from __future__ import absolute_import, unicode_literals

from .. import enum

# special value which is processed by sandbox.common.statistics::Signaler::__loop
ALL_SIGNALS = None


class SignalType(enum.Enum):
    enum.Enum.lower_case()
    enum.Enum.no_underscores()

    API_CALL = None
    API_CALL_CLIENT_SIDE = None
    API_USAGE = None
    CLIENT_INFO = None
    QUOTA_CONSUMPTION = None
    QUOTA_CONSUMPTION_DETAILS = None

    NOTIFICATION = None

    SERVICEQ_CALL = None
    SERVICEQ_COUNTER = None
    SERVICEQ_TASK = None
    SERVICEQ_SYSTEM_RESOURCES = None
    SERVICEQ_REPLICATION_DELAY = None

    TASK_OPERATION = None
    TASK_DISK_USAGE = None
    TEMPLATE_RUN_DELAY = None
    AUDIT = None
    TASK_CREATION = None
    TASK_REJECTION = None
    QUEUE_STATISTICS = None
    EXECUTION_STATISTICS = None
    CLEANER = None
    QUOTA_MEDIAN = None
    BACKUP_RESOURCES = None
    RESOURCE_REGISTRATION = None
    RESOURCE_SYNC = None
    RESOURCES_ON_STORAGES = None
    RESOURCES_SYNC_TO_MDS_DELAY = None
    RESOURCES_REMOVED_FROM_MDS = None
    MDS_BUCKET_INFO = None
    TASK_WAIT_DELAY = None
    EXCEPTION_STATISTICS = None
    TASK_EXCEPTION_STATISTICS = None
    API_QUOTA_CONSUMPTION = None
    SERVICE_STATISTICS = None
    TASK_SESSION_COMPLETION = None  # signal that doesn't have a schema yet, don't touch it
    TASK_INTERVALS = None
    TASK_CPU_USAGE = None
    TASK_RAM_USAGE = None
    TASK_DISK_IO_USAGE = None
    TASK_NETWORK_IO_USAGE = None
    TASK_HARDWARE_METRICS = None
    EMPTY_TASKLET_METRICS = None

    PROXY_API_CALL = None
    PROXY_REQUESTS_DYNAMIC_NETS = None

    MDS_API_CALL = None

    TASKBOX_CALL = None
    TASKBOX_STATISTICS = None
    COREDUMPS = None


class OperationType(enum.Enum):
    enum.Enum.lower_case()
    enum.Enum.preserve_order()

    HG = None
    SVN = None
    REST = None
    AAPI = None
    DOCKER = None


class YTSignalType(enum.Enum):
    enum.Enum.lower_case()
    enum.Enum.no_underscores()

    API_CALL_YT = None
    RESOURCE_AUDIT = None
