# -*- coding: utf-8 -*-

from sandbox.projects import resource_types
from sandbox.projects.BuildKWMQBuild import BuildKWMQBuild
import sandbox.projects.common.build.BuildForAllTask as bfa


class BuildKWMQBuildForAll(bfa.BuildForAllTask):
    type = 'BUILD_KWMQBUILD_FOR_ALL'
    input_parameters = bfa.get_build_for_all_params()
    # TODO(rdna@): Set appropriate release_to.
    release_to = 'rdna@yandex-team.ru'

    # BuildForAllTask fields
    subtask_type = BuildKWMQBuild
    subtask_description = 'Building KWMQBuild for {target}'
    resource_type = resource_types.KWMQBUILD_ARCHIVE
    resource_description = 'KWMQBuild archive for {target}'


__Task__ = BuildKWMQBuildForAll
