# -*- coding: utf-8 -*-

from sandbox.projects import resource_types
from sandbox.projects.common.build.CommonBuildTask import CommonBuildTask
from sandbox.projects.common.nanny import nanny


class BuildNewsGenMongoConf(nanny.ReleaseToNannyTask, CommonBuildTask):
    """
        Build News MongoDb config generator
    """

    type = 'BUILD_NEWS_GEN_MONGO_CONF'

    TARGET_RESOURCES = (
        (resource_types.NEWS_GEN_MONGO_CONF_EXECUTABLE, 'yweb/news/common/python/mongo/tools/gencfg/gen_mongo_conf'),
    )

    def do_execute(self):
        CommonBuildTask.do_execute(self)


__Task__ = BuildNewsGenMongoConf
