# -*- coding: utf-8 -*-

from sandbox.projects import resource_types
from sandbox.projects.common.build.CommonBuildTask import CommonBuildTask
from sandbox.projects.common.nanny import nanny


class BuildNewsGenZkConf(nanny.ReleaseToNannyTask, CommonBuildTask):
    """
        Build News ZooKeeper config generator
    """

    type = 'BUILD_NEWS_GEN_ZK_CONF'

    TARGET_RESOURCES = (
        (resource_types.NEWS_GEN_ZK_CONF_EXECUTABLE, 'yweb/news/common/python/zk/tools/gencfg/gen_zk_conf'),
    )

    def do_execute(self):
        CommonBuildTask.do_execute(self)


__Task__ = BuildNewsGenZkConf
