# coding=utf-8

from sandbox.projects import resource_types
from sandbox.projects.BuildTmux import BuildTmux
from sandbox.projects.common.build.BuildForAllTask import BuildForAllTask, PlatformsListParameter


class BuildTmuxForAll(BuildForAllTask):
    type = 'BUILD_TMUX_FOR_ALL'

    input_parameters = list(BuildTmux.input_parameters) + [PlatformsListParameter]

    subtask_type = BuildTmux
    subtask_description = 'Build Tmux {version} for {target}'
    resource_type = resource_types.TMUX_EXECUTABLE
    resource_description = 'Tmux {version} for {target}'


__Task__ = BuildTmuxForAll
