SVN_DELIM = ','

# All packages from intersection of available in a build task packages and ones
# used in a z2 config.
ALL_POSSIBLE_PACKAGES = '*'


CFG_PROPS = {
        'UKROP_CLIENTS': {
            'items': {
                'svn': [
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/conf/common',
                        '{branch}/arcadia/yweb/robot/ukrop/conf/conf-common={revision}'
                    ]),
                ],
                'pkg': [
                    ALL_POSSIBLE_PACKAGES
                ],
            },
        },

        'UKROP_MASTER': {
            'items': {
                'svn': [
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/conf/specific',
                        '{branch}/arcadia/yweb/robot/ukrop/conf/conf-production={revision}'
                    ]),
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/scripts',
                        '{branch}/arcadia/yweb/robot/ukrop/scripts={revision}'
                    ]),
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/var',
                        '{branch}/arcadia/yweb/robot/ukrop/conf/conf-production/points={revision}'
                    ]),
                    SVN_DELIM.join([
                        '/Berkanavt/webscripts/images/thumbnails',
                        '{branch}/arcadia/yweb/webscripts/images/thumbnails={revision}'
                    ]),
                    SVN_DELIM.join([
                        '/Berkanavt/webscripts/robot-common',
                        '{branch}/arcadia/yweb/webscripts/robot-common={revision}'
                    ]),
                ],
                'pkg': [
                    ALL_POSSIBLE_PACKAGES
                ],
            },
        },

        'UKROP_PRESTABLE': {
            'items': {
                'svn': [
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/conf/common',
                        '{branch}/arcadia/yweb/robot/ukrop/conf/conf-common={revision}'
                    ]),
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/conf/specific',
                        '{branch}/arcadia/yweb/robot/ukrop/conf/conf-production={revision}'
                    ]),
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/scripts',
                        '{branch}/arcadia/yweb/robot/ukrop/scripts={revision}'
                    ]),
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/var',
                        '{branch}/arcadia/yweb/robot/ukrop/conf/conf-production/points={revision}'
                    ]),
                ],
                'pkg': [
                    ALL_POSSIBLE_PACKAGES
                ],
            },
        },

        'UKROP_STG': {
            'items': {
                'svn': [
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/conf/common',
                        '{branch}/arcadia/yweb/robot/ukrop/conf/conf-common={revision}'
                    ]),
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/conf/specific',
                        '{branch}/arcadia/yweb/robot/ukrop/conf/conf-staging={revision}'
                    ]),
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/conf/zones',
                        '{branch}/arcadia/yweb/robot/ukrop/conf/conf-staging/zones={revision}'
                    ]),
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/mnformulas',
                        '{branch}/arcadia/yweb/robot/ukrop/mnformulas={revision}'
                    ]),
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/scripts',
                        '{branch}/arcadia/yweb/robot/ukrop/scripts={revision}'
                    ]),
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/var',
                        '{branch}/arcadia/yweb/robot/ukrop/conf/conf-staging/points={revision}'
                    ]),
                    SVN_DELIM.join([
                        '/Berkanavt/urlrules',
                        '{branch}/arcadia/yweb/urlrules={revision}'
                    ]),
                ],
                'pkg': [
                    ALL_POSSIBLE_PACKAGES
                ],
            },
        },

        'UKROP_PRE_STG': {
            'items': {
                'svn': [
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/conf/common',
                        '{branch}/arcadia/yweb/robot/ukrop/conf/conf-common={revision}'
                    ]),
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/conf/specific',
                        '{branch}/arcadia/yweb/robot/ukrop/conf/conf-prestaging={revision}'
                    ]),
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/conf/zones',
                        '{branch}/arcadia/yweb/robot/ukrop/conf/conf-prestaging/zones={revision}'
                    ]),
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/mnformulas',
                        '{branch}/arcadia/yweb/robot/ukrop/mnformulas={revision}'
                    ]),
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/scripts',
                        '{branch}/arcadia/yweb/robot/ukrop/scripts={revision}'
                    ]),
                    SVN_DELIM.join([
                        '/Berkanavt/fresh/var',
                        '{branch}/arcadia/yweb/robot/ukrop/conf/conf-prestaging/points={revision}'
                    ]),
                    SVN_DELIM.join([
                        '/Berkanavt/urlrules',
                        '{branch}/arcadia/yweb/urlrules={revision}'
                    ]),
                ],
                'pkg': [
                    ALL_POSSIBLE_PACKAGES
                ],
            },
        },
}
