# -*- coding: utf-8 -*-

from sandbox.projects.common.search.components import DefaultThumbDaemonParameters
from sandbox.projects.common.search.components import get_thumb_daemon
from sandbox.projects import resource_types

from sandbox.projects.common.http_responses.BaseLocalResponsesTask import BaseLocalResponsesTask
from sandbox.projects.common.http_responses.BaseLocalResponsesTask import create_parameters


class GetThumbDaemonResponses(BaseLocalResponsesTask):
    type = 'GET_THUMB_DAEMON_RESPONSES'

    input_parameters = DefaultThumbDaemonParameters.params + create_parameters(resource_types.THUMB_DAEMON_REQUESTS,
                                                                               100000)

    def get_responses_resource_type(self):
        return resource_types.THUMB_DAEMON_RESPONSES_ARCHIVE

    def get_component(self):
        return get_thumb_daemon()


__Task__ = GetThumbDaemonResponses
