# -*- coding: utf-8 -*-

from sandbox import sdk2
import sandbox.projects.resource_types.releasers as resource_releasers


class VideoIndexKnnCkmeansModel(sdk2.Resource):
    releasable = True
    releasers = list(set(resource_releasers.video_robot_releasers + resource_releasers.video))


class VideoBuildIndexKnnCkmeansModel(sdk2.Task):
    '''Export CKmeans model for indexknn'''

    def get_model_path(self):
        return "arc/trunk/data/video/nn_models/related/indexknn.ckmeans"

    def export_configs(self, path):
        model_path = self.get_model_path()
        sdk2.svn.Arcadia.export("arcadia:/{}".format(model_path), str(path))

    def on_execute(self):
        resource = sdk2.ResourceData(VideoIndexKnnCkmeansModel(
            self, "Ckmeans model for indexknn", "indexknn.ckmeans"))

        self.export_configs(resource.path)

        resource.ready()
