from sandbox.projects.resource_types import AbstractResource
from sandbox.projects.yabs.qa.task_factory.simple_shoot_task import factory as simple_shoot_task_factory
from sandbox.projects.YabsLmService.modules.sut.adapters.sandbox import LmServiceSUTSandboxAdapter
from sandbox.projects.yabs.qa.dolbilo_module.simple.adapters.sandbox import DolbiloModuleSandboxAdapter
from sandbox.projects.yabs.qa.yt_uploader_module.adapters.sandbox import ShootResultsYtUploaderGenericSandboxAdapter
from sandbox.projects.yabs.qa.ammo_module.requestlog.adapters.general.sandbox import AmmoRequestlogModuleGeneralSandboxAdapter
from sandbox.common.types import resource as ctr


class YabsLmServiceResponseDump(AbstractResource):
    restart_policy = ctr.RestartPolicy.DELETE


simple_shoot_task = simple_shoot_task_factory(
    LmServiceSUTSandboxAdapter,
    AmmoRequestlogModuleGeneralSandboxAdapter,
    DolbiloModuleSandboxAdapter,
    YabsLmServiceResponseDump,
    'YABS_LMSERVICE',
    ShootResultsYtUploaderGenericSandboxAdapter
)


class YabsLmServiceShootTask(simple_shoot_task):
    class Parameters(simple_shoot_task.Parameters):
        kill_timeout = 60 * 30
