# -*- coding: utf-8 -*-

TABLE_SCHEMA = {
    'Banner130': {
        'key_columns': [
            'BannerID',
            'OrderID',
            'ParentExportID',
            'BannerHash',
            'ExportID',
            'ContextID',
            'GroupExportID',
            'PlaceID',
        ],
        'value_columns': [
            'UpdateTime',
            'BannerType',
            'Flags',
            'BannerWeight',
            'DomainID',
            'ContextPriority',
            'EngineID',
            'FlatProbability',
            'TargetDomainID',
            'CounterType',
            'Lang',
            'Options',
            'DynamicBannerID',
            'TemplateID',
            'BannerPriority',
            'ResourceFlags',
        ],
    },
    'AutoBudgetOrder': {
        'key_columns': [
            'OrderID',
        ],
        'value_columns': [
            'LimitDayMoney',
            'StopDays',
            'LimitDayMoneyCur',
            'ROILevel',
            'AvgCPM',
            'AvgCost',
            'AvgCostCur',
            'PeriodBudgetFinish',
            'Easy',
            'AvgCPA',
            'ContextLimit',
            'Profitability',
            'Options',
            'AvgCPMCur',
            'WeekStartTime',
            'GoalExpression',
            'FirstStartTime',
            'LimitWeekClicks',
            'GenerateBids',
            'Testing',
            'RegularSpent',
            'ReserveReturn',
            'Type',
            'StartTime',
            'LimitWeekCur',
            'DayWeight',
            'LimitWeek',
            'BidCoef',
            'MaxCostCur',
            'TransportDelayed',
            'MaxCost',
            'OptimizeType',
            'MaxCPMCur',
            'AvgCPACur',
            'AuctionProbability',
            'Problems',
            'MaxCPM',
            'PeriodBudgetLimit',
            'ChosenStrategy',
            'GoalID',
            'PeriodBudgetLimitCur',
        ],
    },
    'OrderInfo': {
        'key_columns': [
            'OrderID',
            'AgencyID',
            'GroupOrderID',
            'ManagerID',
            'ClientID',
            'EngineID',
            'BaseNo',
            'Complete',
            'Exported',
        ],
        'value_columns': [
            'CheckStopTime',
            'Discount',
            'PriceType',
            'AttributionType',
            'CostPcs',
            'CurrencyID',
            'MaxClicks',
            'LimitCoef',
            'CounterType',
            'UserID',
            'MaxCPCCur',
            'MaxShows',
            'Options',
            'AvgDiscount',
            'ContextPriceCoef',
            'ProductID',
            'OrderTime',
            'ContextID',
            'ReservedTime',
            'LimitOld',
            'ContentType',
            'EditTime',
            'BroadmatchPriceCoef',
            'UpdateTime',
            'HolidayRegionID',
            'LimitNew',
            'MCost',
            'KeepActive',
            'RFDecay',
            'RFDays',
            'StartTime',
            'Cost',
            'StopTime',
            'MaxCostCur',
            'BillingState',
            'RFCPMThreshold',
            'ExportID',
            'State',
            'AutoStop',
            'TimeZoneID',
            'MinTrustLevel',
            'RFMinCPM',
            'CounterID',
            'OrderResourceID',
            'LimitCur',
            'MaxRF',
            'Price',
            'Days',
            'CurrencyDate',
            'StrategyMinPrice',
            'MaxCPC',
            'TaxID',
            'Quantity',
            'OrderType',
            'DiscountID',
            'PicturePriceCoef',
            'TaxesIncluded',
            'AgencyCoef',
        ],
    },
    'Banner127': {
        'key_columns': [
            'BannerID',
            'OrderID',
            'ParentExportID',
            'BannerHash',
            'ExportID',
            'ContextID',
            'GroupExportID',
            'PlaceID',
        ],
        'value_columns': [
            'UpdateTime',
            'BannerType',
            'Flags',
            'BannerWeight',
            'DomainID',
            'ContextPriority',
            'EngineID',
            'FlatProbability',
            'TargetDomainID',
            'CounterType',
            'Lang',
            'Options',
            'DynamicBannerID',
            'TemplateID',
            'BannerPriority',
            'ResourceFlags',
        ],
    },
    'BroadmatchLimits': {
        'key_columns': [
            'OrderID',
        ],
        'value_columns': [
            'AutoBudgetCost',
            'MinShows',
            'Clicks',
            'AutoBudgetMinCost',
            'MinClicks',
            'CostUpdateTime',
            'Cost',
            'MinCost',
            'CPARate',
            'UnitedLimit',
            'Shows',
        ],
    },
    'Banner138': {
        'key_columns': [
            'BannerID',
            'OrderID',
            'ParentExportID',
            'BannerHash',
            'ExportID',
            'ContextID',
            'GroupExportID',
            'PlaceID',
        ],
        'value_columns': [
            'UpdateTime',
            'BannerType',
            'Flags',
            'BannerWeight',
            'DomainID',
            'ContextPriority',
            'EngineID',
            'FlatProbability',
            'TargetDomainID',
            'CounterType',
            'Lang',
            'Options',
            'DynamicBannerID',
            'TemplateID',
            'BannerPriority',
            'ResourceFlags',
        ],
    },
    'PhrasePrice': {
        'key_columns': [
            'GroupExportID',
            'OrderID',
            'ContextType',
            'EngineID',
            'PhraseID',
        ],
        'value_columns': [
            'FlatCost',
            'OptionOnlyNewAuditoryUpdateTime',
            'AvgCost',
            'Hits',
            'CostUpdateTime',
            'OptionOnlyOfferRetargetingUpdateTime',
            'Cost',
            'AvgCPA',
            'Options',
            'OptionDeletedUpdateTime',
            'OptionGoalContextUpdateTime',
            'HitsUpdateTime',
            'OptionAutobrokerCurrencyUpdateTime',
            'PCTR0',
            'ResultFlatCost',
            'FlatCostUpdateTime',
            'ResultCost',
            'AvgCPAUpdateTime',
            'AvgCostUpdateTime',
        ],
    },
    'Banner11': {
        'key_columns': [
            'BannerID',
            'OrderID',
            'ParentExportID',
            'BannerHash',
            'ExportID',
            'ContextID',
            'GroupExportID',
            'PlaceID',
        ],
        'value_columns': [
            'UpdateTime',
            'BannerType',
            'Flags',
            'BannerWeight',
            'DomainID',
            'ContextPriority',
            'EngineID',
            'FlatProbability',
            'TargetDomainID',
            'CounterType',
            'Lang',
            'Options',
            'DynamicBannerID',
            'TemplateID',
            'BannerPriority',
            'ResourceFlags',
        ],
    },
}
