PY2_LIBRARY()

OWNER(
    g:broautotests
)

PY_SRCS(
    autoduty/templates/__init__.py
    autoduty/__init__.py
    autoduty/failures_analyzer.py
    autoduty/flaky_analyzer.py
    autoduty/issue.py

    regression_manager/__init__.py
    regression_manager/alicekit.py
    regression_manager/android.py
    regression_manager/common.py
    regression_manager/common_desktop.py
    regression_manager/common_mobile.py
    regression_manager/desktop.py
    regression_manager/distribution_desktop.py
    regression_manager/ios.py
    regression_manager/searchapp_ios.py
    regression_manager/searchapp_android.py
    regression_manager/webntp_desktop.py

    regression_manager_templates/dbro_regression/__init__.py
    regression_manager_templates/distr_dbro_regressoin/__init__.py
    regression_manager_templates/mobile_regression/__init__.py
    regression_manager_templates/webntp_dbro_regressoin/__init__.py

    functionalities/__init__.py

    group_regression_manager/__init__.py
    group_regression_manager/alicekit.py
    group_regression_manager/android.py
    group_regression_manager/common.py
    group_regression_manager/common_desktop.py
    group_regression_manager/common_mobile.py
    group_regression_manager/desktop.py
    group_regression_manager/distribution_desktop.py
    group_regression_manager/ios.py
    group_regression_manager/searchapp_ios.py
    group_regression_manager/searchapp_android.py
    group_regression_manager/webntp_desktop.py

    __init__.py
    allure_parser.py
    assessors.py
    autotests_bundle.py
    autotests_result.py
    btr_log_parser.py
    diff_tickets.py
    frozendict.py
    hitman_client.py
    jns_client.py
    regression_report.py
    test_statuses.py
    testcases_analyst.py
    testing_builds.py
    testing_groups.py
    testing_job.py
    testing_platforms.py
    testpalm_helper.py
    ya_booking.py
    ya_clients.py
)

PEERDIR(
    contrib/python/PyYAML
    contrib/python/Jinja2
    sandbox/projects/common
    sandbox/projects/browser/common
    sandbox/projects/browser/autotests_qa_tools/common
    sandbox/projects/browser/autotests_qa_tools/configs
)

RESOURCE(
    regression_manager_templates/dbro_regression/assessors_ticket.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/dbro_regression/assessors_ticket.jinja
    regression_manager_templates/dbro_regression/builds_diff_issues.html sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/dbro_regression/builds_diff_issues.html
    regression_manager_templates/dbro_regression/group_builds_diff_issues_startrek.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/dbro_regression/group_builds_diff_issues_startrek.jinja
    regression_manager_templates/dbro_regression/group_issue_autotests_results.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/dbro_regression/group_issue_autotests_results.jinja
    regression_manager_templates/dbro_regression/group_issue_autotests_work.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/dbro_regression/group_issue_autotests_work.jinja
    regression_manager_templates/dbro_regression/group_issue_human_work.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/dbro_regression/group_issue_human_work.jinja
    regression_manager_templates/dbro_regression/group_ticket.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/dbro_regression/group_ticket.jinja
    regression_manager_templates/dbro_regression/main_ticket.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/dbro_regression/main_ticket.jinja

    regression_manager_templates/distr_dbro_regressoin/assessors_ticket.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/distr_dbro_regressoin/assessors_ticket.jinja
    regression_manager_templates/distr_dbro_regressoin/group_ticket.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/distr_dbro_regressoin/group_ticket.jinja
    regression_manager_templates/distr_dbro_regressoin/group_issue_human_work.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/distr_dbro_regressoin/group_issue_human_work.jinja
    regression_manager_templates/distr_dbro_regressoin/group_issue_autotests_work.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/distr_dbro_regressoin/group_issue_autotests_work.jinja

    regression_manager_templates/mobile_regression/assessors_ticket.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/mobile_regression/assessors_ticket.jinja
    regression_manager_templates/mobile_regression/group_ticket.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/mobile_regression/group_ticket.jinja
    regression_manager_templates/mobile_regression/group_issue_human_work.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/mobile_regression/group_issue_human_work.jinja
    regression_manager_templates/mobile_regression/main_ticket.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/mobile_regression/main_ticket.jinja
    regression_manager_templates/mobile_regression/group_issue_autotests_work.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/mobile_regression/group_issue_autotests_work.jinja
    regression_manager_templates/mobile_regression/group_issue_autotests_results.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/mobile_regression/group_issue_autotests_results.jinja

    regression_manager_templates/webntp_dbro_regressoin/assessors_ticket.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/webntp_dbro_regressoin/assessors_ticket.jinja
    regression_manager_templates/webntp_dbro_regressoin/group_ticket.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/webntp_dbro_regressoin/group_ticket.jinja
    regression_manager_templates/webntp_dbro_regressoin/group_issue_human_work.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/webntp_dbro_regressoin/group_issue_human_work.jinja
    regression_manager_templates/webntp_dbro_regressoin/group_issue_autotests_work.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/webntp_dbro_regressoin/group_issue_autotests_work.jinja
    regression_manager_templates/webntp_dbro_regressoin/group_builds_diff_issues_startrek.jinja sandbox/projects/browser/autotests_qa_tools/classes/regression_manager_templates/webntp_dbro_regressoin/group_builds_diff_issues_startrek.jinja

    autoduty/templates/binary_tests_failed_issue.jinga sandbox/projects/browser/autotests_qa_tools/classes/autoduty/templates/binary_tests_failed_issue.jinga
    autoduty/templates/issue_draft_head.jinja sandbox/projects/browser/autotests_qa_tools/classes/autoduty/templates/issue_draft_head.jinja
    autoduty/templates/python_tests_issue.jinga sandbox/projects/browser/autotests_qa_tools/classes/autoduty/templates/python_tests_issue.jinga
    autoduty/templates/python_legacy_tests_issue.jinga sandbox/projects/browser/autotests_qa_tools/classes/autoduty/templates/python_legacy_tests_issue.jinga
    autoduty/templates/mobile_tests_failed_issue.jinga sandbox/projects/browser/autotests_qa_tools/classes/autoduty/templates/mobile_tests_failed_issue.jinga
)

END()

RECURSE(
    functionalities/tests
)
