#!/usr/bin/env python
# coding: utf-8

import urllib


def get_qtreedbg_sample_value():
    return urllib.quote(_qtree_sample)


_qtree_sample = '''
{
    "Base": {
        "OpInfo": {
            "Lo": -7,
            "Hi": 7,
            "Level": 1,
            "Arrange": false,
            "TextOp": "oAnd",
            "TextCmpOper": "cmpEQ"
        },
        "Name": "",
        "TextAfter": "",
        "TextBefore": "",
        "AttrValue": "",
        "AttrValueHi": "",
        "TokSpan": {
            "Len": 0,
            "Pos": 0,
            "SuffixLen": 0,
            "Type": 0,
            "TokenDelim": 0
        },
        "Quoted": false,
        "Softness": 6,
        "ReverseFreq": -1,
        "TextPhraseType": "PHRASE_SYNTAX",
        "TextLastPhraseType": "PHRASE_SYNTAX",
        "TextNecessity": "nDEFAULT",
        "KeyPrefix": 0,
        "TextName": "",
        "Text": ""
    },
    "Children": [
        {
            "Base": {
                "OpInfo": {
                    "Lo": 0,
                    "Hi": 0,
                    "Level": 0,
                    "Arrange": false,
                    "TextOp": "oWord",
                    "TextCmpOper": "cmpEQ"
                },
                "Name": "сбербанк",
                "TextAfter": " ",
                "TextBefore": "",
                "AttrValue": "",
                "AttrValueHi": "",
                "TokSpan": {
                    "Len": 8,
                    "Pos": 0,
                    "SuffixLen": 0,
                    "Type": 0,
                    "TokenDelim": 0
                },
                "Quoted": false,
                "ReverseFreq": 56321,
                "TextPhraseType": "PHRASE_NONE",
                "TextLastPhraseType": "PHRASE_NONE",
                "TextNecessity": "nDEFAULT",
                "KeyPrefix": 0,
                "TextName": "",
                "Text": "сбербанк"
            },
            "SubExpr": 0,
            "HiliteType": 1,
            "WordInfo": {
                "NlpType": 1,
                "FormType": 0,
                "Form": "сбербанк",
                "Attr": "",
                "RevFr": 56321,
                "FormRevFr": -1,
                "Idf": -1,
                "TermFreq": 13546,
                "LangMask": 2,
                "CaseFlags": 291,
                "StopWord": false,
                "Stickiness": 0,
                "TokenCount": 1,
                "Lemmas": [
                    {
                        "Lemma": "сбербанк",
                        "Best": true,
                        "Bastard": false,
                        "StopWord": false,
                        "Stickiness": 0,
                        "Grammar": "S,муж,неод(им,ед|вин,ед)",
                        "Forms": [
                            {
                                "Form": "сбербанк",
                                "Weight": 0,
                                "Mode": 19
                            },
                            {
                                "Form": "сбербанка",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "сбербанкам",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "сбербанками",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "сбербанках",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "сбербанке",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "сбербанки",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "сбербанков",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "сбербанком",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "сбербанку",
                                "Weight": 0,
                                "Mode": 3
                            }
                        ],
                        "Quality": 0,
                        "TextLanguage": "rus"
                    },
                    {
                        "Lemma": "сбербанк",
                        "Best": false,
                        "Bastard": true,
                        "StopWord": false,
                        "Stickiness": 0,
                        "Grammar": "",
                        "Forms": [
                            {
                                "Form": "сбербанк",
                                "Weight": 0,
                                "Mode": 19
                            }
                        ],
                        "Quality": 1,
                        "TextLanguage": "unk"
                    }
                ],
                "Languages": {
                    "Names": "rus"
                }
            },
            "ExtensionType": 0,
            "ExtensionRelev": 1
        },
        {
            "Base": {
                "OpInfo": {
                    "Lo": 0,
                    "Hi": 0,
                    "Level": 0,
                    "Arrange": false,
                    "TextOp": "oWord",
                    "TextCmpOper": "cmpEQ"
                },
                "Name": "россии",
                "TextAfter": " ",
                "TextBefore": " ",
                "AttrValue": "",
                "AttrValueHi": "",
                "TokSpan": {
                    "Len": 6,
                    "Pos": 0,
                    "SuffixLen": 0,
                    "Type": 0,
                    "TokenDelim": 0
                },
                "Quoted": false,
                "ReverseFreq": 908,
                "TextPhraseType": "PHRASE_NONE",
                "TextLastPhraseType": "PHRASE_NONE",
                "TextNecessity": "nDEFAULT",
                "KeyPrefix": 0,
                "TextName": "",
                "Text": "россии"
            },
            "SubExpr": 0,
            "HiliteType": 1,
            "WordInfo": {
                "NlpType": 1,
                "FormType": 0,
                "Form": "россии",
                "Attr": "",
                "RevFr": 908,
                "FormRevFr": -1,
                "Idf": -1,
                "TermFreq": 840085,
                "LangMask": 2,
                "CaseFlags": 291,
                "StopWord": false,
                "Stickiness": 0,
                "TokenCount": 1,
                "Lemmas": [
                    {
                        "Lemma": "россии",
                        "Best": false,
                        "Bastard": true,
                        "StopWord": false,
                        "Stickiness": 0,
                        "Grammar": "",
                        "Forms": [
                            {
                                "Form": "россии",
                                "Weight": 0,
                                "Mode": 19
                            }
                        ],
                        "Quality": 8,
                        "TextLanguage": "unk"
                    },
                    {
                        "Lemma": "россия",
                        "Best": true,
                        "Bastard": false,
                        "StopWord": false,
                        "Stickiness": 0,
                        "Grammar": "S,гео,жен,неод(им,мн|род,ед|дат,ед|вин,мн|пр,ед)",
                        "Forms": [
                            {
                                "Form": "россией",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "россиею",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "россии",
                                "Weight": 0,
                                "Mode": 19
                            },
                            {
                                "Form": "россий",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "россию",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "россия",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "россиям",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "россиями",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "россиях",
                                "Weight": 0,
                                "Mode": 3
                            }
                        ],
                        "Quality": 0,
                        "TextLanguage": "rus"
                    }
                ],
                "Languages": {
                    "Names": "rus"
                }
            },
            "ExtensionType": 0,
            "ExtensionRelev": 1
        },
        {
            "Base": {
                "OpInfo": {
                    "Lo": 0,
                    "Hi": 0,
                    "Level": 0,
                    "Arrange": false,
                    "TextOp": "oWord",
                    "TextCmpOper": "cmpEQ"
                },
                "Name": "официальный",
                "TextAfter": " ",
                "TextBefore": " ",
                "AttrValue": "",
                "AttrValueHi": "",
                "TokSpan": {
                    "Len": 11,
                    "Pos": 0,
                    "SuffixLen": 0,
                    "Type": 0,
                    "TokenDelim": 0
                },
                "Quoted": false,
                "ReverseFreq": 6305,
                "TextPhraseType": "PHRASE_NONE",
                "TextLastPhraseType": "PHRASE_NONE",
                "TextNecessity": "nDEFAULT",
                "KeyPrefix": 0,
                "TextName": "",
                "Text": "официальный"
            },
            "SubExpr": 0,
            "HiliteType": 1,
            "WordInfo": {
                "NlpType": 1,
                "FormType": 0,
                "Form": "официальный",
                "Attr": "",
                "RevFr": 6305,
                "FormRevFr": -1,
                "Idf": -1,
                "TermFreq": 120987,
                "LangMask": 2,
                "CaseFlags": 291,
                "StopWord": false,
                "Stickiness": 0,
                "TokenCount": 1,
                "Lemmas": [
                    {
                        "Lemma": "официальный",
                        "Best": true,
                        "Bastard": false,
                        "StopWord": false,
                        "Stickiness": 0,
                        "Grammar": "A(им,ед,полн,муж|вин,ед,полн,муж,неод)",
                        "Forms": [
                            {
                                "Form": "официален",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальна",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальнаго",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальная",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальнее",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальней",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальнейшаго",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальнейшая",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальнейшего",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальнейшее",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальнейшей",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальнейшем",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальнейшему",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальнейшею",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальнейшие",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальнейший",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальнейшим",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальнейшими",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальнейших",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальнейшия",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальнейшую",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официально",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официального",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальное",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальной",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальном",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальному",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальною",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальную",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальны",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальные",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальный",
                                "Weight": 0,
                                "Mode": 19
                            },
                            {
                                "Form": "официальным",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальными",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальных",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "официальныя",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "поофициальнее",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "поофициальней",
                                "Weight": 0,
                                "Mode": 3
                            }
                        ],
                        "Quality": 0,
                        "TextLanguage": "rus"
                    },
                    {
                        "Lemma": "официальный",
                        "Best": false,
                        "Bastard": true,
                        "StopWord": false,
                        "Stickiness": 0,
                        "Grammar": "",
                        "Forms": [
                            {
                                "Form": "официальный",
                                "Weight": 0,
                                "Mode": 19
                            }
                        ],
                        "Quality": 1,
                        "TextLanguage": "unk"
                    }
                ],
                "Languages": {
                    "Names": "rus"
                }
            },
            "ExtensionType": 0,
            "ExtensionRelev": 1
        },
        {
            "Base": {
                "OpInfo": {
                    "Lo": 0,
                    "Hi": 0,
                    "Level": 0,
                    "Arrange": false,
                    "TextOp": "oWord",
                    "TextCmpOper": "cmpEQ"
                },
                "Name": "сайт",
                "TextAfter": " ",
                "TextBefore": " ",
                "AttrValue": "",
                "AttrValueHi": "",
                "TokSpan": {
                    "Len": 4,
                    "Pos": 0,
                    "SuffixLen": 0,
                    "Type": 0,
                    "TokenDelim": 0
                },
                "Quoted": false,
                "ReverseFreq": 507,
                "TextPhraseType": "PHRASE_NONE",
                "TextLastPhraseType": "PHRASE_NONE",
                "TextNecessity": "nDEFAULT",
                "KeyPrefix": 0,
                "TextName": "",
                "Text": "сайт"
            },
            "SubExpr": 0,
            "HiliteType": 1,
            "WordInfo": {
                "NlpType": 1,
                "FormType": 0,
                "Form": "сайт",
                "Attr": "",
                "RevFr": 507,
                "FormRevFr": -1,
                "Idf": -1,
                "TermFreq": 1501986,
                "LangMask": 2,
                "CaseFlags": 291,
                "StopWord": false,
                "Stickiness": 0,
                "TokenCount": 1,
                "Lemmas": [
                    {
                        "Lemma": "сайт",
                        "Best": true,
                        "Bastard": false,
                        "StopWord": false,
                        "Stickiness": 0,
                        "Grammar": "S,муж,неод(им,ед|вин,ед)",
                        "Forms": [
                            {
                                "Form": "сайт",
                                "Weight": 0,
                                "Mode": 19
                            },
                            {
                                "Form": "сайта",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "сайтам",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "сайтами",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "сайтах",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "сайте",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "сайтов",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "сайтом",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "сайту",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "сайты",
                                "Weight": 0,
                                "Mode": 3
                            }
                        ],
                        "Quality": 0,
                        "TextLanguage": "rus"
                    },
                    {
                        "Lemma": "сайт",
                        "Best": false,
                        "Bastard": false,
                        "StopWord": false,
                        "Stickiness": 0,
                        "Grammar": "",
                        "Forms": [
                            {
                                "Form": "сайт",
                                "Weight": 0,
                                "Mode": 19
                            }
                        ],
                        "Quality": 0,
                        "TextLanguage": "unk"
                    }
                ],
                "Languages": {
                    "Names": "rus"
                }
            },
            "ExtensionType": 0,
            "ExtensionRelev": 1
        },
        {
            "Base": {
                "OpInfo": {
                    "Lo": 0,
                    "Hi": 0,
                    "Level": 0,
                    "Arrange": false,
                    "TextOp": "oWord",
                    "TextCmpOper": "cmpEQ"
                },
                "Name": "карелии",
                "TextAfter": " softness:6",
                "TextBefore": " ",
                "AttrValue": "",
                "AttrValueHi": "",
                "TokSpan": {
                    "Len": 7,
                    "Pos": 0,
                    "SuffixLen": 0,
                    "Type": 0,
                    "TokenDelim": 0
                },
                "Quoted": false,
                "ReverseFreq": 61536,
                "TextPhraseType": "PHRASE_REGION",
                "TextLastPhraseType": "PHRASE_REGION",
                "TextNecessity": "nDEFAULT",
                "KeyPrefix": 0,
                "TextName": "",
                "Text": "карелии"
            },
            "SubExpr": 0,
            "HiliteType": 1,
            "WordInfo": {
                "NlpType": 1,
                "FormType": 0,
                "Form": "карелии",
                "Attr": "",
                "RevFr": 61536,
                "FormRevFr": -1,
                "Idf": -1,
                "TermFreq": 12398,
                "LangMask": 2,
                "CaseFlags": 291,
                "StopWord": false,
                "Stickiness": 0,
                "TokenCount": 1,
                "Lemmas": [
                    {
                        "Lemma": "карелии",
                        "Best": false,
                        "Bastard": true,
                        "StopWord": false,
                        "Stickiness": 0,
                        "Grammar": "",
                        "Forms": [
                            {
                                "Form": "карелии",
                                "Weight": 0,
                                "Mode": 19
                            }
                        ],
                        "Quality": 8,
                        "TextLanguage": "unk"
                    },
                    {
                        "Lemma": "карелия",
                        "Best": true,
                        "Bastard": false,
                        "StopWord": false,
                        "Stickiness": 0,
                        "Grammar": "S,гео,жен,неод(им,мн|род,ед|дат,ед|вин,мн|пр,ед)",
                        "Forms": [
                            {
                                "Form": "карелией",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "карелиею",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "карелии",
                                "Weight": 0,
                                "Mode": 19
                            },
                            {
                                "Form": "карелий",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "карелию",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "карелия",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "карелиям",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "карелиями",
                                "Weight": 0,
                                "Mode": 3
                            },
                            {
                                "Form": "карелиях",
                                "Weight": 0,
                                "Mode": 3
                            }
                        ],
                        "Quality": 0,
                        "TextLanguage": "rus"
                    }
                ],
                "Languages": {
                    "Names": "rus"
                }
            },
            "ExtensionType": 0,
            "ExtensionRelev": 1
        }
    ],
    "Proxes": [
        {
            "Begin": -3,
            "End": 5,
            "Center": 1,
            "Level": 4,
            "ConvertedBounds": false,
            "TextDistanceType": "DT_SYNTAX"
        },
        {
            "Begin": -3,
            "End": 5,
            "Center": 1,
            "Level": 4,
            "ConvertedBounds": false,
            "TextDistanceType": "DT_SYNTAX"
        },
        {
            "Begin": -3,
            "End": 5,
            "Center": 1,
            "Level": 4,
            "ConvertedBounds": false,
            "TextDistanceType": "DT_SYNTAX"
        },
        {
            "Begin": -3,
            "End": 5,
            "Center": 1,
            "Level": 4,
            "ConvertedBounds": false,
            "TextDistanceType": "DT_SYNTAX"
        }
    ],
    "SubExpr": 0,
    "HiliteType": 1,
    "ExtensionType": 0,
    "ExtensionRelev": 1,
    "Synonyms": [
        {
            "Type": 8,
            "Relev": 0,
            "SubTree": {
                "Base": {
                    "OpInfo": {
                        "Lo": 0,
                        "Hi": 0,
                        "Level": 0,
                        "Arrange": false,
                        "TextOp": "oWord",
                        "TextCmpOper": "cmpEQ"
                    },
                    "Name": "sberbank",
                    "TextAfter": ")",
                    "TextBefore": "(",
                    "AttrValue": "",
                    "AttrValueHi": "",
                    "TokSpan": {
                        "Len": 8,
                        "Pos": 0,
                        "SuffixLen": 0,
                        "Type": 0,
                        "TokenDelim": 0
                    },
                    "Quoted": false,
                    "ReverseFreq": 5154937,
                    "TextPhraseType": "PHRASE_NONE",
                    "TextLastPhraseType": "PHRASE_NONE",
                    "TextNecessity": "nDEFAULT",
                    "KeyPrefix": 0,
                    "TextName": "",
                    "Text": "sberbank"
                },
                "SubExpr": 0,
                "HiliteType": 1,
                "WordInfo": {
                    "NlpType": 1,
                    "FormType": 0,
                    "Form": "sberbank",
                    "Attr": "",
                    "RevFr": -1,
                    "FormRevFr": -1,
                    "Idf": -1,
                    "TermFreq": 0,
                    "LangMask": 1,
                    "CaseFlags": 275,
                    "StopWord": false,
                    "Stickiness": 0,
                    "TokenCount": 1,
                    "Lemmas": [
                        {
                            "Lemma": "sberbank",
                            "Best": false,
                            "Bastard": true,
                            "StopWord": false,
                            "Stickiness": 0,
                            "Grammar": "A()",
                            "Forms": [
                                {
                                    "Form": "sberbank",
                                    "Weight": 0,
                                    "Mode": 19
                                }
                            ],
                            "Quality": 1,
                            "TextLanguage": "eng"
                        }
                    ],
                    "Languages": {
                        "Names": "eng"
                    }
                },
                "ExtensionType": 8,
                "ExtensionRelev": 0.5
            },
            "Range": {
                "Begin": 0,
                "End": 0
            }
        },
        {
            "Type": 16,
            "Relev": 0,
            "SubTree": {
                "Base": {
                    "OpInfo": {
                        "Lo": 1,
                        "Hi": 1,
                        "Level": 0,
                        "Arrange": false,
                        "TextOp": "oAnd",
                        "TextCmpOper": "cmpEQ"
                    },
                    "Name": "сбер-банк",
                    "TextAfter": ")",
                    "TextBefore": "(",
                    "AttrValue": "",
                    "AttrValueHi": "",
                    "TokSpan": {
                        "Len": 9,
                        "Pos": 0,
                        "SuffixLen": 0,
                        "Type": 0,
                        "TokenDelim": 0
                    },
                    "Quoted": false,
                    "ReverseFreq": -1,
                    "TextPhraseType": "PHRASE_MULTIWORD",
                    "TextLastPhraseType": "PHRASE_MULTIWORD",
                    "TextNecessity": "nDEFAULT",
                    "KeyPrefix": 0,
                    "TextName": "",
                    "Text": "сбер-банк"
                },
                "Children": [
                    {
                        "Base": {
                            "OpInfo": {
                                "Lo": 0,
                                "Hi": 0,
                                "Level": 0,
                                "Arrange": false,
                                "TextOp": "oWord",
                                "TextCmpOper": "cmpEQ"
                            },
                            "Name": "сбер",
                            "TextAfter": "-",
                            "TextBefore": "(",
                            "AttrValue": "",
                            "AttrValueHi": "",
                            "TokSpan": {
                                "Len": 4,
                                "Pos": 0,
                                "SuffixLen": 0,
                                "Type": 0,
                                "TokenDelim": 0
                            },
                            "Quoted": false,
                            "ReverseFreq": 999909,
                            "TextPhraseType": "PHRASE_NONE",
                            "TextLastPhraseType": "PHRASE_NONE",
                            "TextNecessity": "nDEFAULT",
                            "KeyPrefix": 0,
                            "TextName": "",
                            "Text": "сбер"
                        },
                        "SubExpr": 0,
                        "HiliteType": 1,
                        "WordInfo": {
                            "NlpType": 1,
                            "FormType": 0,
                            "Form": "сбер",
                            "Attr": "",
                            "RevFr": -1,
                            "FormRevFr": -1,
                            "Idf": -1,
                            "TermFreq": 0,
                            "LangMask": 2,
                            "CaseFlags": 291,
                            "StopWord": false,
                            "Stickiness": 0,
                            "TokenCount": 1,
                            "Lemmas": [
                                {
                                    "Lemma": "сбер",
                                    "Best": false,
                                    "Bastard": true,
                                    "StopWord": false,
                                    "Stickiness": 0,
                                    "Grammar": "S,муж,неод(им,ед|вин,ед)",
                                    "Forms": [
                                        {
                                            "Form": "сбер",
                                            "Weight": 0,
                                            "Mode": 19
                                        },
                                        {
                                            "Form": "сбера",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "сберам",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "сберами",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "сберах",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "сбере",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "сберов",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "сбером",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "сберу",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "сберы",
                                            "Weight": 0,
                                            "Mode": 3
                                        }
                                    ],
                                    "Quality": 2,
                                    "TextLanguage": "rus"
                                }
                            ],
                            "Languages": {
                                "Names": "rus"
                            }
                        },
                        "ExtensionType": 0,
                        "ExtensionRelev": 1
                    },
                    {
                        "Base": {
                            "OpInfo": {
                                "Lo": 0,
                                "Hi": 0,
                                "Level": 0,
                                "Arrange": false,
                                "TextOp": "oWord",
                                "TextCmpOper": "cmpEQ"
                            },
                            "Name": "банк",
                            "TextAfter": ")",
                            "TextBefore": "-",
                            "AttrValue": "",
                            "AttrValueHi": "",
                            "TokSpan": {
                                "Len": 4,
                                "Pos": 0,
                                "SuffixLen": 0,
                                "Type": 0,
                                "TokenDelim": 0
                            },
                            "Quoted": false,
                            "ReverseFreq": 3776,
                            "TextPhraseType": "PHRASE_NONE",
                            "TextLastPhraseType": "PHRASE_NONE",
                            "TextNecessity": "nDEFAULT",
                            "KeyPrefix": 0,
                            "TextName": "",
                            "Text": "банк"
                        },
                        "SubExpr": 0,
                        "HiliteType": 1,
                        "WordInfo": {
                            "NlpType": 1,
                            "FormType": 0,
                            "Form": "банк",
                            "Attr": "",
                            "RevFr": -1,
                            "FormRevFr": -1,
                            "Idf": -1,
                            "TermFreq": 0,
                            "LangMask": 2,
                            "CaseFlags": 291,
                            "StopWord": false,
                            "Stickiness": 0,
                            "TokenCount": 1,
                            "Lemmas": [
                                {
                                    "Lemma": "банк",
                                    "Best": false,
                                    "Bastard": false,
                                    "StopWord": false,
                                    "Stickiness": 0,
                                    "Grammar": "S,муж,неод(им,ед|вин,ед)",
                                    "Forms": [
                                        {
                                            "Form": "банк",
                                            "Weight": 0,
                                            "Mode": 19
                                        },
                                        {
                                            "Form": "банка",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "банкам",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "банками",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "банках",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "банке",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "банки",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "банков",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "банком",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "банку",
                                            "Weight": 0,
                                            "Mode": 3
                                        }
                                    ],
                                    "Quality": 0,
                                    "TextLanguage": "rus"
                                }
                            ],
                            "Languages": {
                                "Names": "rus"
                            }
                        },
                        "ExtensionType": 0,
                        "ExtensionRelev": 1
                    }
                ],
                "Proxes": [
                    {
                        "Begin": 1,
                        "End": 1,
                        "Center": 1,
                        "Level": 3,
                        "ConvertedBounds": false,
                        "TextDistanceType": "DT_MULTITOKEN"
                    }
                ],
                "SubExpr": 1,
                "HiliteType": 1,
                "ExtensionType": 16,
                "ExtensionRelev": 1
            },
            "Range": {
                "Begin": 0,
                "End": 0
            }
        },
        {
            "Type": 1,
            "Relev": 0,
            "SubTree": {
                "Base": {
                    "OpInfo": {
                        "Lo": 0,
                        "Hi": 0,
                        "Level": 0,
                        "Arrange": false,
                        "TextOp": "oWord",
                        "TextCmpOper": "cmpEQ"
                    },
                    "Name": "рф",
                    "TextAfter": "",
                    "TextBefore": "",
                    "AttrValue": "",
                    "AttrValueHi": "",
                    "TokSpan": {
                        "Len": 2,
                        "Pos": 0,
                        "SuffixLen": 0,
                        "Type": 0,
                        "TokenDelim": 0
                    },
                    "Quoted": false,
                    "ReverseFreq": 3800,
                    "TextPhraseType": "PHRASE_NONE",
                    "TextLastPhraseType": "PHRASE_NONE",
                    "TextNecessity": "nDEFAULT",
                    "KeyPrefix": 0,
                    "TextName": "",
                    "Text": "рф"
                },
                "SubExpr": 0,
                "HiliteType": 1,
                "WordInfo": {
                    "NlpType": 1,
                    "FormType": 0,
                    "Form": "рф",
                    "Attr": "",
                    "RevFr": -1,
                    "FormRevFr": -1,
                    "Idf": -1,
                    "TermFreq": 0,
                    "LangMask": 2,
                    "CaseFlags": 291,
                    "StopWord": false,
                    "Stickiness": 0,
                    "TokenCount": 1,
                    "Lemmas": [
                        {
                            "Lemma": "рф",
                            "Best": false,
                            "Bastard": false,
                            "StopWord": false,
                            "Stickiness": 0,
                            "Grammar": "S,reserved,сокр,гео,ед,жен,неод(им|род|дат|вин|твор|пр)",
                            "Forms": [
                                {
                                    "Form": "рф",
                                    "Weight": 0,
                                    "Mode": 19
                                }
                            ],
                            "Quality": 0,
                            "TextLanguage": "rus"
                        }
                    ],
                    "Languages": {
                        "Names": "rus"
                    }
                },
                "ExtensionType": 1,
                "ExtensionRelev": 0.031087
            },
            "Range": {
                "Begin": 1,
                "End": 1
            }
        },
        {
            "Type": 8,
            "Relev": 0,
            "SubTree": {
                "Base": {
                    "OpInfo": {
                        "Lo": 0,
                        "Hi": 0,
                        "Level": 0,
                        "Arrange": false,
                        "TextOp": "oWord",
                        "TextCmpOper": "cmpEQ"
                    },
                    "Name": "site",
                    "TextAfter": ")",
                    "TextBefore": "(",
                    "AttrValue": "",
                    "AttrValueHi": "",
                    "TokSpan": {
                        "Len": 4,
                        "Pos": 0,
                        "SuffixLen": 0,
                        "Type": 0,
                        "TokenDelim": 0
                    },
                    "Quoted": false,
                    "ReverseFreq": 8071,
                    "TextPhraseType": "PHRASE_NONE",
                    "TextLastPhraseType": "PHRASE_NONE",
                    "TextNecessity": "nDEFAULT",
                    "KeyPrefix": 0,
                    "TextName": "",
                    "Text": "site"
                },
                "SubExpr": 0,
                "HiliteType": 1,
                "WordInfo": {
                    "NlpType": 1,
                    "FormType": 0,
                    "Form": "site",
                    "Attr": "",
                    "RevFr": -1,
                    "FormRevFr": -1,
                    "Idf": -1,
                    "TermFreq": 0,
                    "LangMask": 1,
                    "CaseFlags": 275,
                    "StopWord": false,
                    "Stickiness": 0,
                    "TokenCount": 1,
                    "Lemmas": [
                        {
                            "Lemma": "site",
                            "Best": true,
                            "Bastard": false,
                            "StopWord": false,
                            "Stickiness": 0,
                            "Grammar": "V(наст,изъяв|инф)",
                            "Forms": [
                                {
                                    "Form": "site",
                                    "Weight": 0,
                                    "Mode": 19
                                },
                                {
                                    "Form": "sited",
                                    "Weight": 0,
                                    "Mode": 3
                                },
                                {
                                    "Form": "sites",
                                    "Weight": 0,
                                    "Mode": 3
                                },
                                {
                                    "Form": "siting",
                                    "Weight": 0,
                                    "Mode": 3
                                }
                            ],
                            "Quality": 0,
                            "TextLanguage": "eng"
                        },
                        {
                            "Lemma": "site",
                            "Best": true,
                            "Bastard": false,
                            "StopWord": false,
                            "Stickiness": 0,
                            "Grammar": "S(им,ед)",
                            "Forms": [
                                {
                                    "Form": "site",
                                    "Weight": 0,
                                    "Mode": 19
                                },
                                {
                                    "Form": "site's",
                                    "Weight": 0,
                                    "Mode": 3
                                },
                                {
                                    "Form": "sites",
                                    "Weight": 0,
                                    "Mode": 3
                                },
                                {
                                    "Form": "sites'",
                                    "Weight": 0,
                                    "Mode": 3
                                }
                            ],
                            "Quality": 0,
                            "TextLanguage": "eng"
                        }
                    ],
                    "Languages": {
                        "Names": "eng"
                    }
                },
                "ExtensionType": 8,
                "ExtensionRelev": 0.5
            },
            "Range": {
                "Begin": 3,
                "End": 3
            }
        },
        {
            "Type": 1,
            "Relev": 0,
            "SubTree": {
                "Base": {
                    "OpInfo": {
                        "Lo": 0,
                        "Hi": 0,
                        "Level": 0,
                        "Arrange": false,
                        "TextOp": "oWord",
                        "TextCmpOper": "cmpEQ"
                    },
                    "Name": "карельский",
                    "TextAfter": "",
                    "TextBefore": "",
                    "AttrValue": "",
                    "AttrValueHi": "",
                    "TokSpan": {
                        "Len": 10,
                        "Pos": 0,
                        "SuffixLen": 0,
                        "Type": 0,
                        "TokenDelim": 0
                    },
                    "Quoted": false,
                    "ReverseFreq": 288333,
                    "TextPhraseType": "PHRASE_NONE",
                    "TextLastPhraseType": "PHRASE_NONE",
                    "TextNecessity": "nDEFAULT",
                    "KeyPrefix": 0,
                    "TextName": "",
                    "Text": "карельский"
                },
                "SubExpr": 0,
                "HiliteType": 1,
                "WordInfo": {
                    "NlpType": 1,
                    "FormType": 0,
                    "Form": "карельский",
                    "Attr": "",
                    "RevFr": -1,
                    "FormRevFr": -1,
                    "Idf": -1,
                    "TermFreq": 0,
                    "LangMask": 2,
                    "CaseFlags": 291,
                    "StopWord": false,
                    "Stickiness": 0,
                    "TokenCount": 1,
                    "Lemmas": [
                        {
                            "Lemma": "карельский",
                            "Best": false,
                            "Bastard": false,
                            "StopWord": false,
                            "Stickiness": 0,
                            "Grammar": "A(им,ед,полн,муж|вин,ед,полн,муж,неод)",
                            "Forms": [
                                {
                                    "Form": "карельскаго",
                                    "Weight": 0,
                                    "Mode": 3
                                },
                                {
                                    "Form": "карельская",
                                    "Weight": 0,
                                    "Mode": 3
                                },
                                {
                                    "Form": "карельски",
                                    "Weight": 0,
                                    "Mode": 3
                                },
                                {
                                    "Form": "карельские",
                                    "Weight": 0,
                                    "Mode": 3
                                },
                                {
                                    "Form": "карельский",
                                    "Weight": 0,
                                    "Mode": 19
                                },
                                {
                                    "Form": "карельским",
                                    "Weight": 0,
                                    "Mode": 3
                                },
                                {
                                    "Form": "карельскими",
                                    "Weight": 0,
                                    "Mode": 3
                                },
                                {
                                    "Form": "карельских",
                                    "Weight": 0,
                                    "Mode": 3
                                },
                                {
                                    "Form": "карельския",
                                    "Weight": 0,
                                    "Mode": 3
                                },
                                {
                                    "Form": "карельско",
                                    "Weight": 0,
                                    "Mode": 3
                                },
                                {
                                    "Form": "карельского",
                                    "Weight": 0,
                                    "Mode": 3
                                },
                                {
                                    "Form": "карельское",
                                    "Weight": 0,
                                    "Mode": 3
                                },
                                {
                                    "Form": "карельской",
                                    "Weight": 0,
                                    "Mode": 3
                                },
                                {
                                    "Form": "карельском",
                                    "Weight": 0,
                                    "Mode": 3
                                },
                                {
                                    "Form": "карельскому",
                                    "Weight": 0,
                                    "Mode": 3
                                },
                                {
                                    "Form": "карельскою",
                                    "Weight": 0,
                                    "Mode": 3
                                },
                                {
                                    "Form": "карельскую",
                                    "Weight": 0,
                                    "Mode": 3
                                }
                            ],
                            "Quality": 0,
                            "TextLanguage": "rus"
                        }
                    ],
                    "Languages": {
                        "Names": "rus"
                    }
                },
                "ExtensionType": 1,
                "ExtensionRelev": 0.5
            },
            "Range": {
                "Begin": 4,
                "End": 4
            }
        }
    ],
    "Markup": [
        {
            "Range": {
                "Begin": 0,
                "End": 0
            },
            "Data": {
                "Type": 0,
                "Synonym": {
                    "Type": 8,
                    "Relev": 0,
                    "SubTree": {
                        "Base": {
                            "OpInfo": {
                                "Lo": 0,
                                "Hi": 0,
                                "Level": 0,
                                "Arrange": false,
                                "TextOp": "oWord",
                                "TextCmpOper": "cmpEQ"
                            },
                            "Name": "sberbank",
                            "TextAfter": ")",
                            "TextBefore": "(",
                            "AttrValue": "",
                            "AttrValueHi": "",
                            "TokSpan": {
                                "Len": 8,
                                "Pos": 0,
                                "SuffixLen": 0,
                                "Type": 0,
                                "TokenDelim": 0
                            },
                            "Quoted": false,
                            "ReverseFreq": 5154937,
                            "TextPhraseType": "PHRASE_NONE",
                            "TextLastPhraseType": "PHRASE_NONE",
                            "TextNecessity": "nDEFAULT",
                            "KeyPrefix": 0,
                            "TextName": "",
                            "Text": "sberbank"
                        },
                        "SubExpr": 0,
                        "HiliteType": 1,
                        "WordInfo": {
                            "NlpType": 1,
                            "FormType": 0,
                            "Form": "sberbank",
                            "Attr": "",
                            "RevFr": -1,
                            "FormRevFr": -1,
                            "Idf": -1,
                            "TermFreq": 0,
                            "LangMask": 1,
                            "CaseFlags": 275,
                            "StopWord": false,
                            "Stickiness": 0,
                            "TokenCount": 1,
                            "Lemmas": [
                                {
                                    "Lemma": "sberbank",
                                    "Best": false,
                                    "Bastard": true,
                                    "StopWord": false,
                                    "Stickiness": 0,
                                    "Grammar": "A()",
                                    "Forms": [
                                        {
                                            "Form": "sberbank",
                                            "Weight": 0,
                                            "Mode": 19
                                        }
                                    ],
                                    "Quality": 1,
                                    "TextLanguage": "eng"
                                }
                            ],
                            "Languages": {
                                "Names": "eng"
                            }
                        },
                        "ExtensionType": 8,
                        "ExtensionRelev": 0.5
                    }
                }
            }
        },
        {
            "Range": {
                "Begin": 0,
                "End": 0
            },
            "Data": {
                "Type": 0,
                "Synonym": {
                    "Type": 16,
                    "Relev": 0,
                    "SubTree": {
                        "Base": {
                            "OpInfo": {
                                "Lo": 1,
                                "Hi": 1,
                                "Level": 0,
                                "Arrange": false,
                                "TextOp": "oAnd",
                                "TextCmpOper": "cmpEQ"
                            },
                            "Name": "сбер-банк",
                            "TextAfter": ")",
                            "TextBefore": "(",
                            "AttrValue": "",
                            "AttrValueHi": "",
                            "TokSpan": {
                                "Len": 9,
                                "Pos": 0,
                                "SuffixLen": 0,
                                "Type": 0,
                                "TokenDelim": 0
                            },
                            "Quoted": false,
                            "ReverseFreq": -1,
                            "TextPhraseType": "PHRASE_MULTIWORD",
                            "TextLastPhraseType": "PHRASE_MULTIWORD",
                            "TextNecessity": "nDEFAULT",
                            "KeyPrefix": 0,
                            "TextName": "",
                            "Text": "сбер-банк"
                        },
                        "Children": [
                            {
                                "Base": {
                                    "OpInfo": {
                                        "Lo": 0,
                                        "Hi": 0,
                                        "Level": 0,
                                        "Arrange": false,
                                        "TextOp": "oWord",
                                        "TextCmpOper": "cmpEQ"
                                    },
                                    "Name": "сбер",
                                    "TextAfter": "-",
                                    "TextBefore": "(",
                                    "AttrValue": "",
                                    "AttrValueHi": "",
                                    "TokSpan": {
                                        "Len": 4,
                                        "Pos": 0,
                                        "SuffixLen": 0,
                                        "Type": 0,
                                        "TokenDelim": 0
                                    },
                                    "Quoted": false,
                                    "ReverseFreq": 999909,
                                    "TextPhraseType": "PHRASE_NONE",
                                    "TextLastPhraseType": "PHRASE_NONE",
                                    "TextNecessity": "nDEFAULT",
                                    "KeyPrefix": 0,
                                    "TextName": "",
                                    "Text": "сбер"
                                },
                                "SubExpr": 0,
                                "HiliteType": 1,
                                "WordInfo": {
                                    "NlpType": 1,
                                    "FormType": 0,
                                    "Form": "сбер",
                                    "Attr": "",
                                    "RevFr": -1,
                                    "FormRevFr": -1,
                                    "Idf": -1,
                                    "TermFreq": 0,
                                    "LangMask": 2,
                                    "CaseFlags": 291,
                                    "StopWord": false,
                                    "Stickiness": 0,
                                    "TokenCount": 1,
                                    "Lemmas": [
                                        {
                                            "Lemma": "сбер",
                                            "Best": false,
                                            "Bastard": true,
                                            "StopWord": false,
                                            "Stickiness": 0,
                                            "Grammar": "S,муж,неод(им,ед|вин,ед)",
                                            "Forms": [
                                                {
                                                    "Form": "сбер",
                                                    "Weight": 0,
                                                    "Mode": 19
                                                },
                                                {
                                                    "Form": "сбера",
                                                    "Weight": 0,
                                                    "Mode": 3
                                                },
                                                {
                                                    "Form": "сберам",
                                                    "Weight": 0,
                                                    "Mode": 3
                                                },
                                                {
                                                    "Form": "сберами",
                                                    "Weight": 0,
                                                    "Mode": 3
                                                },
                                                {
                                                    "Form": "сберах",
                                                    "Weight": 0,
                                                    "Mode": 3
                                                },
                                                {
                                                    "Form": "сбере",
                                                    "Weight": 0,
                                                    "Mode": 3
                                                },
                                                {
                                                    "Form": "сберов",
                                                    "Weight": 0,
                                                    "Mode": 3
                                                },
                                                {
                                                    "Form": "сбером",
                                                    "Weight": 0,
                                                    "Mode": 3
                                                },
                                                {
                                                    "Form": "сберу",
                                                    "Weight": 0,
                                                    "Mode": 3
                                                },
                                                {
                                                    "Form": "сберы",
                                                    "Weight": 0,
                                                    "Mode": 3
                                                }
                                            ],
                                            "Quality": 2,
                                            "TextLanguage": "rus"
                                        }
                                    ],
                                    "Languages": {
                                        "Names": "rus"
                                    }
                                },
                                "ExtensionType": 0,
                                "ExtensionRelev": 1
                            },
                            {
                                "Base": {
                                    "OpInfo": {
                                        "Lo": 0,
                                        "Hi": 0,
                                        "Level": 0,
                                        "Arrange": false,
                                        "TextOp": "oWord",
                                        "TextCmpOper": "cmpEQ"
                                    },
                                    "Name": "банк",
                                    "TextAfter": ")",
                                    "TextBefore": "-",
                                    "AttrValue": "",
                                    "AttrValueHi": "",
                                    "TokSpan": {
                                        "Len": 4,
                                        "Pos": 0,
                                        "SuffixLen": 0,
                                        "Type": 0,
                                        "TokenDelim": 0
                                    },
                                    "Quoted": false,
                                    "ReverseFreq": 3776,
                                    "TextPhraseType": "PHRASE_NONE",
                                    "TextLastPhraseType": "PHRASE_NONE",
                                    "TextNecessity": "nDEFAULT",
                                    "KeyPrefix": 0,
                                    "TextName": "",
                                    "Text": "банк"
                                },
                                "SubExpr": 0,
                                "HiliteType": 1,
                                "WordInfo": {
                                    "NlpType": 1,
                                    "FormType": 0,
                                    "Form": "банк",
                                    "Attr": "",
                                    "RevFr": -1,
                                    "FormRevFr": -1,
                                    "Idf": -1,
                                    "TermFreq": 0,
                                    "LangMask": 2,
                                    "CaseFlags": 291,
                                    "StopWord": false,
                                    "Stickiness": 0,
                                    "TokenCount": 1,
                                    "Lemmas": [
                                        {
                                            "Lemma": "банк",
                                            "Best": false,
                                            "Bastard": false,
                                            "StopWord": false,
                                            "Stickiness": 0,
                                            "Grammar": "S,муж,неод(им,ед|вин,ед)",
                                            "Forms": [
                                                {
                                                    "Form": "банк",
                                                    "Weight": 0,
                                                    "Mode": 19
                                                },
                                                {
                                                    "Form": "банка",
                                                    "Weight": 0,
                                                    "Mode": 3
                                                },
                                                {
                                                    "Form": "банкам",
                                                    "Weight": 0,
                                                    "Mode": 3
                                                },
                                                {
                                                    "Form": "банками",
                                                    "Weight": 0,
                                                    "Mode": 3
                                                },
                                                {
                                                    "Form": "банках",
                                                    "Weight": 0,
                                                    "Mode": 3
                                                },
                                                {
                                                    "Form": "банке",
                                                    "Weight": 0,
                                                    "Mode": 3
                                                },
                                                {
                                                    "Form": "банки",
                                                    "Weight": 0,
                                                    "Mode": 3
                                                },
                                                {
                                                    "Form": "банков",
                                                    "Weight": 0,
                                                    "Mode": 3
                                                },
                                                {
                                                    "Form": "банком",
                                                    "Weight": 0,
                                                    "Mode": 3
                                                },
                                                {
                                                    "Form": "банку",
                                                    "Weight": 0,
                                                    "Mode": 3
                                                }
                                            ],
                                            "Quality": 0,
                                            "TextLanguage": "rus"
                                        }
                                    ],
                                    "Languages": {
                                        "Names": "rus"
                                    }
                                },
                                "ExtensionType": 0,
                                "ExtensionRelev": 1
                            }
                        ],
                        "Proxes": [
                            {
                                "Begin": 1,
                                "End": 1,
                                "Center": 1,
                                "Level": 3,
                                "ConvertedBounds": false,
                                "TextDistanceType": "DT_MULTITOKEN"
                            }
                        ],
                        "SubExpr": 1,
                        "HiliteType": 1,
                        "ExtensionType": 16,
                        "ExtensionRelev": 1
                    }
                }
            }
        },
        {
            "Range": {
                "Begin": 1,
                "End": 1
            },
            "Data": {
                "Type": 0,
                "Synonym": {
                    "Type": 1,
                    "Relev": 0,
                    "SubTree": {
                        "Base": {
                            "OpInfo": {
                                "Lo": 0,
                                "Hi": 0,
                                "Level": 0,
                                "Arrange": false,
                                "TextOp": "oWord",
                                "TextCmpOper": "cmpEQ"
                            },
                            "Name": "рф",
                            "TextAfter": "",
                            "TextBefore": "",
                            "AttrValue": "",
                            "AttrValueHi": "",
                            "TokSpan": {
                                "Len": 2,
                                "Pos": 0,
                                "SuffixLen": 0,
                                "Type": 0,
                                "TokenDelim": 0
                            },
                            "Quoted": false,
                            "ReverseFreq": 3800,
                            "TextPhraseType": "PHRASE_NONE",
                            "TextLastPhraseType": "PHRASE_NONE",
                            "TextNecessity": "nDEFAULT",
                            "KeyPrefix": 0,
                            "TextName": "",
                            "Text": "рф"
                        },
                        "SubExpr": 0,
                        "HiliteType": 1,
                        "WordInfo": {
                            "NlpType": 1,
                            "FormType": 0,
                            "Form": "рф",
                            "Attr": "",
                            "RevFr": -1,
                            "FormRevFr": -1,
                            "Idf": -1,
                            "TermFreq": 0,
                            "LangMask": 2,
                            "CaseFlags": 291,
                            "StopWord": false,
                            "Stickiness": 0,
                            "TokenCount": 1,
                            "Lemmas": [
                                {
                                    "Lemma": "рф",
                                    "Best": false,
                                    "Bastard": false,
                                    "StopWord": false,
                                    "Stickiness": 0,
                                    "Grammar": "S,reserved,сокр,гео,ед,жен,неод(им|род|дат|вин|твор|пр)",
                                    "Forms": [
                                        {
                                            "Form": "рф",
                                            "Weight": 0,
                                            "Mode": 19
                                        }
                                    ],
                                    "Quality": 0,
                                    "TextLanguage": "rus"
                                }
                            ],
                            "Languages": {
                                "Names": "rus"
                            }
                        },
                        "ExtensionType": 1,
                        "ExtensionRelev": 0.031087
                    }
                }
            }
        },
        {
            "Range": {
                "Begin": 3,
                "End": 3
            },
            "Data": {
                "Type": 0,
                "Synonym": {
                    "Type": 8,
                    "Relev": 0,
                    "SubTree": {
                        "Base": {
                            "OpInfo": {
                                "Lo": 0,
                                "Hi": 0,
                                "Level": 0,
                                "Arrange": false,
                                "TextOp": "oWord",
                                "TextCmpOper": "cmpEQ"
                            },
                            "Name": "site",
                            "TextAfter": ")",
                            "TextBefore": "(",
                            "AttrValue": "",
                            "AttrValueHi": "",
                            "TokSpan": {
                                "Len": 4,
                                "Pos": 0,
                                "SuffixLen": 0,
                                "Type": 0,
                                "TokenDelim": 0
                            },
                            "Quoted": false,
                            "ReverseFreq": 8071,
                            "TextPhraseType": "PHRASE_NONE",
                            "TextLastPhraseType": "PHRASE_NONE",
                            "TextNecessity": "nDEFAULT",
                            "KeyPrefix": 0,
                            "TextName": "",
                            "Text": "site"
                        },
                        "SubExpr": 0,
                        "HiliteType": 1,
                        "WordInfo": {
                            "NlpType": 1,
                            "FormType": 0,
                            "Form": "site",
                            "Attr": "",
                            "RevFr": -1,
                            "FormRevFr": -1,
                            "Idf": -1,
                            "TermFreq": 0,
                            "LangMask": 1,
                            "CaseFlags": 275,
                            "StopWord": false,
                            "Stickiness": 0,
                            "TokenCount": 1,
                            "Lemmas": [
                                {
                                    "Lemma": "site",
                                    "Best": true,
                                    "Bastard": false,
                                    "StopWord": false,
                                    "Stickiness": 0,
                                    "Grammar": "V(наст,изъяв|инф)",
                                    "Forms": [
                                        {
                                            "Form": "site",
                                            "Weight": 0,
                                            "Mode": 19
                                        },
                                        {
                                            "Form": "sited",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "sites",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "siting",
                                            "Weight": 0,
                                            "Mode": 3
                                        }
                                    ],
                                    "Quality": 0,
                                    "TextLanguage": "eng"
                                },
                                {
                                    "Lemma": "site",
                                    "Best": true,
                                    "Bastard": false,
                                    "StopWord": false,
                                    "Stickiness": 0,
                                    "Grammar": "S(им,ед)",
                                    "Forms": [
                                        {
                                            "Form": "site",
                                            "Weight": 0,
                                            "Mode": 19
                                        },
                                        {
                                            "Form": "site's",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "sites",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "sites'",
                                            "Weight": 0,
                                            "Mode": 3
                                        }
                                    ],
                                    "Quality": 0,
                                    "TextLanguage": "eng"
                                }
                            ],
                            "Languages": {
                                "Names": "eng"
                            }
                        },
                        "ExtensionType": 8,
                        "ExtensionRelev": 0.5
                    }
                }
            }
        },
        {
            "Range": {
                "Begin": 4,
                "End": 4
            },
            "Data": {
                "Type": 0,
                "Synonym": {
                    "Type": 1,
                    "Relev": 0,
                    "SubTree": {
                        "Base": {
                            "OpInfo": {
                                "Lo": 0,
                                "Hi": 0,
                                "Level": 0,
                                "Arrange": false,
                                "TextOp": "oWord",
                                "TextCmpOper": "cmpEQ"
                            },
                            "Name": "карельский",
                            "TextAfter": "",
                            "TextBefore": "",
                            "AttrValue": "",
                            "AttrValueHi": "",
                            "TokSpan": {
                                "Len": 10,
                                "Pos": 0,
                                "SuffixLen": 0,
                                "Type": 0,
                                "TokenDelim": 0
                            },
                            "Quoted": false,
                            "ReverseFreq": 288333,
                            "TextPhraseType": "PHRASE_NONE",
                            "TextLastPhraseType": "PHRASE_NONE",
                            "TextNecessity": "nDEFAULT",
                            "KeyPrefix": 0,
                            "TextName": "",
                            "Text": "карельский"
                        },
                        "SubExpr": 0,
                        "HiliteType": 1,
                        "WordInfo": {
                            "NlpType": 1,
                            "FormType": 0,
                            "Form": "карельский",
                            "Attr": "",
                            "RevFr": -1,
                            "FormRevFr": -1,
                            "Idf": -1,
                            "TermFreq": 0,
                            "LangMask": 2,
                            "CaseFlags": 291,
                            "StopWord": false,
                            "Stickiness": 0,
                            "TokenCount": 1,
                            "Lemmas": [
                                {
                                    "Lemma": "карельский",
                                    "Best": false,
                                    "Bastard": false,
                                    "StopWord": false,
                                    "Stickiness": 0,
                                    "Grammar": "A(им,ед,полн,муж|вин,ед,полн,муж,неод)",
                                    "Forms": [
                                        {
                                            "Form": "карельскаго",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "карельская",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "карельски",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "карельские",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "карельский",
                                            "Weight": 0,
                                            "Mode": 19
                                        },
                                        {
                                            "Form": "карельским",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "карельскими",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "карельских",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "карельския",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "карельско",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "карельского",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "карельское",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "карельской",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "карельском",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "карельскому",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "карельскою",
                                            "Weight": 0,
                                            "Mode": 3
                                        },
                                        {
                                            "Form": "карельскую",
                                            "Weight": 0,
                                            "Mode": 3
                                        }
                                    ],
                                    "Quality": 0,
                                    "TextLanguage": "rus"
                                }
                            ],
                            "Languages": {
                                "Names": "rus"
                            }
                        },
                        "ExtensionType": 1,
                        "ExtensionRelev": 0.5
                    }
                }
            }
        }
    ]
}
'''
