PY2_LIBRARY()

OWNER(
    g:sandbox-dev
    g:search-sandbox
)

PY_SRCS(
    __init__.py

    antispam_db.py
    async_res_download.py

    BaseBinariesAndConfigsTask.py
    BaseBuildMonsysTask.py
    BaseBuildPythonBundleTask.py
    BaseGetLastShardmapTask.py
    BaseGetMediaDatabaseTask.py
    BaseGetShardmapTask.py
    BaseImagesBuildBundle.py
    BaseImagesBuildIndexBundle.py
    BaseImagesBuildIndexBundles.py
    BaseImagesBundleReplaces.py
    BaseImagesFastBuildDeployBundle.py
    BaseLoadMediaBasesearchResources.py
    BaseMediaBuildBundle.py
    BaseMediaBuildBundle_v2.py
    BaseMediaBuildBundle_v3.py
    BaseMediaBuildRobotBinaries.py
    BaseMediaBuildRobotBundles.py
    BaseReportShardTask.py
    BaseRpmTask.py
    BaseVideoBuildBundle.py
    binaries_provider_ymake.py
    BuildExternalProgramTask.py

    deploy_jupiter.py
    DeployMediaShardmap.py

    FuncTestSuiteBase.py

    juggler_notifying_sandbox_task.py

    mapreduce_runner.py

    NannyTask.py

    quentao_task.py

    releases.py
    rsync_helper.py
)

SET(COMMON_DIR "sandbox/projects/common")

PEERDIR(
    contrib/python/protobuf

    skynet/api/cms
    skynet/library

    ${COMMON_DIR}/apihelpers
    ${COMMON_DIR}/app_host
    ${COMMON_DIR}/arcadia
    ${COMMON_DIR}/autocheck
    ${COMMON_DIR}/backend_build_pipeline
    ${COMMON_DIR}/balancer
    ${COMMON_DIR}/balancer_sepe
    ${COMMON_DIR}/base_search_quality
    ${COMMON_DIR}/betas
    ${COMMON_DIR}/blender
    ${COMMON_DIR}/binary_task
    ${COMMON_DIR}/bno
    ${COMMON_DIR}/breakpad
    ${COMMON_DIR}/build
    ${COMMON_DIR}/cms
    ${COMMON_DIR}/commands
    ${COMMON_DIR}/compare_upper_results
    ${COMMON_DIR}/conductor
    ${COMMON_DIR}/config_patcher_tool
    ${COMMON_DIR}/config_processor
    ${COMMON_DIR}/constants
    ${COMMON_DIR}/create_text_resource
    ${COMMON_DIR}/debpkg
    ${COMMON_DIR}/decorators
    ${COMMON_DIR}/differ
    ${COMMON_DIR}/dolbilka
    ${COMMON_DIR}/dolbilka2
    ${COMMON_DIR}/dynamic_models
    ${COMMON_DIR}/gsid_parser
    ${COMMON_DIR}/environments
    ${COMMON_DIR}/error_handlers
    ${COMMON_DIR}/fasthttp
    ${COMMON_DIR}/file_utils
    ${COMMON_DIR}/footers
    ${COMMON_DIR}/fuzzing
    ${COMMON_DIR}/gencfg
    ${COMMON_DIR}/geosearch
    ${COMMON_DIR}/gnupg
    ${COMMON_DIR}/http_responses
    ${COMMON_DIR}/import_tools

    ${COMMON_DIR}/infra
    ${COMMON_DIR}/infra/exec_script_lxc

    ${COMMON_DIR}/infractl
    ${COMMON_DIR}/iss
    ${COMMON_DIR}/juggler
    ${COMMON_DIR}/kosher_release
    ${COMMON_DIR}/link_builder
    ${COMMON_DIR}/mapreduce_stored_tables
    ${COMMON_DIR}/market_report
    ${COMMON_DIR}/mediasearch
    ${COMMON_DIR}/metrics_launch_manager
    ${COMMON_DIR}/middlesearch
    ${COMMON_DIR}/mobilesearch
    ${COMMON_DIR}/nanny
    ${COMMON_DIR}/nanny_release_resource
    ${COMMON_DIR}/network
    ${COMMON_DIR}/news
    ${COMMON_DIR}/noapacheupper
    ${COMMON_DIR}/panopticon
    ${COMMON_DIR}/paths
    ${COMMON_DIR}/parameters
    ${COMMON_DIR}/platform_api
    ${COMMON_DIR}/priemka
    ${COMMON_DIR}/profiling
    ${COMMON_DIR}/profiling2
    ${COMMON_DIR}/proxy_wizard
    ${COMMON_DIR}/pumpkin
    ${COMMON_DIR}/rem
    ${COMMON_DIR}/ra2
    ${COMMON_DIR}/report_renderer
    ${COMMON_DIR}/requests_wrapper
    ${COMMON_DIR}/resource_selectors
    ${COMMON_DIR}/rtyserver
    ${COMMON_DIR}/sanitizer
    ${COMMON_DIR}/sb_decorators
    ${COMMON_DIR}/scheduling
    ${COMMON_DIR}/search
    ${COMMON_DIR}/solomon
    ${COMMON_DIR}/startrek_utils
    ${COMMON_DIR}/staff
    ${COMMON_DIR}/stats
    ${COMMON_DIR}/string
    ${COMMON_DIR}/tasklet
    ${COMMON_DIR}/telegram_api
    ${COMMON_DIR}/templates
    ${COMMON_DIR}/testenv
    ${COMMON_DIR}/thumbdaemon
    ${COMMON_DIR}/time_utils
    ${COMMON_DIR}/userdata
    ${COMMON_DIR}/ui
    ${COMMON_DIR}/utils
    ${COMMON_DIR}/utils2
    ${COMMON_DIR}/vcs
    ${COMMON_DIR}/wizard
    ${COMMON_DIR}/yabs
    ${COMMON_DIR}/yappy
    ${COMMON_DIR}/yasm
    ${COMMON_DIR}/ya_deploy
    ${COMMON_DIR}/yc
    ${COMMON_DIR}/yql
    ${COMMON_DIR}/yt_runner
    ${COMMON_DIR}/z2
    ${COMMON_DIR}/massif
    ${COMMON_DIR}/msparser
    ${COMMON_DIR}/yt_cleaner
    ${COMMON_DIR}/task_env
    ${COMMON_DIR}/teamcity

    ${COMMON_DIR}/BaseTestTask
    ${COMMON_DIR}/BaseGetDatabaseTask
    ${COMMON_DIR}/BaseCompareYaMakeOutputsTask
    ${COMMON_DIR}/ProcessPool
    ${COMMON_DIR}/RunCommand
    ${COMMON_DIR}/YMakeBase
    ${COMMON_DIR}/TestPerformanceBest

    sandbox/projects/resource_types
    sandbox/projects/DeployNannyShardmap
    sandbox/projects/GenerateAllPlans
    sandbox/projects/GetImagesMrIndexConfig
    sandbox/projects/images/ImagesBuildMainIndexBinaries
    sandbox/projects/SetItsValueTask
)

RESOURCE(
    testenv_tests/.arcignore sandbox/projects/common/testenv_tests/.arcignore
    testenv_tests/file1.json sandbox/projects/common/testenv_tests/file1.json
    testenv_tests/file1.xml sandbox/projects/common/testenv_tests/file1.xml
    testenv_tests/file2.json sandbox/projects/common/testenv_tests/file2.json
    testenv_tests/file2.xml sandbox/projects/common/testenv_tests/file2.xml
    testenv_tests/file3.json sandbox/projects/common/testenv_tests/file3.json
    testenv_tests/file4.json sandbox/projects/common/testenv_tests/file4.json
    testenv_tests/kvm-xfstests-results.json sandbox/projects/common/testenv_tests/kvm-xfstests-results.json
    testenv_tests/kvm-xfstests-results.xml sandbox/projects/common/testenv_tests/kvm-xfstests-results.xml
    testenv_tests/kvm-xfstests-results2.json sandbox/projects/common/testenv_tests/kvm-xfstests-results2.json
    testenv_tests/kvm-xfstests-results2.xml sandbox/projects/common/testenv_tests/kvm-xfstests-results2.xml
)

END()

RECURSE(
    BaseCompareYaMakeOutputsTask
    BaseGetDatabaseTask
    BaseTestTask
    ProcessPool
    ReleasedResourceConsumer
    RunCommand
    TestPerformanceBest
    YMakeBase
    apihelpers
    app_host
    aqua
    arcadia
    autocheck
    backend_build_pipeline
    balancer
    balancer_sepe
    base_search_quality
    betas
    binary_task
    blender
    bno
    breakpad
    build
    cgroup
    cms
    commands
    compare_upper_results
    conductor
    config_patcher_tool
    config_processor
    constants
    context_managers
    create_text_resource
    debpkg
    decorators
    differ
    dolbilka
    dolbilka2
    dynamic_models
    gsid_parser
    environments
    error_handlers
    fasthttp
    file_utils
    footers
    fusion
    fuzzing
    gencfg
    geosearch
    gnupg
    http_responses
    import_tools
    infra
    infractl
    iss
    juggler
    kosher_release
    link_builder
    mapreduce_stored_tables
    market_report
    massif
    mediasearch
    metrics_launch_manager
    middlesearch
    mobilesearch
    msparser
    nanny
    nanny_release_resource
    network
    news
    noapacheupper
    panopticon
    paths
    parameters
    platform_api
    priemka
    profiling
    profiling2
    proxy_wizard
    pumpkin
    ra2
    rem
    report_renderer
    requests_wrapper
    resource_selectors
    rtyserver
    sanitizer
    sb_decorators
    scheduling
    sdk_compat
    search
    solomon
    startrek_utils
    stats
    string
    task_env
    tasklet
    teamcity
    telegram_api
    templates
    testenv
    testenv_client
    testenv_tests
    tests
    thumbdaemon
    time_utils
    ui
    userdata
    utils
    utils2
    vcs
    wizard
    yabs
    yappy
    yasm
    ya_deploy
    yc
    yql
    yt_cleaner
    yt_runner
    z2
)
