PY2_LIBRARY()

OWNER(g:crypta)

PY_SRCS(
    __init__.py
)

SET(PWD "sandbox/projects/crypta")
PEERDIR(
    ${PWD}/audience
    ${PWD}/buchhalter
    ${PWD}/build_and_release
    ${PWD}/build_deb_package
    ${PWD}/clone_bigb_experiment
    ${PWD}/cm
    ${PWD}/cm/api
    ${PWD}/cm/calc_expire
    ${PWD}/cm/db_backup
    ${PWD}/cm/db_stats
    ${PWD}/cm/ext_id_mapper
    ${PWD}/cm/fpc_uploader
    ${PWD}/cm/identifier
    ${PWD}/cm/mutator
    ${PWD}/cm/offline/bundle
    ${PWD}/cm/offline/parse_cm_access_log
    ${PWD}/cm/offline/split_by_tag
    ${PWD}/cm/offline/update_state
    ${PWD}/cm/prepare_to_sync_db
    ${PWD}/cm/quoter
    ${PWD}/cm/rt_duid_uploader
    ${PWD}/cm/udf
    ${PWD}/cm/uploader
    ${PWD}/common
    ${PWD}/common/crypta_api
    ${PWD}/dit
    ${PWD}/dit/bundle
    ${PWD}/dit/export_data
    ${PWD}/dit/match_dit_to_segments_and_domains
    ${PWD}/dit/sftp_to_yt_daily
    ${PWD}/dmp
    ${PWD}/dmp/adobe/common
    ${PWD}/dmp/adobe/process_segments
    ${PWD}/dmp/check_upload_to_audience_errors
    ${PWD}/dmp/upload_to_logbroker
    ${PWD}/dmp/yandex
    ${PWD}/dmp/yandex/calc_sizes
    ${PWD}/dmp/yandex/common
    ${PWD}/dmp/yandex/ftp_to_yt
    ${PWD}/dmp/yandex/make_mac_hash_yuid
    ${PWD}/dmp/yandex/process_segments
    ${PWD}/dmp/yandex/publish_index
    ${PWD}/dmp/yandex/send_metrics
    ${PWD}/dmp/yandex/send_metrics_mail
    ${PWD}/dmp/yandex/send_quarantine_mail
    ${PWD}/dmp/yandex/send_report_mail
    ${PWD}/dmp/yandex/send_statistics_mail
    ${PWD}/dmp/yandex/upload_report_to_ftp
    ${PWD}/dmp/yandex/upload_to_audience
    ${PWD}/ext_fp
    ${PWD}/ext_fp/delay_line
    ${PWD}/ext_fp/matcher
    ${PWD}/graph
    ${PWD}/graph/bochka
    ${PWD}/graph/export
    ${PWD}/graph/fingerprint
    ${PWD}/graph/fpc
    ${PWD}/graph/households
    ${PWD}/graph/indevice
    ${PWD}/graph/matching
    ${PWD}/graph/matching/human_matching
    ${PWD}/graph/matching/params_exp
    ${PWD}/graph/metrics
    ${PWD}/graph/metrics/stats
    ${PWD}/graph/metrics/stats/base
    ${PWD}/graph/metrics/stats/exporter
    ${PWD}/graph/metrics/telegram
    ${PWD}/graph/metrics/telegram/bin
    ${PWD}/graph/metrics/telegram/lib
    ${PWD}/graph/metrics/user_params
    ${PWD}/graph/probabilistic
    ${PWD}/graph/rtdi
    ${PWD}/graph/rtsklejka
    ${PWD}/graph/soup
    ${PWD}/graph/soup/edge_weights
    ${PWD}/graph/soup/prepare
    ${PWD}/graph/soup/prepare_radius
    ${PWD}/graph/soup/sample
    ${PWD}/graph/staff
    ${PWD}/graph/staff/bin
    ${PWD}/graph/staff/lib
    ${PWD}/graph/stream
    ${PWD}/graph/styx
    ${PWD}/graph/task_runner
    ${PWD}/graph/v1
    ${PWD}/graph/vavilov
    ${PWD}/lab
    ${PWD}/lookalike
    ${PWD}/lookalike/calc_goal_audiences
    ${PWD}/lookalike/calc_metrika_counter_audiences
    ${PWD}/lookalike/calc_metrika_segments
    ${PWD}/lookalike/common
    ${PWD}/lookalike/index_builder
    ${PWD}/lookalike/lal_manager
    ${PWD}/lookalike/lal_refresher
    ${PWD}/lookalike/lal_synchronizer
    ${PWD}/lookalike/metrics
    ${PWD}/lookalike/metrics/counts_per_parent_type_calc
    ${PWD}/lookalike/metrics/sizes_diff_calc
    ${PWD}/lookalike/model_supplier
    ${PWD}/lookalike/segment_dssm_applier
    ${PWD}/lookalike/segmentator
    ${PWD}/lookalike/user_dssm_applier
    ${PWD}/lookalike/user_segments_exporter
    ${PWD}/lookalike/visit_log_parser
    ${PWD}/ltp
    ${PWD}/ltp/viewer_index
    ${PWD}/merge_to_bigb_collector
    ${PWD}/ml_models
    ${PWD}/ml_models/resources
    ${PWD}/ml_models/train_custom_model
    ${PWD}/platform
    ${PWD}/resources
    ${PWD}/rt_socdem
    ${PWD}/rt_socdem/rtmr
    ${PWD}/run_binary
    ${PWD}/run_luigi_task
    ${PWD}/run_universal_bundle
    ${PWD}/s2s
    ${PWD}/s2s/calc_stats
    ${PWD}/s2s/common
    ${PWD}/s2s/process_conversions
    ${PWD}/s2s/transfer_conversions_to_yt
    ${PWD}/s2s/upload_to_postback
    ${PWD}/siberia
    ${PWD}/siberia/core
    ${PWD}/siberia/describer
    ${PWD}/siberia/expirator
    ${PWD}/siberia/make_crypta_id_user_data
    ${PWD}/siberia/make_user_data_encoded
    ${PWD}/siberia/matching_table_uploader
    ${PWD}/siberia/mutator
    ${PWD}/siberia/segmentator
    ${PWD}/siberia/upload_clients
    ${PWD}/siberia/user_data_uploader
    ${PWD}/styx
    ${PWD}/styx/api
    ${PWD}/styx/mutator
    ${PWD}/tx_data_import
    ${PWD}/ya_make_yt
)

END()

RECURSE(
    audience
    buchhalter
    build_deb_package
    clone_bigb_experiment
    cm
    common
    dit
    dmp
    ext_fp
    graph
    lab
    lookalike
    merge_to_bigb_collector
    ml_models
    platform
    resources
    run_binary
    run_luigi_task
    run_universal_bundle
    s2s
    siberia
    styx
    tx_data_import
)
