# -*- coding: utf-8 -*-
RESPONSIBLE = (
    "Ознакомьтесь с (({devops_doc_link} DevOps-документацией)) или обратитесь к dmitryno@ "
    "(или {alt_devops_master}@), если необходимы пояснения, но **не игнорируйте** "
    "сообщения от бота (иначе за вами придут живые люди и начнут разбираться).\n"
    "\n"
    "Если вам не нравятся эти сообщения (или вы считаете их неуместными), "
    "напишите @natapolienko.\n"
    "Проблемы или улучшения в работе бота заносите тикетом в очередь DEVOPS. Спасибо!"
)


BASE_TG_TEXT_TEMPLATED = (
    "В этом инциденте **нет активности** более {silence_time} дней.\n"
    "\n"
    "Инцидент считается разобранным, если он признан проявлением проблемы или созданы тикеты на доработки, "
    "которые позволят избегать подобных инцидентов в дальнейшем.\n"
    "Пожалуйста, привяжите данный инцидент к проблеме, если подобное уже случалось ранее "
    "и исправление ведётся в рамках исправления проблемы.\n"
    "Если такое случилось впервые - пожалуйста, создайте тикеты на доработки, "
    "которые помогут избежать подобного в будущем. Для таких тикетов следует проставить тег "
    "spi:actionitem"
    " или перечислить их в описании тикета в разделе 'Меры предотвращения'.\n"
    "\n"
    "Следуйте devops-методологии:\n"
    "- Негативное воздействие **на пользователя** должно быть устранено.\n"
    "- **Причина** инцидента должна быть точно определена и задокументирована в описании тикета.\n"
    "Если у этого тикета нет исполнителя или исполнителем является уволенный сотрудник,"
    " пожалуйста, проставьте или смените исполнителя.\n"
    "Пожалуйста, не забудьте заполнить поле ydt.\n"
    "\n"
)

TEXT_WITHOUT_RESOLUTION = (
    "В этом инциденте не проставлена резолюция.\n"
    "Инцидент считается закрытым, когда резолюция проставлена.\n"
    "Как проставить резолюцию, если тикет уже закрыт - переоткрыть и закрыть заново.\n"
)

TEXT_EXISTS_SPPROBLEM = (
    "Данный тикет является частным случаем проблемы {spproblem_key}.\n"
    "Если вы уже закончили разбор данного тикета - закройте его, нажав кнопку 'закрыть'.\n"
    "\n"
)

TEXT_MAYBE_EXISTS_SPPROBLEM = (
    "Предполагается, что данный тикет является частным случаем проблемы {spproblem_key}.\n"
    "Пожалуйста, убедитесь в этом и измените тип связи с {spproblem_type_id} на 'Блокирует'.\n"
    "\n"
)

TEXT_EXISTS_ACTION_ITEMS = (
    "Для данного инцидента выделено {ai_count} Action Items.\n"
    "Если вы уже закончили разбор данного тикета - закройте его, нажав кнопку 'закрыть'.\n"
    "\n"
)

ACTION_ITEM_PING_TEMPLATE = (
    "Здесь нет активности более {silence_time} дней.\n"
    "Пожалуйста, займитесь этой задачей: она поможет избежать {incident} в будущем.\n"
    "Если у этого тикета нет исполнителя или исполнителем является уволенный сотрудник,"
    " пожалуйста, проставьте или смените исполнителя.\n"
    "Если не хотите, чтобы вас пинговал бот, выставьте разумный дедлайн тикету.\n"
    "По всем вопросам, касающимся бота обращаться к natapolienko@ (dmitryno@ или mvel@).\n"
    "Выполнено {sandbox_task_link}\n"
    "Если вам не нравятся эти сообщения (или вы считаете их неуместными), пожалуйста, "
    "напишите @natapolienko. Спасибо!\n"
    "Проблемы или улучшения в работе бота заносите тикетом в очередь DEVOPS. Спасибо!"
)


BASE_VIDEO_TEXT = (
    "Привет всем! Прошло много дней после инцидента. Пожалуйста:\n"
    "1) опишите влияние на пользователя - как проявилось, какой процент затронуто. "
    "Посчитайте даунтайм, если не работала какая-то функциональность.\n"

    "2) опишите причину инцидента, с подкреплением нужными графиками\n"

    "3) опишите шаги для недопущения повторения в будущем: "
    "нужно описать в тикете, завести и прилинковать action item "
    "(тикет, в котором будет проставлен тег spi:actionitem) **(ВАЖНО)** "
    "(например VIDEOPOISK13894)\n"

    "4) после 1-3 можно закрыть тикет как разобранный.\n"

    "5) если инцидент повторяющийся - нужно завести st/SPPROBLEM "
    "или к существующему SPP прилинковать инцидент (обязательно SPI должен быть в секции 'Blocker to' для SPP); "
    "для таких случаев SPI можно сразу закрывать. Например, SPPROBLEM262\n"

    "6) если SPI является дубликатом - можно закрыть как дубликат (не забыть закрыть "
    "именно как дубликат чтобы прилинковать корневой тикет)"
)

BASE_RTCSUPPORT_TEXT = (
    "В этой задаче не было никаких изменений уже {silence_time} дней. Пожалуйста, займитесь ей."
)

BASE_RESPONSIBLE_TEXT = RESPONSIBLE.format(
    devops_doc_link='https://nda.ya.ru/3Tvds7',
    alt_devops_master='mvel',
)
