PY23_LIBRARY()

OWNER(g:geotargeting)

PY_SRCS(
    __init__.py
    assets-testing.py
    build_layout.py
    builder.py
    filter-eu-ranges.py
    gen_layout.py
    ipreg-testing.py
    ipreg-testing-v6.py
    isp-testing.py
    maxmind_anon_data_processor.py
    maxmind_isp_data_processor.py
    merge_ranges.py
    replace_traits_by_idx.py
    team.py
    test_layout.py
    tor-testing.py
    utils_layout.py
    utils_proj_nets.py
)

PEERDIR(
    sandbox/projects/common/ya_deploy
    contrib/python/ipaddr
)

SET(CUR_DIR "sandbox/projects/geobase/common")

RESOURCE(
    borders-section-unstable.sh ${CUR_DIR}/borders-section-unstable.sh
    check-borders-windows.py ${CUR_DIR}/check-borders-windows.py
    check-iso-codes.py ${CUR_DIR}/check-iso-codes.py
    check-lings.py ${CUR_DIR}/check-lings.py
    extract-id-if-field.py ${CUR_DIR}/extract-id-if-field.py
    prepare-eu-list.py ${CUR_DIR}/prepare-eu-list.py

    LAAS-964.hosting+proxy+vpn-fix/check-is-old-in-new-region.py ${CUR_DIR}/LAAS-964.hosting+proxy+vpn-fix/check-is-old-in-new-region.py
    LAAS-964.hosting+proxy+vpn-fix/check-reg_id-mismatch-by-json.py ${CUR_DIR}/LAAS-964.hosting+proxy+vpn-fix/check-reg_id-mismatch-by-json.py
    LAAS-964.hosting+proxy+vpn-fix/prepare-maxmind-data.py ${CUR_DIR}/LAAS-964.hosting+proxy+vpn-fix/prepare-maxmind-data.py
    LAAS-1981.check-regions-centers.py ${CUR_DIR}/LAAS-1981.check-regions-centers.py
    LIB-775.check-removed-regions-borders.py ${CUR_DIR}/LIB-775.check-removed-regions-borders.py
    LIB-776.check-dangling-regions.py ${CUR_DIR}/LIB-776.check-dangling-regions.py
    LIB-795/add_fake_ranges.py ${CUR_DIR}/LIB-795/add_fake_ranges.py
    LIB-795/cidr2long.py ${CUR_DIR}/LIB-795/cidr2long.py
    LIB-795/merge_ranges.py ${CUR_DIR}/LIB-795/merge_ranges.py
    LIB-871.check-en-ling.py ${CUR_DIR}/LIB-871.check-en-ling.py
    common.sh ${CUR_DIR}/common.sh
    export/export2yt.py ${CUR_DIR}/export2yt.py
    geodata-treeling-stable.sh ${CUR_DIR}/geodata-treeling-stable.sh
    geodata-treeling-testing.sh ${CUR_DIR}/geodata-treeling-testing.sh
    geodata4-stable.sh ${CUR_DIR}/geodata4-stable.sh
    geodata4-testing.sh ${CUR_DIR}/geodata4-testing.sh
    geodata5-common.sh ${CUR_DIR}/geodata5-common.sh
    geodata5-stable.sh ${CUR_DIR}/geodata5-stable.sh
    geodata5-testing.sh ${CUR_DIR}/geodata5-testing.sh
    geodata5-xurma-stable.sh ${CUR_DIR}/geodata5-xurma-stable.sh
    geodata6-common.sh ${CUR_DIR}/geodata6-common.sh
    geodata6-cutted-common.sh ${CUR_DIR}/geodata6-cutted-common.sh
    geodata6-unstable.sh ${CUR_DIR}/geodata6-unstable.sh
    geodata6-nomm-stable.sh ${CUR_DIR}/geodata6-nomm-stable.sh
    geodata6-purecountry-stable.sh ${CUR_DIR}/geodata6-purecountry-stable.sh
    geodata6-stable.sh ${CUR_DIR}/geodata6-stable.sh
    geodata6-testing.sh ${CUR_DIR}/geodata6-testing.sh
    geodata6-balancer-stable.sh ${CUR_DIR}/geodata6-balancer-stable.sh
    geodata6-xurma-stable.sh ${CUR_DIR}/geodata6-xurma-stable.sh
    geodata6-quasar-stable.sh ${CUR_DIR}/geodata6-quasar-stable.sh
    geodb-stable.sh ${CUR_DIR}/geodb-stable.sh
    geodb-testing.sh ${CUR_DIR}/geodb-testing.sh
    iso-alpha3.list ${CUR_DIR}/iso-alpha3.list
    ipreg-yandex-stable.sh ${CUR_DIR}/ipreg-yandex-stable.sh
    ipreg-yandex-testing.sh ${CUR_DIR}/ipreg-yandex-testing.sh
    prepare_full_patch.sh ${CUR_DIR}/prepare_full_patch.sh
    LAAS-964.hosting+proxy+vpn-fix/build-patch.sh ${CUR_DIR}/LAAS-964.hosting+proxy+vpn-fix/build-patch.sh
    LIB-795/READ.ME ${CUR_DIR}/LIB-795/READ.ME
    LIB-795/make_networks.sh ${CUR_DIR}/LIB-795/make_networks.sh
)

END()

RECURSE(
    export
)
