from sandbox.projects import resource_types
from sandbox.projects.common.build.YaPackage import YaPackage as build_task

from sandbox.projects.common.geosearch.indexing import generate_base_update_task

BaseUpdate = generate_base_update_task(build_task=build_task,
                                       index_type_for_timestamp=resource_types.GEOSEARCH_FACTOR_COMPARE,
                                       release_subject="Auto released ya package",
                                       inherit_notifications=True, force_rebuild=True)


class UpdateFactorComparer(BaseUpdate):
    """
        Update factor comparer
    """
    type = 'UPDATE_FACTOR_COMPARER'
    cores = 1


__Task__ = UpdateFactorComparer
