from sandbox import sdk2
from sandbox.projects.sandbox.resources import LXC_CONTAINER

HOME_RELEASERS = ['HOME_RELEASERS']
ETHER_RELEASERS = ['ETHER_RELEASERS']


class TuneBuildagentTrustyLxc(LXC_CONTAINER):
    releasable = True
    releasers = HOME_RELEASERS


class TuneBuildagentXenialLxc(LXC_CONTAINER):
    releasable = True
    releasers = HOME_RELEASERS


class HomeXenialBuildagentLxc(LXC_CONTAINER):
    releasable = True
    releasers = HOME_RELEASERS


class HomeTrustyBuildagentLxc(LXC_CONTAINER):
    releasable = True
    releasers = HOME_RELEASERS


class HomePreciseBuildagentLxc(LXC_CONTAINER):
    releasable = True
    releasers = HOME_RELEASERS


class HomeNginxStaticFiles(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class HomeCleanvarsPythonTestsLxc(LXC_CONTAINER):
    releasable = True
    releasers = HOME_RELEASERS


class HomeAllureReport(sdk2.Resource):
    releasable = False


class PortalEtherResourceTarball(sdk2.Resource):
    version = sdk2.Attributes.String("Version")


class PortalEtherTmplTarball(PortalEtherResourceTarball):
    releasable = True
    releasers = ETHER_RELEASERS


class PortalEtherTmplBetaTarball(PortalEtherResourceTarball):
    releasable = True
    releasers = ETHER_RELEASERS
    instance = sdk2.parameters.String("Instance")


class PortalEtherFrontTarball(PortalEtherResourceTarball):
    releasable = True
    releasers = ETHER_RELEASERS


class PortalEtherFrontBetaTarball(PortalEtherResourceTarball):
    releasable = True
    releasers = ETHER_RELEASERS
    instance = sdk2.parameters.String("Instance")


class PortalMordaResourceTarball(sdk2.Resource):
    version = sdk2.Attributes.String("Version")


class TuneAppTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class TuneAppConfig(PortalMordaResourceTarball):
    """Tune configuration"""
    releasable = True
    releasers = HOME_RELEASERS

class TuneAppBetaTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class TuneAppConfigBeta(PortalMordaResourceTarball):
    """Tune beta configuration"""
    releasable = True
    releasers = HOME_RELEASERS


class lgV2AppTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class PortalMordaWboxdbTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class operaTvAppTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class oldTuneSuggestStubTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class wyWidgetsTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class PortalMordaFrontTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class PortalMordaFrontBetaTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS
    instance = sdk2.parameters.String("Instance")


class PortalMordaTmplSkinsTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class PortalMordaTmplSkinsBetaTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS
    instance = sdk2.parameters.String("Instance")


class PortalMordaTmplTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class PortalMordaTmplBetaTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS
    instance = sdk2.parameters.String("Instance")


class PortalMordaExportPullerTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class PortalMordaAdminTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class PortalMordaTrafficForecastTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class PortalMordaInstancectlConf(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class PortoLayerHomeMordaXenial(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortoLayerHomeMordaExportsXenial(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortoLayerHomeMordaBuildXenial(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortoLayerHomeTuneTrusty(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortoLayerHomeTuneXenial(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortoLayerHomeGeohelperXenial(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortoLayerHomeClickhouseXenial(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortoLayerHomeZookeeperXenial(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortoLayerHomeLogshatterXenial(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS

class PortoLayerHomeGreenboxXenial(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortalHomeBuildTools(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PumpiCache(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PumpiApp(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortoLayerHomePumpiXenial(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class StarlogApp(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortoLayerHomeStarlogXenial(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class YandexPortalPostcardsTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class YandexPortalGeohelperTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class PortalStocksTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class PortalRssStorageTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class PortalXivaTarball(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class PortoLayerHomeMocksXenial(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortalMordaMocksApi(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortalMordaMocksWeb(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortalMordaJugglerBundle(PortalMordaResourceTarball):
    releasable = True
    releasers = HOME_RELEASERS


class PortalYandexAllServices(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortalMordaCppTarball(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortalMordaGoTarball(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortalAvocadoTarball(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortalCiTestingResource(sdk2.Resource):
    releasable = True
    releasers = ['dbeliakov', 'robot-morda-dev']


class PortalGreenboxTarball(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortalGreenboxCommonTarball(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortalWunderwaffeTarball(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortalMadmTarball(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS


class PortalWdevxResolver(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS

class PortalMapAddrTarball(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS

class PortalCacherTarball(sdk2.Resource):
    releasable = True
    releasers = HOME_RELEASERS
