# coding: utf-8
from sandbox.projects import resource_types
from sandbox.projects.images import resource_types as images_resource_types
from sandbox.projects.common.mediasearch.online import task
from sandbox.sandboxsdk import environments
import control


@task.empower(control.ImagesExamineThumbsIntegrity)
class ImagesExamineThumbsIntegrity(task.BaseOnlineTask):
    input_resource_type = resource_types.IMAGES_THUMBS_PLAN
    input_resource_description = "Thumbs plan"
    ignore_built_output_flag = False
    output_resource_type = images_resource_types.IMAGES_THUMBS_CHECKSUMS

    environment = (environments.PipEnvironment('Pillow'),)


__Task__ = ImagesExamineThumbsIntegrity
