from sandbox.projects.common import sanitizer
from sandbox.projects.common.search import components as search_components
from sandbox.projects.images.daemons import task as daemons_task
from sandbox.projects.images.daemons import ImagesTestCbirdaemon2Performance as performance_task


_BASE_CLASS = sanitizer.generate_task(
    daemons_task.CBIRDAEMON_PARAMS,
    performance_task.ImagesTestCbirdaemon2Performance,
    start_timeout=search_components.DEFAULT_START_TIMEOUT * 4
)


class ImagesTestCbirdaemon2Sanitizer(_BASE_CLASS):
    type = 'IMAGES_TEST_CBIRDAEMON2_SANITIZER'


__Task__ = ImagesTestCbirdaemon2Sanitizer
