from sandbox.projects.common import sanitizer
from sandbox.projects.common.search import components as search_components
from sandbox.projects.images.daemons import task as daemons_task
from sandbox.projects.images.daemons import ImagesTestNaildaemonPerformance as performance_task


_BASE_CLASS = sanitizer.generate_task(
    daemons_task.NAILDAEMON_PARAMS,
    performance_task.ImagesTestNaildaemonPerformance,
    start_timeout=search_components.DEFAULT_START_TIMEOUT * 4
)


class ImagesTestNaildaemonSanitizer(_BASE_CLASS):
    type = 'IMAGES_TEST_NAILDAEMON_SANITIZER'


__Task__ = ImagesTestNaildaemonSanitizer
