PY2_LIBRARY()

OWNER(
    g:iss
)

SET(PROJ_DIR "sandbox/projects/iss")

PEERDIR(
    sandbox/projects/porto/common
    ${PROJ_DIR}/build_qemu_image_iss_local
    ${PROJ_DIR}/build_qloud_hfsm_service
    ${PROJ_DIR}/build_yp_cauth_export_service
    ${PROJ_DIR}/build_yp_export_service
    ${PROJ_DIR}/build_yp_hfsm_service
    ${PROJ_DIR}/build_yp_pdns_backend
    ${PROJ_DIR}/import_cacher_hooks_and_configs
    ${PROJ_DIR}/import_meta_capi_jar
    ${PROJ_DIR}/import_skymap_jar
    ${PROJ_DIR}/import_yp_microservices
    ${PROJ_DIR}/build_qloud_manager
    ${PROJ_DIR}/build_qemu_image_iss_teamcity
)

PY_SRCS(
    __init__.py
    build_qloud_hfsm_service/__init__.py
    build_yp_cauth_export_service/__init__.py
    build_yp_export_service/__init__.py
    build_yp_hfsm_service/__init__.py
    build_yp_pdns_backend/__init__.py
    import_cacher_hooks_and_configs/__init__.py
    import_meta_capi_jar/__init__.py
    import_skymap_jar/__init__.py
    import_yp_microservices/__init__.py
    build_qemu_image_iss_local/__init__.py
    build_qemu_image_iss_teamcity/__init__.py
    build_qloud_manager/__init__.py
)

END()

RECURSE(
    build_yp_hfsm_service
    build_yp_export_service
    build_yp_pdns_backend
    import_meta_capi_jar
    import_yp_microservices
    build_yp_cauth_export_service
    build_qloud_hfsm_service
    import_skymap_jar
    import_cacher_hooks_and_configs
    build_qemu_image_iss_local
    build_qemu_image_iss_teamcity
    build_qloud_manager
)
