USE marketclickhouse;

SELECT
    period_start,
    round(SUM(page_count / total_count * resp_95), 2) AS weighted_resp_95
FROM (
    SELECT
        date as period_start,
        count(*) as total_count
    FROM
        market.nesu_nginx
    PREWHERE
        period_start = today() - {delta_in_days}
        AND environment = 'PRODUCTION'
    WHERE
        url LIKE '/back-office/business%'
        OR url LIKE '/back-office/partner%'
    GROUP BY period_start
) as total
JOIN (
    SELECT
        date as period_start,
        page_id,
        quantileExact(0.95)(resptime_ms) AS resp_95,
        count(*) as page_count
    FROM
        market.nesu_nginx
    PREWHERE
        period_start = today() - {delta_in_days}
        AND environment = 'PRODUCTION'
    WHERE
        url LIKE '/back-office/business%'
       OR url LIKE '/back-office/partner%'
    GROUP BY
        period_start,
        page_id
) as page ON page.period_start = total.period_start
GROUP BY
    period_start
ORDER BY
    period_start ASC
;
