PY23_LIBRARY()

OWNER(g:market-logistics-reporter)

PY_SRCS(
    __init__.py

    metrics/__init__.py
    metrics/metrics.py
    metrics/metric_factory.py

    repository/__init__.py
    repository/exception.py
    repository/metrics_repository.py
    repository/clickhouse.py
    repository/helpers.py

    repository/yt.py
    repository/migrations.py

    template/__init__.py
    template/exception.py
    template/template.py

    startrek/__init__.py
    startrek/startrek.py
)

RESOURCE(
    template/table.html template/table.html

    query/clickhouse/tpl-int-partner-timings.sql query/clickhouse/tpl-int-partner-timings.sql
    query/clickhouse/tpl_int_partner_5xx_count.sql query/clickhouse/tpl_int_partner_5xx_count.sql

    query/clickhouse/tpl-int-parnter-timing-critical.sql query/clickhouse/tpl-int-parnter-timing-critical.sql
    query/clickhouse/tpl_int_partner_5xx_count_critial.sql query/clickhouse/tpl_int_partner_5xx_count_critial.sql

    query/clickhouse/tpl_int_delivery_service_api_timings.sql query/clickhouse/tpl_int_delivery_service_api_timings.sql
    query/clickhouse/tpl_int_delivery_service_api_5xx_count.sql query/clickhouse/tpl_int_delivery_service_api_5xx_count.sql

    query/clickhouse/tpl_int_tracking_timings.sql query/clickhouse/tpl_int_tracking_timings.sql
    query/clickhouse/tpl_int_tracking_5xx_count.sql query/clickhouse/tpl_int_tracking_5xx_count.sql

    query/clickhouse/tpl_api_timings.sql query/clickhouse/tpl_api_timings.sql
    query/clickhouse/tpl_api_5xx_count.sql query/clickhouse/tpl_api_5xx_count.sql

    query/clickhouse/timings_pvz.sql query/clickhouse/timings_pvz.sql
    query/clickhouse/pvz_5xx.sql query/clickhouse/pvz_5xx.sql

    query/clickhouse/pvz_int_nginx_timings.sql query/clickhouse/pvz_int_nginx_timings.sql
    query/clickhouse/pvz_int_partner_500.sql query/clickhouse/pvz_int_partner_500.sql

    query/clickhouse/timings_sc.sql query/clickhouse/timings_sc.sql
    query/clickhouse/sc_5xx.sql query/clickhouse/sc_5xx.sql

    query/clickhouse/sc_int_nginx_timings.sql query/clickhouse/sc_int_nginx_timings.sql
    query/clickhouse/sc_int_parter_5xx_count.sql query/clickhouse/sc_int_parter_5xx_count.sql

    query/clickhouse/sc_api_nginx_scan_timings.sql query/clickhouse/sc_api_nginx_scan_timings.sql
    query/clickhouse/sc_api_5xx_scan_count.sql query/clickhouse/sc_api_5xx_scan_count.sql

    query/clickhouse/tracker_put_track_5xx_count.sql query/clickhouse/tracker_put_track_5xx_count.sql
    query/clickhouse/tracker_put_track_timings.sql query/clickhouse/tracker_put_track_timings.sql

    query/clickhouse/combinator.sql query/clickhouse/combinator.sql
    query/clickhouse/tracker_push_status_5xx_count.sql query/clickhouse/tracker_push_status_5xx_count.sql
    query/clickhouse/tracker_push_status_timings.sql query/clickhouse/tracker_push_status_timings.sql
    query/clickhouse/nesu_timings.sql query/clickhouse/nesu_timings.sql
    query/clickhouse/nesu_5xx_count.sql query/clickhouse/nesu_5xx_count.sql
    query/clickhouse/tracker_crit_timings.sql query/clickhouse/tracker_crit_timings.sql
    query/clickhouse/tracker_express_crit_timings.sql query/clickhouse/tracker_express_crit_timings.sql
    query/clickhouse/tracker_go_crit_timings.sql query/clickhouse/tracker_go_crit_timings.sql
    query/clickhouse/tracker_mk_crit_timings.sql query/clickhouse/tracker_mk_crit_timings.sql
    query/clickhouse/tracker_pvz_crit_timings.sql query/clickhouse/tracker_pvz_crit_timings.sql
    query/clickhouse/tracker_sc_crit_timings.sql query/clickhouse/tracker_sc_crit_timings.sql

    query/clickhouse/courier_into_pi_timings.sql query/clickhouse/courier_into_pi_timings.sql
    query/clickhouse/courier_into_pi_5xx.sql query/clickhouse/courier_into_pi_5xx.sql
    query/clickhouse/courier_calc_and_publish_time.sql query/clickhouse/courier_calc_and_publish_time.sql

    query/clickhouse/mqm_over_lom_timings.sql query/clickhouse/mqm_over_lom_timings.sql
    query/clickhouse/mqm_over_lom_penalty.sql query/clickhouse/mqm_over_lom_penalty.sql

    query/clickhouse/mqm_timings.sql query/clickhouse/mqm_timings.sql
    query/clickhouse/mqm_penalty.sql query/clickhouse/mqm_penalty.sql
    query/clickhouse/mqm_delay.sql query/clickhouse/mqm_delay.sql

    query/clickhouse/tpl_int_modify_timings.sql query/clickhouse/tpl_int_modify_timings.sql
    query/clickhouse/tpl_int_modify_5xx_count.sql query/clickhouse/tpl_int_modify_5xx_count.sql

    query/clickhouse/apiresolve_5xx_sc.sql query/clickhouse/apiresolve_5xx_sc.sql
    query/clickhouse/apiresolve_5xx_pvz.sql query/clickhouse/apiresolve_5xx_pvz.sql
    query/clickhouse/apiresolve_5xx_courier.sql query/clickhouse/apiresolve_5xx_courier.sql

    query/clickhouse/capacity_overflow.sql query/clickhouse/capacity_overflow.sql

    query/yt/pickup_point_availability.sql query/yt/pickup_point_availability.sql
    query/yt/after_cutoff_stats.sql query/yt/after_cutoff_stats.sql

    query/clickhouse/carrier_pi_5xx.sql query/clickhouse/carrier_pi_5xx.sql
    query/clickhouse/carrier_pi_timings.sql query/clickhouse/carrier_pi_timings.sql
    query/clickhouse/carrier_partner_nginx_5xx_count.sql query/clickhouse/carrier_partner_nginx_5xx_count.sql
    query/clickhouse/carrier_partner_nginx_timings.sql query/clickhouse/carrier_partner_nginx_timings.sql
    query/clickhouse/carrier_api_nginx_5xx_count.sql query/clickhouse/carrier_api_nginx_5xx_count.sql
    query/clickhouse/carrier_api_nginx_timings.sql query/clickhouse/carrier_api_nginx_timings.sql

    query/clickhouse/crash_free_sc.sql query/clickhouse/crash_free_sc.sql
    query/clickhouse/crash_free_courier.sql query/clickhouse/crash_free_courier.sql
    query/clickhouse/crash_free_magistral.sql query/clickhouse/crash_free_magistral.sql

    query/clickhouse/postamat_backoffice_5xx.sql query/clickhouse/postamat_backoffice_5xx.sql
    query/clickhouse/postamat_backoffice_timings.sql query/clickhouse/postamat_backoffice_timings.sql
    query/clickhouse/postamat_courier_api_5xx.sql query/clickhouse/postamat_courier_api_5xx.sql
    query/clickhouse/postamat_courier_api_timings.sql query/clickhouse/postamat_courier_api_timings.sql
    query/clickhouse/postamat_ds_api_5xx.sql query/clickhouse/postamat_ds_api_5xx.sql
    query/clickhouse/postamat_ds_api_timings.sql query/clickhouse/postamat_ds_api_timings.sql
    query/clickhouse/postamat_pincode_api_5xx.sql query/clickhouse/postamat_pincode_api_5xx.sql
    query/clickhouse/postamat_pincode_api_timings.sql query/clickhouse/postamat_pincode_api_timings.sql
    query/clickhouse/postamat_postamat_api_5xx.sql query/clickhouse/postamat_postamat_api_5xx.sql
    query/clickhouse/postamat_postamat_api_timings.sql query/clickhouse/postamat_postamat_api_timings.sql
    query/yt/postamat_availability.sql query/yt/postamat_availability.sql

    migrations/0001-initial.py.dist 0001-initial.py
    migrations/0002-filling-streams.py.dist 0002-filling-streams.py
    migrations/0003-filling-groups.py.dist 0003-filling-groups.py
    migrations/0004-filling-metrics.py.dist 0004-filling-metrics.py
    migrations/0005-history-index-create.py.dist 0005-history-index-create.py
    migrations/0006-add-sc-pvz-ajax.py.dist 0006-add-sc-pvz-ajax.py
    migrations/0007-update-route-plan.py.dist 0007-update-route-plan.py
    migrations/0008-rename-errors-metric.py.dist 0008-rename-errors-metric.py
    migrations/0009-mqm-brand-new.py.dist 0009-mqm-brand-new.py
    migrations/0010-add-resources-table.py.dist 0010-add-resources-table.py
    migrations/0011-filling-resources-table.py.dist 0011-filling-resources-table.py
    migrations/0012-fix-capacity-metrics-unit.py.dist 0012-fix-capacity-metrics-unit.py
    migrations/0013-fix-mqm-metrics-name.py.dist 0013-fix-mqm-metrics-name.py
    migrations/0014-courier-ajax.py.dist 0014-courier-ajax.py
    migrations/0015-pvz-invisible-points.py.dist 0015-pvz-invisible-points.py
    migrations/0016-add-active-column.py.dist 0016-add-active-column.py
    migrations/0017-fix-sequence.py.dist 0017-fix-sequence.py
    migrations/0018-add-yt-resource-type.py.dist 0018-add-yt-resource-type.py
    migrations/0019-add-pickup-point-availability.py.dist 0019-add-pickup-point-availability.py
    migrations/0020-update-metrics-with-percent.py.dist 0020-update-metrics-with-percent.py
    migrations/0021-add-pvz-sla-metrics.py.dist 0021-add-pvz-sla-metrics.py
    migrations/0022-add-pvz-unavail-metrics.py.dist 0022-add-pvz-unavail-metrics.py
    migrations/0023-add-orders-after-cutoff-metrics.py.dist 0023-add-orders-after-cutoff-metrics.py
    migrations/0024-update-orders-after-cutoff-metrics.py.dist 0024-update-orders-after-cutoff-metrics.py
    migrations/0025-add-delays-after-cutoff-metrics.py.dist 0025-add-delays-after-cutoff-metrics.py
    migrations/0026-update-mqm-metrics.py.dist 0026-update-mqm-metrics.py
    migrations/0027-update-tracker-metrics.py.dist 0027-update-tracker-metrics.py
    migrations/0028-add-linehaul.py.dist 0028-add-linehaul.py
    migrations/0029-courier-routing-calc-and-publish-time.py.dist 0029-courier-routing-calc-and-publish-time.py
    migrations/0030-add-linehaul-app-crash-free.py.dist 0030-add-linehaul-app-crash-free.py
    migrations/0031-up-pickup-point-availability.py.dist 0031-up-pickup-point-availability.py
    migrations/0032-add-postamat.py.dist 0032-add-postamat.py
    migrations/0033-add-period.py.dist 0033-add-period.py
    migrations/0034-rename-pi-metrics.py.dist 0034-rename-pi-metrics.py
    migrations/0035-add-capacity-overflow.py.dist 0035-add-capacity-overflow.py
    migrations/0036-add-crash-free-sc.py.dist 0036-add-crash-free-sc.py
    migrations/0037-add-crash-free-courier.py.dist 0037-add-crash-free-courier.py
    migrations/0038-add-crash-free-magistral.py.dist 0038-add-crash-free-magistral.py
    migrations/0039-update-threshold-postamat.py.dist 0039-update-threshold-postamat.py
)

PEERDIR(
    sandbox/common
    sandbox/projects/common/binary_task
    sandbox/projects/common/environments
    library/python/startrek_python_client
    yql/library/python
)

END()
