# -*- coding: utf-8 -*-
import sandbox.common.types.client as ctc
from sandbox import sdk2

from sandbox.projects.modadvert.common import modadvert
from sandbox.projects.modadvert import resource_types


class ModadvertAntispamReverseAdapter(modadvert.ModadvertBaseRunSupermoderation):

    class Requirements(sdk2.Task.Requirements):
        client_tags = ctc.Tag.GENERIC

    class Parameters(modadvert.ModadvertBaseRunSupermoderation.Parameters):
        with sdk2.parameters.Group('Binary') as binary_group:
            binaries_resource = sdk2.parameters.Resource(
                'Resource with antispam reverse adapter binary',
                resource_type=[resource_types.MODADVERT_ANTISPAM_REVERSE_ADAPTER_BINARY],
                required=True
            )
