PY2_LIBRARY()

OWNER(g:modadvert)

PEERDIR(
    sandbox/sandboxsdk
    sandbox/projects/common/apihelpers
    sandbox/projects/common/build
    sandbox/projects/common/utils

    sandbox/projects/release_machine/input_params
    sandbox/projects/release_machine/helpers/startrek_helper

    sandbox/projects/release_machine/core
    sandbox/projects/release_machine/core/const
    sandbox/projects/release_machine/components

    sandbox/projects/BuildDockerImageV6_01
    sandbox/projects/yql/RunYQL2
    sandbox/projects/modadvert/MailingCircuit
    sandbox/projects/modadvert/resource_types
    sandbox/projects/modadvert/rm
)

SET(CUR_DIR "sandbox/projects/modadvert")
RESOURCE(
    CheckNewCircuit/yt_runner.py ${CUR_DIR}/CheckNewCircuit/yt_runner.py
    RunCupidMR/yt_runner.py ${CUR_DIR}/RunCupidMR/yt_runner.py
    TolokaAutobudget/test.py ${CUR_DIR}/TolokaAutobudget/test.py
    UpdateBannersCount/yt_runner.py ${CUR_DIR}/UpdateBannersCount/yt_runner.py
    common/ytutils.py ${CUR_DIR}/common/ytutils.py
)

PY_SRCS(
    AbuseDailyAggregator/__init__.py
    AbuseLogsProcessor/__init__.py
    AbuseLyncherResults/__init__.py
    AntispamAdapter/__init__.py
    AntispamReverseAdapter/__init__.py
    AntivirVerdictsLagMetrics/__init__.py
    BrandsClassifier/__init__.py
    BrandsClassifierCircuit/__init__.py
    BsPriorityThreshold/__init__.py
    BuildCupid/__init__.py
    BuildLaaS/__init__.py
    BuildLaaS/patch.py
    BuildTask/__init__.py
    CVIndexer/__init__.py
    CVRejectedMetrics/__init__.py
    CatalogiaFlagsDiff/__init__.py
    CheckNewCircuit/__init__.py
    ChunkMerger/__init__.py
    CleanData/__init__.py
    CleanSupermoderationRequests/__init__.py
    ClientDomainStat/__init__.py
    ClientFactors/__init__.py
    CreateSMDatabase/__init__.py
    CreateSMStaticTables/__init__.py
    DeployBrands/__init__.py
    DeployCupid/__init__.py
    DeployLyncher/__init__.py
    DeployQloudEnvironment/__init__.py
    DeployYDeployEnvironment/__init__.py
    DeployYDeployEnvironment/utils.py
    DeploySupermoderation/__init__.py
    DiffSMResults/__init__.py
    DynamicTableInserter/__init__.py
    EvilMisprintsStatistics/__init__.py
    FilterWidePhrases/__init__.py
    FindSpamNGramsBinary/__init__.py
    GetBannerManualResults/__init__.py
    GetManuallyModeratedRejects/__init__.py
    GetMatrixnetClientKarma/__init__.py
    GrepImgRejects/__init__.py
    LicensesDynamicInserter/__init__.py
    LogsChunkMerger/__init__.py
    LyncherReportVerdicts/__init__.py
    MailingCircuit/__init__.py
    MetricSimilarityIndexCollector/__init__.py
    ModadvertDeployTask/__init__.py
    ModerationAdapter/__init__.py
    Monika/__init__.py
    MordaClustering/__init__.py
    PriorityClients/__init__.py
    PushDockerImage/__init__.py
    ReplicaSwitcher/__init__.py
    RunBinaryWithConfig/__init__.py
    RunBroker/__init__.py
    RunComparison/__init__.py
    RunComparison/stat.py
    RunCupidMR/__init__.py
    RunLaaSMR/__init__.py
    RunLyncherSDK2/__init__.py
    RunManualAutobudget/__init__.py
    RunOfflineLyncherSDK2/__init__.py
    RunQLyncher/__init__.py
    RunSmBinary/__init__.py
    RunTransferManager/__init__.py
    SaasIndexer/__init__.py
    SaveSMResults/__init__.py
    SendCircuitLogMetrics/__init__.py
    SupermoderationB2B/__init__.py
    SupermoderationInstance/__init__.py
    TestCupidB2B/__init__.py
    TestLyncher/__init__.py
    TestRequestsGenerator/__init__.py
    TestSupermoderation/__init__.py
    TestSupermoderationB2B/__init__.py
    TolokaAutobudget/__init__.py
    UpdateAbusiveBanners/__init__.py
    UpdateBannerKarmaQuantiles/__init__.py
    UpdateBannersCount/__init__.py
    UpdateClientsWhiteList/__init__.py
    UpdateFlagsOfflineTablesManager/__init__.py
    UpdateMisprintsWhiteList/__init__.py
    WaitTeamcityBuild/__init__.py
    WhiteListSpamClient/__init__.py
    __init__.py
    common/__init__.py
    common/constants.py
    common/modadvert.py
    common/schedulers_ids.py
    common/utils.py
)

END()

RECURSE(
    BuildLaaS
    MailingCircuit
    RunComparison
    resource_types
    rm
)
