from sandbox import sdk2


class MssngrRuntimeResource(sdk2.Resource):
    releasers = ["thorfinn", "chmerev", "yamilov", "ivaxer", "manokk", "robot-srch-releaser", "deligor"]


class MssngrExecutableResource(MssngrRuntimeResource):
    executable = True
    releasable = True
    any_arch = False


class MssngrConfigResource(MssngrRuntimeResource):
    executable = False
    releasable = True
    any_arch = True


class MssngrRouterPartitionMap(MssngrConfigResource):
    pass


class MssngrRouterPrevPartitionMap(MssngrRouterPartitionMap):
    pass


class MssngrTestingRouterPrevPartitionMap(MssngrRouterPartitionMap):
    pass


class MssngrTestingRouterPartitionMap(MssngrRouterPartitionMap):
    pass


class MssngrAlphaRouterPrevPartitionMap(MssngrRouterPartitionMap):
    pass


class MssngrAlphaRouterPartitionMap(MssngrRouterPartitionMap):
    pass


class MssngrProductionRouterPrevPartitionMap(MssngrRouterPartitionMap):
    pass


class MssngrProductionRouterPartitionMap(MssngrRouterPartitionMap):
    pass


class MssngrRouterConfigGenerator(MssngrExecutableResource):
    pass


# balancer


class MssngrRouterBalancer(MssngrExecutableResource):
    pass


class MssngrRouterBalancerConfig(MssngrConfigResource):
    pass


class MssngrRouterBalancerTestingConfig(MssngrConfigResource):
    pass


class MssngrRouterBalancerAlphaConfig(MssngrConfigResource):
    pass


class MssngrRouterBalancerLoopConf(MssngrConfigResource):
    pass


class MssngrRouterBalancerTestingLoopConf(MssngrConfigResource):
    pass


class MssngrRouterBalancerAlphaLoopConf(MssngrConfigResource):
    pass


# worker


class MssngrRouterWorker(MssngrExecutableResource):
    pass


class MssngrRouterWorkerConfig(MssngrConfigResource):
    pass


class MssngrRouterWorkerTestingConfig(MssngrConfigResource):
    pass


class MssngrRouterWorkerAlphaConfig(MssngrConfigResource):
    pass


class MssngrRouterWorkerLoopConf(MssngrConfigResource):
    pass


class MssngrRouterWorkerTestingLoopConf(MssngrConfigResource):
    pass


class MssngrRouterWorkerAlphaLoopConf(MssngrConfigResource):
    pass


# state cache


class MssngrBstr(MssngrExecutableResource):
    pass


class MssngrRouterStateCacher(MssngrExecutableResource):
    version = sdk2.Attributes.String("State cache version")


class MssngrRouterStateCachePusher(MssngrExecutableResource):
    pass


class MssngrRouterStateCacheUpdater(MssngrExecutableResource):
    pass


class MssngrRouterStateCache(MssngrRuntimeResource):
    pass


# lb proxy


class MssngrRouterLbProxy(MssngrExecutableResource):
    pass


class MssngrRouterLbProxyConfig(MssngrConfigResource):
    pass


class MssngrRouterLbProxyLoopConf(MssngrConfigResource):
    pass


# lb subscriber


class MssngrRouterLbSubscriber(MssngrExecutableResource):
    pass


class MssngrRouterLbSubscriberConfig(MssngrConfigResource):
    pass


class MssngrRouterLbSubscriberLoopConf(MssngrConfigResource):
    pass


class MssngrRouterLbSubscriberTestingConfig(MssngrConfigResource):
    pass


class MssngrRouterLbSubscriberTestingLoopConf(MssngrConfigResource):
    pass


class MssngrRouterLbSubscriberAlphaConfig(MssngrConfigResource):
    pass


class MssngrRouterLbSubscriberAlphaLoopConf(MssngrConfigResource):
    pass


class MssngrRouterLbSubscriber2(MssngrExecutableResource):
    pass


class MssngrRouterLbSubscriber2Config(MssngrConfigResource):
    pass


class MssngrRouterLbSubscriber2TestingConfig(MssngrConfigResource):
    pass


class MssngrRouterLbSubscriber2AlphaConfig(MssngrConfigResource):
    pass


# cs server


class MssngrCsServer(MssngrExecutableResource):
    pass


class MssngrCsServerConfig(MssngrConfigResource):
    pass


class MssngrCsServerLoopConf(MssngrConfigResource):
    pass


# cs server rtc call feedback
class MssngrCsServerRtcCallFeedback(MssngrExecutableResource):
    pass


# metasearch


class MssngrGeobase(MssngrExecutableResource):
    pass


class MssngrMetasearch(MssngrExecutableResource):
    pass


class MssngrMetasearchConfig(MssngrConfigResource):
    pass


class MssngrMetasearchLoopConf(MssngrConfigResource):
    pass


class MssngrMetasearchTestingConfig(MssngrConfigResource):
    pass


class MssngrMetasearchTestingLoopConf(MssngrConfigResource):
    pass


class MssngrMetasearchAlphaConfig(MssngrConfigResource):
    pass


class MssngrMetasearchAlphaLoopConf(MssngrConfigResource):
    pass


# geo bot


class MssngrGeoBot(MssngrExecutableResource):
    pass


class MssngrGeoBotConfig(MssngrConfigResource):
    pass


class MssngrGeoBotLoopConf(MssngrConfigResource):
    pass


class MssngrGeoBotTestingConfig(MssngrConfigResource):
    pass


class MssngrGeoBotTestingLoopConf(MssngrConfigResource):
    pass


class MssngrGeoBotAlphaConfig(MssngrConfigResource):
    pass


class MssngrGeoBotAlphaLoopConf(MssngrConfigResource):
    pass


# gdpr data collector


class MssngrDataCollector(MssngrExecutableResource):
    pass


class MssngrDataCollectorConfig(MssngrConfigResource):
    pass


class MssngrDataCollectorLoopConf(MssngrConfigResource):
    pass


class MssngrDataCollectorTestingConfig(MssngrConfigResource):
    pass


class MssngrDataCollectorTestingLoopConf(MssngrConfigResource):
    pass


# registry


class MssngrRegistry(MssngrExecutableResource):
    pass


class MssngrRegistryLoopConf(MssngrConfigResource):
    pass


class MssngrRegistryInternalLoopConf(MssngrConfigResource):
    pass


class MssngrRegistryTestingLoopConf(MssngrConfigResource):
    pass


class MssngrRegistryAlphaLoopConf(MssngrConfigResource):
    pass


class MssngrRegistryInternalAlphaLoopConf(MssngrConfigResource):
    pass


class MssngrRegistryConfig(MssngrConfigResource):
    pass


class MssngrRegistryInternalConfig(MssngrConfigResource):
    pass


class MssngrRegistryAlphaConfig(MssngrConfigResource):
    pass


class MssngrRegistryInternalAlphaConfig(MssngrConfigResource):
    pass


class MssngrRegistryTestingConfig(MssngrConfigResource):
    pass


class MssngrYambConfLocalConfig(MssngrConfigResource):
    pass


class MssngrYambInternalConfLocalConfig(MssngrConfigResource):
    pass


class MssngrYambConfLocalAlphaConfig(MssngrConfigResource):
    pass


class MssngrYambInternalConfLocalAlphaConfig(MssngrConfigResource):
    pass


class MssngrYambConfLocalTestingConfig(MssngrConfigResource):
    pass


class MssngrContactsIndexer(MssngrExecutableResource):
    pass


# files + stickers


class MssngrFiles(MssngrExecutableResource):
    pass


class MssngrStickers(MssngrExecutableResource):
    pass


class MssngrFilesLoopConf(MssngrConfigResource):
    pass


class MssngrFilesTestingLoopConf(MssngrConfigResource):
    pass


class MssngrFilesAlphaLoopConf(MssngrConfigResource):
    pass


class MssngrFilesConfig(MssngrConfigResource):
    pass


class MssngrFilesAlphaConfig(MssngrConfigResource):
    pass


class MssngrFilesTestingConfig(MssngrConfigResource):
    pass


class MssngrStickersConfig(MssngrConfigResource):
    pass


class MssngrStickersAlphaConfig(MssngrConfigResource):
    pass


class MssngrStickersTestingConfig(MssngrConfigResource):
    pass


class MssngrFilesConfLocalConfig(MssngrConfigResource):
    pass


class MssngrFilesConfLocalAlphaConfig(MssngrConfigResource):
    pass


class MssngrFilesConfLocalTestingConfig(MssngrConfigResource):
    pass

# message viewer


class MssngrMessageViewer(MssngrExecutableResource):
    pass


class MssngrMessageViewerData(MssngrConfigResource):
    pass


class MssngrMessageViewerLoopConf(MssngrConfigResource):
    pass


# botplatform


class MssngrBotplatform(MssngrExecutableResource):
    pass


class MssngrBotplatformLoopConf(MssngrConfigResource):
    pass


class MssngrBotplatformAlphaLoopConf(MssngrConfigResource):
    pass


class MssngrBotplatformTestingLoopConf(MssngrConfigResource):
    pass


class MssngrBotplatformConfLocalConfig(MssngrConfigResource):
    pass


class MssngrBotplatformConfLocalAlphaConfig(MssngrConfigResource):
    pass


class MssngrBotplatformConfLocalTestingConfig(MssngrConfigResource):
    pass


class MssngrBotplatformData(MssngrConfigResource):
    pass


class MssngrBotplatformConfig(MssngrConfigResource):
    pass


# support gateway


class MssngrSupportGateway(MssngrExecutableResource):
    pass


class MssngrSupportGatewayConfig(MssngrConfigResource):
    pass


class MssngrSupportGatewayLoopConf(MssngrConfigResource):
    pass


class MssngrSupportGatewayAlphaConfig(MssngrConfigResource):
    pass


class MssngrSupportGatewayAlphaLoopConf(MssngrConfigResource):
    pass


class MssngrSupportGatewayTestingConfig(MssngrConfigResource):
    pass


class MssngrSupportGatewayTestingLoopConf(MssngrConfigResource):
    pass


# chat mirror


class MssngrChatMirror(MssngrExecutableResource):
    pass


class MssngrChatMirrorConfig(MssngrConfigResource):
    pass


class MssngrChatMirrorLoopConf(MssngrConfigResource):
    pass


class MssngrChatMirrorTestingConfig(MssngrConfigResource):
    pass


class MssngrChatMirrorTestingLoopConf(MssngrConfigResource):
    pass


# other resources


class MssngrNginxBinary(MssngrExecutableResource):
    pass


class MssngrJugglerChecks(MssngrConfigResource):
    pass


class MssngrJugglerPushClientChecks(MssngrConfigResource):
    pass


class MssngrJugglerCustomChecks(MssngrConfigResource):
    pass


class MssngrYdbTool(MssngrExecutableResource):
    pass


class MssngrYambCodeBundle(MssngrConfigResource):
    pass


class MssngrFilesCodeBundle(MssngrConfigResource):
    pass


class MssngrPortoLayer(MssngrConfigResource):
    pass


class MssngrCloseLocationTool(MssngrExecutableResource):
    pass
