# -*- coding: utf-8 -*-

from sandbox.projects.news import resources

from sandbox.projects.common.nanny import nanny
from sandbox.sandboxsdk.copy import RemoteCopy
from sandbox import sdk2

FILES = {
    "params_presets.json": "svn+ssh://arcadia.yandex.ru/arc/trunk/arcadia/yweb/news/services/app_host/routerd/params_presets.json"
}


class BuildNewsRouterdParamsPresets(nanny.ReleaseToNannyTask2, sdk2.Task):
    """
        Get params_presets.json
    """

    class Parameters(sdk2.Task.Parameters):
        svn_revision = sdk2.parameters.Integer("SVN revision", required=True)

    def download_file(self, src, dst):
        RemoteCopy(src, dst,
                   log_dir=self.log_path())(timeout=RemoteCopy.DEFAULT_TIMEOUT)

    def on_execute(self):
        for filename, src_path in FILES.iteritems():
            self.download_file(src_path + "@" + str(self.Parameters.svn_revision), filename)

        presets = sdk2.ResourceData(resources.NEWS_ROUTERD_PARAMS_PRESETS(self, "params_presets.json for api", "params_presets.json", ttl=28))
        presets.ready()
