import sandbox.sdk2 as sdk2
import sandbox.projects.quasar.resource_types as quasar_resource_types
import sandbox.projects.quasar.lxc_image_builds.base as base_lxc_image_build


class QuasarYandexSmartDeviceLxcImageBuild(base_lxc_image_build.BaseQuasarLxcImageBuild):
    class Parameters(base_lxc_image_build.BaseQuasarLxcImageBuild.Parameters):
        custom_image = sdk2.parameters.Bool("Create custom LXC image",
                                            default=True)

        custom_script = sdk2.parameters.String(
            "Shell script to execute during final stage",
            description="Will be copied to /custom.sh inside container and"
                        " started with '/bin/bash /custom.sh' inside chroot."
                        " Stdout of script could be found in shell.log",
            multiline=True,
            default=base_lxc_image_build.read_custom_script(__file__)
        )
        resource_type = sdk2.parameters.String(
            "Container resource type",
            default=quasar_resource_types.QuasarYandexSmartDeviceLxcImage.name)

        resource_description = sdk2.parameters.String(
            "Container resource's custom description",
            default="Common container for build android or sideload linux image")
