# -*- coding: utf-8 -*-
from sandbox.projects.release_machine.components import configs
from sandbox.projects.release_machine.components.configs.sb_tasks import _base as sb_cfg_base
from sandbox.projects.release_machine.components.config_core.jg import cube as jg_cube


class BannerLandFunnelHistoryCfg(sb_cfg_base.SandboxSingleTaskReleaseCfg):  # TODO remove this comment
    name = "bannerland_funnel_history"
    responsible = configs.Responsible(
        abc=configs.Abc(service_name="irt"),
        login="optozorax",
    )
    target_task_path = "irt/bannerland/sanbox_tasks/funnel_history"
    target_task_path_no_bin = target_task_path
    target_bin_name = "funnel_history"
    target_task_type = "BANNER_LAND_FUNNEL_HISTORY"
    target_task_ci_registry_location = "projects/irt/bannerland_funnel_history"
    release_to_stable_manually = True
    add_precommit_check = True

    @property
    def test_run_input(self):
        return jg_cube.CubeInput(
            binary_release_parameters="testing",
            yt_token="sec-01g4d9mp2q209szcq4v52fvztq",
            solomon_token="sec-01g4d9p2s4rejgeccyrp9sv222",
            task_count_limit=2000,
        )

    class CI(sb_cfg_base.SandboxSingleTaskReleaseCfg.CI):
        sb_owner_group = "BANNERLAND"
