# coding: utf8
from __future__ import absolute_import, division, print_function, unicode_literals

# alias for base class module is obligatory because of testenv specifics
import sandbox.projects.release_machine.components.configs.rasp._base_deploy as base_deploy
import sandbox.projects.release_machine.core.const as rm_const


class SuggestsCfg(base_deploy.RaspDeployCfg, base_deploy.FinalConfig):
    class CfgParams(base_deploy.RaspDeployCfg.CfgParams):
        DISPLAY_NAME = 'Rasp Suggests'
        NAME = 'rasp_suggests'

        RESPONSIBLE = 'lorekhov'

        PROJECT_PACKAGE_PATH = 'travel/rasp/suggests/pkg.json'
        APPLICATION_RESOURCE_NAME = 'RASP_SUGGESTS_BINARY'

        DEPLOY_APPLICATION = 'suggests'

        PROJECT_PATHS = ['travel/rasp/suggests']
        WIKI_PAGE = 'raspisanija/releases/suggests/'
        ST_RELEASE_SUMMARY_TEMPLATE = 'Релиз suggests {}'

        RELEASE_BUTTON_DEPLOY_STAGES = [
            rm_const.ReleaseStatus.stable,
        ]
