PY2_LIBRARY()

OWNER(g:release_machine)

PY_SRCS(
    __init__.py
)

PEERDIR(
    sandbox/projects/common
    sandbox/projects/release_machine/client
    sandbox/projects/release_machine/core
    sandbox/projects/release_machine/components
    sandbox/projects/release_machine/resources
    sandbox/projects/release_machine/security
    sandbox/projects/release_machine/rm_utils
    sandbox/projects/release_machine/rm_notify

    sandbox/projects/release_machine/tasks/AbExperimentsApprovementCreator
    sandbox/projects/release_machine/tasks/ArcMergesCrawler
    sandbox/projects/release_machine/tasks/base_task
    sandbox/projects/release_machine/tasks/BuildRmUi
    sandbox/projects/release_machine/tasks/CheckStartrekReleaseTicket
    sandbox/projects/release_machine/tasks/CheckTasksCorrectness
    sandbox/projects/release_machine/tasks/CleanupFailedReleaseAttempt
    sandbox/projects/release_machine/tasks/CloneTestenvDb
    sandbox/projects/release_machine/tasks/CommentStartrekTicket
    sandbox/projects/release_machine/tasks/CreateABTest
    sandbox/projects/release_machine/tasks/CreateBranchOrTag
    sandbox/projects/release_machine/tasks/CreateStartrekOkApprovement
    sandbox/projects/release_machine/tasks/CreateStartrekTicket
    sandbox/projects/release_machine/tasks/CreateStartrekTicket/bin
    sandbox/projects/release_machine/tasks/CreateWikiPage
    sandbox/projects/release_machine/tasks/FindBuildFromTrunk
    sandbox/projects/release_machine/tasks/GenerateYappyBeta
    sandbox/projects/release_machine/tasks/GetLastGoodRevision
    sandbox/projects/release_machine/tasks/GetReportSimultaneousResponses
    sandbox/projects/release_machine/tasks/GetTelegramAndQChatId
    sandbox/projects/release_machine/tasks/LaunchMetrics
    sandbox/projects/release_machine/tasks/LogMergesInStartrek
    sandbox/projects/release_machine/tasks/LogMergesInStartrek/bin
    sandbox/projects/release_machine/tasks/MergeToStable
    sandbox/projects/release_machine/tasks/MergeToStable/bin
    sandbox/projects/release_machine/tasks/MergeRollbackBaseTask
    sandbox/projects/release_machine/tasks/MoveStartrekTicket
    sandbox/projects/release_machine/tasks/PostStartrekComment
    sandbox/projects/release_machine/tasks/PrepareCiEnvironment
    sandbox/projects/release_machine/tasks/PrepareRmComponentEnvironment
    sandbox/projects/release_machine/tasks/PushServicesConfiguration
    sandbox/projects/release_machine/tasks/RearrangeAcceptance2
    sandbox/projects/release_machine/tasks/ReleaseMachineAutobranchCreator
    sandbox/projects/release_machine/tasks/ReleaseMachineBranchCheck
    sandbox/projects/release_machine/tasks/ReleaseMachineChangelog
    sandbox/projects/release_machine/tasks/ReleaseMachineChangelog/bin
    sandbox/projects/release_machine/tasks/ReleaseMachineCrawler
    sandbox/projects/release_machine/tasks/ReleaseMachineFunctionalTest
    sandbox/projects/release_machine/tasks/ReleaseMachineMergesCrawler
    sandbox/projects/release_machine/tasks/ReleaseMachineSiteMonitoring
    sandbox/projects/release_machine/tasks/ReleaseMachineStatCrawler
    sandbox/projects/release_machine/tasks/ReleaseMachineChatCrawler
    sandbox/projects/release_machine/tasks/ReleaseMachineConfigCrawler
    sandbox/projects/release_machine/tasks/ReleaseMonitorCrawlReleases
    sandbox/projects/release_machine/tasks/ReleaseMonitorCrawlTickets
    sandbox/projects/release_machine/tasks/ReleaseMachineGarbageCollector
    sandbox/projects/release_machine/tasks/ReleaseMonitorKpiAlert
    sandbox/projects/release_machine/tasks/ReleaseRmComponent
    sandbox/projects/release_machine/tasks/ReleaseRmComponent2
    sandbox/projects/release_machine/tasks/ReleaseRmFunctionalTest
    sandbox/projects/release_machine/tasks/ReleaseRmComponentAb
    sandbox/projects/release_machine/tasks/RenderReleaseGraph
    sandbox/projects/release_machine/tasks/RollbackCommit
    sandbox/projects/release_machine/tasks/RollbackCommit/bin
    sandbox/projects/release_machine/tasks/RunAlembicMigrations/bin
    sandbox/projects/release_machine/tasks/RunIceFlame
    sandbox/projects/release_machine/tasks/ScheduleRelease
    sandbox/projects/release_machine/tasks/ScheduleRelease/bin
    sandbox/projects/release_machine/tasks/ScrapeRequests2
    sandbox/projects/release_machine/tasks/SendTelegramMessages
    sandbox/projects/release_machine/tasks/SendEmail
    sandbox/projects/release_machine/tasks/SimpleChangelog
    sandbox/projects/release_machine/tasks/SimpleChangelog/bin
    sandbox/projects/release_machine/tasks/TestAllTdiAndRearrange
    sandbox/projects/release_machine/tasks/UpdateMetricsBasket
)

END()

RECURSE(
    AbExperimentsApprovementCreator
    ArcMergesCrawler
    base_task
    BuildRmUi
    CheckTasksCorrectness
    CheckStartrekReleaseTicket
    CleanupFailedReleaseAttempt
    CloneTestenvDb
    CommentStartrekTicket
    CreateABTest
    CreateBranchOrTag
    CreateStartrekTicket
    CreateStartrekOkApprovement
    CreateStartrekTicket/bin
    CreateWikiPage
    FindBuildFromTrunk
    GenerateYappyBeta
    GetLastGoodRevision
    GetReportSimultaneousResponses
    GetTelegramAndQChatId
    GetTelegramAndQChatId/bin
    LaunchMetrics
    LogMergesInStartrek
    LogMergesInStartrek/bin
    MergeToStable
    MergeToStable/bin
    MergeRollbackBaseTask
    MoveStartrekTicket
    PostStartrekComment
    PrepareCiEnvironment
    PrepareRmComponentEnvironment
    PushServicesConfiguration
    RearrangeAcceptance2
    ReleaseMachineAutobranchCreator
    ReleaseMachineBranchCheck
    ReleaseMachineChangelog
    ReleaseMachineChangelog/bin
    ReleaseMachineCrawler
    ReleaseMachineFunctionalTest
    ReleaseMachineMergesCrawler
    ReleaseMachineSiteMonitoring
    ReleaseMonitorCrawlReleases
    ReleaseMonitorCrawlTickets
    ReleaseMonitorKpiAlert
    ReleaseRmComponent
    ReleaseRmComponent2
    ReleaseRmFunctionalTest
    ReleaseRmComponentAb
    RenderReleaseGraph
    RollbackCommit
    RollbackCommit/bin
    RunAlembicMigrations
    RunIceFlame
    ScheduleRelease
    ScrapeRequests2
    SendTelegramMessages
    SendEmail
    SimpleChangelog
    SimpleChangelog/bin
    TestAllTdiAndRearrange
    UpdateMetricsBasket
)
