PY2_LIBRARY()

OWNER(
    g:rtmr
)

SET(RTMR "sandbox/projects/rtmr")

PEERDIR(
    sandbox/sandboxsdk
    sandbox/projects/common/arcadia
    sandbox/projects/common/build
    sandbox/projects/common/constants
    sandbox/projects/juggler/resource_types
    sandbox/projects/geobase
    sandbox/projects/yf
    ${RTMR}/BuildYDBToSolomonMetricsExporter
)

PY_SRCS(
    RtmrApplyMirrorConfig/__init__.py
    RtmrApplySourcesConfig/__init__.py
    RtmrApplyUsertaskConfig/__init__.py
    RtmrBuildCommonUserdata/__init__.py
    RtmrBuildDaemonsConfig/__init__.py
    RtmrBuildGraph/__init__.py
    RtmrBuildGraphConfig/__init__.py
    RtmrBuildMirrorsConfig/__init__.py
    RtmrBuildPackage/__init__.py
    RtmrBuildSourcesConfig/__init__.py
    RtmrBuildSystemTasks/__init__.py
    RtmrBuildTools/__init__.py
    RtmrBuildUsertask/__init__.py
    RtmrBuildUsertaskConfig/__init__.py
    RtmrCleanupUsertaskYF/__init__.py
    RtmrClusterBackup/__init__.py
    RtmrDeploy/__init__.py
    RtmrDeployGraphYF/__init__.py
    RtmrDeployUsertaskYF/__init__.py
    RtmrDeployZ2/__init__.py
    RtmrDiffMirrorConfig/__init__.py
    RtmrDiffSourcesConfig/__init__.py
    RtmrDiffUsertaskConfig/__init__.py
    RtmrDutySwitch/__init__.py
    RtmrGraphDeploy/__init__.py
    RtmrGraphRelease/__init__.py
    RtmrMetaDeployGraph/__init__.py
    RtmrMetaDeployUsertask/__init__.py
    RtmrMultiDeployGraph/__init__.py
    RtmrMultiDeployUsertask/__init__.py
    RtmrPrepareUsertasksReleaseMeta/__init__.py
    RtmrRelease/__init__.py
    RtmrRestartHost/__init__.py
    RtmrRollbackUsertaskYF/__init__.py
    RtmrRollingRestart/__init__.py
    RtmrRunJugglerPlaybook/__init__.py
    RtmrSearchAcceptTablesSwitch/__init__.py
    RtmrUpdateQuoterConfig/__init__.py
    RtmrUpdateSolomonTriggers/__init__.py
    RtmrUploadFromYt/__init__.py
    RtmrUploadToYF/__init__.py
    RtmrUserDeploy/__init__.py
    RtmrUserRelease/__init__.py
    __init__.py
    accounts.py
    clusters.py
    common.py
    resources.py
    singleton.py
)

END()

RECURSE(
    RtmrApplyUsertaskConfig
    RtmrBuildCommonUserdata
    RtmrBuildDaemonsConfig
    RtmrBuildGraph
    RtmrBuildPackage
    RtmrBuildTools
    RtmrBuildUsertask
    RtmrClusterBackup
    RtmrDeploy
    RtmrDeployGraphYF
    RtmrDeployZ2
    RtmrDeployUsertaskYF
    RtmrDiffUsertaskConfig
    RtmrDutySwitch
    RtmrGraphRelease
    RtmrPrepareUsertasksReleaseMeta
    RtmrRelease
    RtmrRestartHost
    RtmrRollingRestart
    RtmrRunJugglerPlaybook
    RtmrSearchAcceptTablesSwitch
    RtmrUpdateQuoterConfig
    RtmrUpdateSolomonTriggers
    RtmrUploadFromYt
    RtmrUploadToYF
    RtmrUserRelease
    BuildYDBToSolomonMetricsExporter
)
