# -*- coding: utf-8 -*-
from sandbox import sdk2
from sandbox.projects.common.build.tasks import YaMakeTemplate
from sandbox.projects.common.ya_deploy import release_integration
import sandbox.projects.runtime_models.components.yabs.resources as yabs_resources


class BuildCaesarModelsDaemons(release_integration.ReleaseToNannyAndYaDeployTask2, YaMakeTemplate.YaMakeTemplate):
    """
    Build CaesarModels daemons bundle
    """
    class Requirements(sdk2.Task.Requirements):
        disk_space = 80 * 1024

    class Parameters(YaMakeTemplate.get_project_params(build_resources=[
        yabs_resources.CaesarModelsDaemon,
        yabs_resources.YabsBegemotEvlogdump,
        yabs_resources.YabsModelsServicesBstr,
        yabs_resources.YabsModelsServicesBstrCallback,
        yabs_resources.YabsModelsServicesBstrCaller,
        yabs_resources.YabsModelsServicesPoorMansProfiler,
    ])):
        pass
