from sandbox.projects.runtime_models.BuildBegemotModelsPackageBase import BuildBegemotModelsPackageBase, get_build_models_package_parameters, StorageSources


class BuildCaesarModelsShard01Package(BuildBegemotModelsPackageBase):
    class Parameters(BuildBegemotModelsPackageBase.Parameters):
        _bmp = get_build_models_package_parameters(
            rules_to_deploy_default=[],
            bg_shard_default='CaesarModelsShard01AndPostProcess',
            pack_to_tar_default=True,
        )

    @property
    def rule2models(self):
        return {
            'CaesarModelsShard01AndPostProcess': {
                'CaesarModelsShard01': [
                    {
                        'model_name': 'banner_tsar_ctr_dssm',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 1671888024,
                            'owner': 'bulatman',
                        },
                    },
                    {
                        'model_name': 'banner_tsar_alb_fresh',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 1748505525,
                            'owner': 'rudolf',
                        },
                    },
                    {
                        'model_name': 'banner_tsar_bc_rsya_noreg',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 1748526888,
                            'owner': 'rudolf',
                        },
                    },
                    {
                        'model_name': 'banner_tsar_jruziev_tsar_searchBC1',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 1748542173,
                            'owner': 'rudolf',
                        },
                    },
                    {
                        'model_name': 'banner_tsar_assessor',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 2046637767,
                            'owner': 'rudolf',
                        },
                    },
                    {
                        'model_name': 'banner_tsar_search_pclick',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 1748583086,
                            'owner': 'rudolf',
                        },
                    },
                    {
                        'model_name': 'banner_tsar_search_bc',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 1748577615,
                            'owner': 'rudolf',
                        },
                    },
                    {
                        'model_name': 'banner_tsar_ab_tsar',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 1748521920,
                            'owner': 'rudolf',
                        },
                    },
                    {
                        'model_name': 'banner_tsar_bc_v1_fps',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 1748531080,
                            'owner': 'rudolf',
                        },
                    },
                    {
                        'model_name': 'banner_tsar_future_prgg_v2',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 1748538963,
                            'owner': 'rudolf',
                        },
                    },
                    {
                        'model_name': 'banner_tsar_bc_rsya_key_goals',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 1813720423,
                            'owner': 'blv1mk',
                        },
                    },
                    {
                        'model_name': 'banner_tsar_rsya_ab_conv',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 1813721801,
                            'owner': 'blv1mk',
                        },
                    },
                    {
                        'model_name': 'banner_tsar_search_apc',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 1939815192,
                            'owner': 'rudolf',
                        },
                    },
                    {
                        'model_name': 'banner_tsar_rsya_pclick',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 1939829087,
                            'owner': 'rudolf',
                        },
                    },
                    {
                        'model_name': 'banner_spynet_ARG_region_sclick_hard',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 2045567658,
                            'owner': 'dpaveldev',
                        },
                    },
                    {
                        'model_name': 'banner_spynet_fps',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 2045575577,
                            'owner': 'dpaveldev',
                        },
                    },
                    {
                        'model_name': 'banner_spynet_queries_fps',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 2045585010,
                            'owner': 'dpaveldev',
                        },
                    },
                    {
                        'model_name': 'banner_spynet3_e300fps_sclick_lr000075_delay1_BSDEV65865',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 2045592216,
                            'owner': 'dpaveldev',
                        },
                    },
                    {
                        'model_name': 'banner_spy_offer_sort_for_turbo',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 2067215083,
                            'owner': 'dpaveldev',
                        },
                    },
                    {
                        'model_name': 'banner_big_search_dssm_bigrams_text',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 2067218177,
                            'owner': 'dpaveldev',
                        },
                    },
                    {
                        'model_name': 'banner_big_search_dssm_bigrams_title',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 2067219318,
                            'owner': 'dpaveldev',
                        },
                    },
                    {
                        'model_name': 'banner_big_search_dssm_ctr_lp_title',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 2067220432,
                            'owner': 'dpaveldev',
                        },
                    },
                    {
                        'model_name': 'banner_big_search_dssm_ctr_title',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 2067220910,
                            'owner': 'dpaveldev',
                        },
                    },
                    {
                        'model_name': 'banner_ADVMACHINE_1170_text',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 2067221819,
                            'owner': 'dpaveldev',
                        },
                    },
                    {
                        'model_name': 'banner_ADVMACHINE_1170_title',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 2067223009,
                            'owner': 'dpaveldev',
                        },
                    },
                    {
                        'model_name': 'banner_ADVMACHINE_1170_lp_title',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 2067224053,
                            'owner': 'dpaveldev',
                        },
                    },
                    {
                        'model_name': 'BroadModelSaNoAggregationTarget_45',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 2584767446,
                            'owner': 'muradmazitov',
                        },
                    },
                    {
                        'model_name': 'banner_relev_v0_title',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 2270595702,
                            'owner': 'kolyakolya',
                        },
                    },
                    {
                        'model_name': 'SuperhumanBroadFixed_landpage_BSDEV_84127',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 2350142918,
                            'owner': 'muradmazitov',
                        },
                    },
                    {
                        'model_name': 'Exact_landpage_title_BSDEV_84127',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 2350235518,
                            'owner': 'muradmazitov',
                        },
                    },
                ],
                'CaesarModelsShardPostProcess': [
                    {
                        'model_name': 'L1_MSE_with_IsAB_banner',
                        'resource_type': 'OTHER_RESOURCE',
                        'source': StorageSources.SANDBOX,
                        'constraints': {
                            'id': 3376468956,
                            'owner': 'ulyanin',
                        },
                    },
                ]
            }
        }
