from sandbox.projects.runtime_models.BuildBegemotModelsPackageBase import BuildBegemotModelsPackageBase, get_build_models_package_parameters, StorageSources


class BuildCaesarModelsShard04GpuInferencePackage(BuildBegemotModelsPackageBase):
    class Parameters(BuildBegemotModelsPackageBase.Parameters):
        _bmp = get_build_models_package_parameters(
            rules_to_deploy_default=[],
            bg_shard_default='CaesarModelsShard04GpuInference',
            pack_to_tar_default=True,
        )

    @property
    def rule2models(self):
        return {
            'CaesarModelsShard04GpuInference': {
                'CaesarModelsShard04GpuInference': [
                    {
                        'model_name': 'RsyaBcTorchV2BannerModel',
                        'resource_type': 'ML_STORAGE_DUMP',
                        'source': StorageSources.ML_STORAGE,
                        'constraints': {
                            'attrs': {
                                "key": "__home_ads_robot-online-pytorch_bc_rsya_torchv2_hitsplit",
                                "dump_key": "banner",
                            },
                        },
                    },
                ],
            }
        }
