# coding: utf-8

from __future__ import absolute_import

from sandbox import sdk2


class RuijerdBinaries(sdk2.resource.AbstractResource):
    """
        Resource RUIJERD_BINARIES for ruijerd package binaries
    """
    releasable = True
    releasers = ['bikulov', 'ashaposhnikov']
    release_subscribers = ['bikulov', 'ashaposhnikov']


class WebspamBinaries(sdk2.resource.AbstractResource):
    """
        Resource WEBSPAM_BINARIES for webspam package binaries
    """
    releasable = True
    releasers = ['bikulov', 'ulyanov', 'koshdm']
    release_subscribers = ['bikulov', 'ulyanov', 'koshdm']


class AntispamViewers(sdk2.resource.AbstractResource):
    """
        Resource ANTISPAM_VIEWERS for all antispam viewers
    """
    releasable = True
    releasers = ['bikulov', 'ulyanov', 'koshdm']
    release_subscribers = ['bikulov', 'ulyanov', 'koshdm']


class AntipornoBinaries(sdk2.resource.AbstractResource):
    """
        Resource ANTIPORNO_BINARIES for antiporno package yweb/antiporno/build/package
    """
    releasable = True
    releasers = ['bikulov', 'ulyanov', 'koshdm', 'vdf']
    release_subscribers = ['bikulov', 'ulyanov', 'koshdm', 'vdf']


class WebspamLegacyBinaries(sdk2.resource.AbstractResource):
    """
        Resource WEBSPAM_LEGACY_BINARIES for yweb/antispam/webspam/build/packages/webspam.json
    """
    releasable = True
    releasers = ['bikulov', 'ulyanov', 'koshdm']
    release_subscribers = ['bikulov', 'ulyanov', 'koshdm']


class MascotBinaries(sdk2.resource.AbstractResource):
    """
        Resource MASCOT_BINARIES for mascot package binaries
    """
    releasable = True
    releasers = ['bikulov', 'ulyanov', 'koshdm']
    release_subscribers = ['bikulov', 'ulyanov', 'koshdm']


class AuraBinaries(sdk2.resource.AbstractResource):
    """
        Resource AURA_BINARIES for aura package binaries
    """
    releasable = True
    releasers = ['bikulov', 'ulyanov', 'koshdm']
    release_subscribers = ['bikulov', 'ulyanov', 'koshdm']


class CidBinaries(sdk2.resource.AbstractResource):
    """
        Resource CID_BINARIES for cid package binaries
        yweb/antispam/cid/package/cid.json
    """
    releasable = True
    releasers = ['bikulov', 'ulyanov', 'koshdm']
    release_subscribers = ['bikulov', 'ulyanov', 'koshdm']


class NevascaDupBinaries(sdk2.resource.AbstractResource):
    """
        Resource NEVASCA_DUP_BINARIES for yandex-yweb-dups-nevasca package binaries
    """
    releasable = True
    releasers = ['bikulov', 'ulyanov', 'koshdm']
    release_subscribers = ['bikulov', 'ulyanov', 'koshdm']


class WebspamBootstrap(sdk2.resource.AbstractResource):
    """
        Resource WEBSPAM_BOOTSTRAP for webspam package binaries
    """
    releasable = True
    releasers = ['bikulov', 'ulyanov', 'koshdm']
    release_subscribers = ['bikulov', 'ulyanov', 'koshdm']
