PY23_LIBRARY()

OWNER(g:infra-vteam-c)

PY_SRCS(
    __init__.py

    arc/context.py
    arc/arc_apply.py
    arc/arc_cli.py
    errors/merge_queue.py
    actions_constants.py
    actions_stat.py
    arcanum_checks.py
    artifacts.py
    browsers_config.py
    cache_profiler.py
    config.py
    deep_actions_profiler.py
    dependencies.py
    github_statuses.py
    info.py
    json_report.py
    lifecycle.py
    meta.py
    assert_metrics.py
    merge_queue.py
    profiled_action_creator.py
    profiler.py
    release.py
    reports.py
    html_report.py
    plugins_profiler_report.py
    s3mds.py
    scp_feedback.py
    scripts.py
    selective.py
    selective_checks.py
    selective_coverage.py
    stability_index.py
    startrek.py
    stat_report.py
    statface.py
    tags.py
    task_dependencies.py
    vault.py
    webhook.py
    metrics_logger.py
    zeroline_reporter.py
    skip_list.py
    template_error_collector.py
)

PEERDIR(
    # если удалить зависимость от statface_client, boto3, botocore, то тесты пройдут, но сломаются бинарные таски;
    # после полного перехода на бинарные таски при удалении этой зависимости тесты будут падать
    library/python/statface_client
    contrib/python/boto3
    contrib/python/botocore
    contrib/python/six

    sandbox/projects/common/gnupg
    sandbox/projects/common/yasm
    sandbox/projects/common/vcs
    sandbox/projects/resource_types

    sandbox/projects/sandbox_ci/utils
    sandbox/projects/sandbox_ci/resources
    sandbox/projects/sandbox_ci/task/test_task/plugins
    sandbox/projects/sandbox_ci/decorators

    sandbox/projects/repo/convert
)

END()
