PY2_LIBRARY()

OWNER(
    g:sdc-infra
)


# find . -name '*.py' | sed 's:^./:    :' | sort
PY_SRCS(
    __init__.py

    PrepareBinariesResource/__init__.py
    PreparePackage/__init__.py
    SDC_CHECK_ACCESS/__init__.py
    SDC_CHECK_ACCESS/teamcity.py
    SdcAwsCloneBinariesCAS/__init__.py
    SdcAwsCloneLanesMap/__init__.py
    SdcBazelTests/__init__.py
    SdcBazelTestsBazelDiff/__init__.py
    SdcBuild/__init__.py
    SdcBuildASAN/__init__.py
    SdcBuildAllPortoLayers/__init__.py
    SdcBuildBinariesPortoLayer/__init__.py
    SdcBuildDebug/__init__.py
    SdcBuildFlaky/__init__.py
    SdcBuildLauncher/__init__.py
    SdcBuildLxcContainerWithDocker/__init__.py
    SdcBuildLxcContainerWithDocker/constants.py
    SdcBuildNoTests/__init__.py
    SdcBuildPackagesPortoLayer/__init__.py
    SdcBuildPerfCtests/__init__.py
    SdcBuildPerfCtestsE5/__init__.py
    SdcBuildRemote/__init__.py
    SdcBuildResourcesArchive/__init__.py
    SdcBuildTSAN/__init__.py
    SdcBuildUbsan/__init__.py
    SdcBuildVHub/__init__.py
    SdcBuildXavier/__init__.py
    SdcCalcTestsResourceUsage/__init__.py
    SdcCtestMapping/__init__.py
    SdcDecodeRosbagFileFromMds/__init__.py
    SdcDeployCar/__init__.py
    SdcIsolateTests/__init__.py
    SdcLanesMapValidatorBuild/__init__.py
    SdcLanesMapValidatorRelease/__init__.py
    SdcLanesRoutingServerBuild/__init__.py
    SdcLanesRoutingServerRelease/__init__.py
    SdcMidnightDevUpdater/__init__.py
    SdcPrComposite/__init__.py
    SdcRunSimMetricsHuge/__init__.py
    SdcRunSimMetricsLight/__init__.py
    SdcSonarAnalysis/__init__.py
    SdcStopTeamcityBuilds/__init__.py
    SdcUpdateBothLayersSymlinks/__init__.py
    SdcUploadResourcesArchiveToYT/__init__.py
    SdcVhubJetsonDeployTest/__init__.py
    SdgDeployArtifactsMonitoring/__init__.py
    SdgDeployArtifactsMonitoring/juggler_api_wrapper.py
    TestRunInPorto/__init__.py

    common/__init__.py
    common/aws.py
    common/bitbucket.py
    common/constants.py
    common/docker.py
    common/git.py
    common/parameters.py
    common/session.py
    common/teamcity.py
    common/utils.py
    common/yt_helpers.py

    isolate_cloud/SdcIcReleaseWorkers/__init__.py
    isolate_cloud/SdcIcResizeWorkerGroups/__init__.py

    tests/CheckCustomSDCHost/__init__.py
    tests/SdcTestDockerRunAlpine/__init__.py
    tests/__init__.py
)

SET(PWD "sandbox/projects/sdc")
PEERDIR(
    ${PWD}/common
    ${PWD}/tests
    ${PWD}/resource_types
    ${PWD}/porto_helper
    ${PWD}/common_tasks
    ${PWD}/simulator

    ${PWD}/SdcBuildPR
    ${PWD}/SdcBuildWithTests
    ${PWD}/SdcCheckSolibDiff
    ${PWD}/SdcDeployPorto
    ${PWD}/SdcLint
    ${PWD}/SdcLxcContainerForCI
    ${PWD}/SdcPrCompositeLxc
)

END()

RECURSE(
    PrepareBinariesResource
    PreparePackage
    SDC_CHECK_ACCESS
    SdcAwsCloneBinariesCAS
    SdcAwsCloneLanesMap
    SdcBazelTests
    SdcBazelTestsBazelDiff
    SdcBuild
    SdcBuildPR
    SdcBuildAllPortoLayers
    SdcBuildFlaky
    SdcBuildLxcContainerWithDocker
    SdcBuildPackagesPortoLayer
    SdcBuildPerfCtests
    SdcBuildRemote
    SdcBuildResourcesArchive
    SdcBuildVHub
    SdcBuildWithTests
    SdcBuildXavier
    SdcCheckSolibDiff
    SdcDecodeRosbagFileFromMds
    SdcDeployCar
    SdcDeployPorto
    SdcIsolateTests
    SdcLanesMapValidatorBuild
    SdcLanesMapValidatorRelease
    SdcLanesRoutingServerBuild
    SdcLanesRoutingServerRelease
    SdcLint
    SdcLxcContainerForCI
    SdcMidnightDevUpdater
    SdcPrComposite
    SdcPrCompositeLxc
    SdcRunSimMetricsHuge
    SdcRunSimMetricsLight
    SdcStopTeamcityBuilds
    SdcUpdateBothLayersSymlinks
    SdcUploadResourcesArchiveToYT
    SdcVhubJetsonDeployTest
    SdgDeployArtifactsMonitoring
    TestRunInPorto
    common
    common_tasks
    isolate_cloud
    porto_helper
    resource_types
    simulator
    tests
)
