from sandbox import sdk2


# Please do not use personal ACL
_RELEASERS = ['STATINFRA_BUILD']


class STATINFRA_EVENT_PROCESSOR(sdk2.Resource):
    __default_attribute__ = sdk2.parameters.String

    auto_backup = True
    any_arch = True
    releasable = True
    releasers = _RELEASERS


class STATINFRA_REPOS(sdk2.Resource):
    __default_attribute__ = sdk2.parameters.String

    auto_backup = True
    any_arch = True
    releasable = True
    releasers = _RELEASERS


class STATINFRA_LXC_CONTAINER(sdk2.service_resources.LxcContainer):
    __default_attribute__ = sdk2.parameters.String

    releasable = True
    releasers = _RELEASERS + [
        'ngc224',
        'kender',
        'sinister',
        'uvizhe',
        'lipkin',
        'amatanhead',
        'stattester',
    ]
    auto_backup = True
    ttl = 60


class STATINFRA_ACTION_REPOS(sdk2.Resource):
    __default_attribute__ = sdk2.parameters.String

    auto_backup = True
    any_arch = True
    releasable = True
    releasers = _RELEASERS
    ttl = 30


class STATINFRA_JOB_REPOS(sdk2.Resource):
    __default_attribute__ = sdk2.parameters.String

    auto_backup = True
    any_arch = True
    releasable = True
    releasers = _RELEASERS
    ttl = 30


class STATINFRA_LIB_REPOS(sdk2.Resource):
    __default_attribute__ = sdk2.parameters.String

    auto_backup = True
    any_arch = True
    releasable = True
    releasers = _RELEASERS
    ttl = 30


class STATINFRA_CONFIG_REPOS(sdk2.Resource):
    __default_attribute__ = sdk2.parameters.String

    auto_backup = True
    any_arch = True
    releasable = True
    releasers = _RELEASERS
    ttl = 30


class STATINFRA_VENVS(sdk2.Resource):
    __default_attribute__ = sdk2.parameters.String

    auto_backup = True
    any_arch = True
    releasable = True
    releasers = _RELEASERS
    ttl = 60


class STATINFRA_LXC_CONTAINER_BETA(STATINFRA_LXC_CONTAINER):
    pass


class STATINFRA_ACTION_REPOS_BETA(sdk2.Resource):
    __default_attribute__ = sdk2.parameters.String

    auto_backup = True
    any_arch = True
    releasable = True
    releasers = _RELEASERS
    ttl = 30


class STATINFRA_JOB_REPOS_BETA(sdk2.Resource):
    __default_attribute__ = sdk2.parameters.String

    auto_backup = True
    any_arch = True
    releasable = True
    releasers = _RELEASERS
    ttl = 30


class STATINFRA_LIB_REPOS_BETA(sdk2.Resource):
    __default_attribute__ = sdk2.parameters.String

    auto_backup = True
    any_arch = True
    releasable = True
    releasers = _RELEASERS
    ttl = 30


class STATINFRA_CONFIG_REPOS_BETA(sdk2.Resource):
    __default_attribute__ = sdk2.parameters.String

    auto_backup = True
    any_arch = True
    releasable = True
    releasers = _RELEASERS
    ttl = 30


class STATINFRA_VENVS_BETA(sdk2.Resource):
    __default_attribute__ = sdk2.parameters.String

    auto_backup = True
    any_arch = True
    releasable = True
    releasers = _RELEASERS
    ttl = 60


class STATINFRA_THEMES_CLASSIFIER(sdk2.Resource):
    __default_attribute__ = sdk2.parameters.String

    auto_backup = True
    any_arch = True
    releasable = True
    releasers = _RELEASERS
    ttl = 'inf'
