import sandbox.projects.quasar.platform as quasar_platform
from sandbox.projects.tv.target_check.common import TargetCheck
from sandbox.projects.tv.target_check.common.utils import get_base_properties


class TargetCheckHikeen2871(TargetCheck):
    class Parameters(TargetCheck.Parameters):
        platform = quasar_platform.Platform.YANDEX_TV_RT2871_HIKEEN
        properties_keys_list = get_base_properties()
        properties_keys_list["product_props"].append("ro.build.fingerprint")
        properties_keys_list["logo_images"] = ["bootfile.raw"]


class TargetCheckHikeen2861(TargetCheck):
    class Parameters(TargetCheck.Parameters):
        platform = quasar_platform.Platform.YANDEX_TV_RT2861_HIKEEN
        properties_keys_list = get_base_properties()
        properties_keys_list["product_props"].append("ro.build.fingerprint")
        properties_keys_list["logo_images"] = ["bootfile.raw"]
