PY2_LIBRARY()

OWNER(
    g:begemot
    g:search-sandbox
)

SET(TASKS sandbox/projects/websearch/begemot/tasks)

PEERDIR(
    sandbox/projects/common/vcs
    sandbox/projects/common/requests_wrapper
    sandbox/projects/fuzzing
    sandbox/projects/fuzzing/resources

    ${TASKS}/BegemotCreateResponsesDiff
    ${TASKS}/BegemotCreateResponsesDiffYT
    ${TASKS}/BegemotGraph
    ${TASKS}/BegemotYT/common
    ${TASKS}/BegemotYT/paths
    ${TASKS}/BisectWizardDiffReason
    ${TASKS}/BuildBegemotConfig
    ${TASKS}/CopyEventLogs/lib
    ${TASKS}/ReleaseBegemotResources
    ${TASKS}/ReleaseBegemotRmPush
)

PY_SRCS(
    BegemotCreateResponsesDiffMulti/__init__.py
    BegemotCreateResponsesDiffYT/__init__.py
    BegemotCreateResponsesDiffYT/diff.py
    BegemotFailCacheHitDiff/__init__.py
    BegemotFreshBuild/__init__.py
    BegemotMarkerTests/__init__.py
    BegemotMarkerTests/validator/__init__.py
    BegemotParseEvlog/__init__.py
    BegemotPerfTestsAccumulation/__init__.py
    BegemotQuotaUsageByRule/__init__.py
    BegemotSpellcheckerHusqvarnaQuality/__init__.py
    BegemotHusqvarnaQualityDiff/__init__.py
    BegemotTankLoadTest/__init__.py
    BegemotYT/BegemotMapper/__init__.py
    BegemotYT/BegemotReducer/__init__.py
    BegemotYT/BegemotReducerMultiplier/__init__.py
    BegemotYT/BegemotStabilityCheck/__init__.py
    BegemotYT/CheckBegemotResponsesYT/__init__.py
    BegemotYT/CheckBegemotResponsesYT/checker.py
    BegemotYT/CoredumpBacktrace/__init__.py
    BegemotYT/MergeChunksYT/__init__.py
    BegemotYT/MiddleSearchCacheHitGuess2/__init__.py
    BegemotYT/MiddleSearchCacheHitGuess2/cache_guess.py
    BegemotYT/__init__.py
    BuildBegemot/__init__.py
    BuildBegemotBstr/__init__.py
    BuildBegemotCommon/__init__.py
    BuildBegemotData/__init__.py
    BuildBegemotLogger/__init__.py
    BuildWizardData/__init__.py
    CheckBegemotResponses/__init__.py
    CheckBegemotSignals/__init__.py
    CheckBetaCoredumps/__init__.py
    CheckMemlockUnlimited/__init__.py
    CheckResourcesAge/__init__.py
    CheckWizhosts/__init__.py
    CollectBegemotResources/__init__.py
    CompareBegemotFastAndFullShardBuild/__init__.py
    CompareBegemotFreshBuildAndDistBuild/__init__.py
    CompareBegemotShardSize/__init__.py
    ComputeBegemotDiffMetrics/__init__.py
    ComputeBegemotDiffMetrics/tree_config.py
    CopyEventLogs/__init__.py
    DeployBegemotFresh/__init__.py
    DeployBegemotFreshDataWithBstr/__init__.py
    DeployBegemotSpellcheckerFresh/__init__.py
    ExtractBegemotProductionRequests/__init__.py
    FindBegemotObsoleteRules/__init__.py
    GetBegemotBetasQueries/__init__.py
    GetBegemotBetasQueries/answer_normalizer.py
    GetBegemotReleasesPerf/__init__.py
    GetBegemotResponses/__init__.py
    GetBegemotResponsesPerf/__init__.py
    GetBegemotResponsesMulti/__init__.py
    GetBegemotShardsQuality/__init__.py
    GetBegemotWorkerAndMergerResponses/__init__.py
    GetBegemotWorkerLingboostResponses/__init__.py
    GetFailCacheHit/__init__.py
    GetWorkerMaxrssDifference/__init__.py
    MergeBegemotFreshRevisions/__init__.py
    PickBuildBegemotDataContext/__init__.py
    PrepareBegemotFuzzyQueries/__init__.py
    QuotasCorrectionScript/__init__.py
    ReleaseBegemotAdvqResources/__init__.py
    ReleaseBegemotBegginsResources/__init__.py
    ReleaseBegemotCaesarModelsResources/__init__.py
    ReleaseBegemotFresh/__init__.py
    ReleaseBegemotMegamindResources/__init__.py
    ReleaseBegemotRequestInitResources/__init__.py
    ReleaseBegemotResources/__init__.py
    ReleaseBegemotResources2/CollectBegemotResources2/__init__.py
    ReleaseBegemotResources2/__init__.py
    RunBegemotFuzzy/__init__.py
    SamogonBegemotFreshPackage/__init__.py
    ShardAutobalancing/__init__.py
    ShardAutobalancing/best_split.py
    ShardAutobalancing/constants.py
    ShardAutobalancing/graph.py
    ShardAutobalancing/rule_parameters.py
    ShardAutobalancing/shard.py
    TestBegemotFresh/__init__.py
    TestBegemotFreshDeployment/__init__.py
    UploadBegemotRequests/__init__.py
    WizardReducer/__init__.py
    WizardRulesDurationPerf/__init__.py
    WizardRulesDurationPerf/duration_meta.py
    __init__.py
)

RESOURCE(
    BegemotHusqvarnaQualityDiff/footer.tmpl sandbox/projects/websearch/begemot/tasks/BegemotHusqvarnaQualityDiff/footer.tmpl
    BegemotTankLoadTest/shooting_config.txt sandbox/projects/websearch/begemot/tasks/BegemotTankLoadTest/shooting_config.txt
    BegemotQuotaUsageByRule/email_template.txt sandbox/projects/websearch/begemot/tasks/BegemotQuotaUsageByRule/email_template.txt
)

END()

RECURSE(
    BegemotCreateResponsesDiff
    BegemotCreateResponsesDiffYT
    BegemotFailCacheHitDiff
    BegemotFreshBuild
    BegemotGraph
    BegemotHusqvarnaQualityDiff
    BegemotMarkerTests
    BegemotParseEvlog
    BegemotPerfTestsAccumulation
    BegemotQuotaUsageByRule
    BegemotSpellcheckerHusqvarnaQuality
    BegemotTankLoadTest
    BegemotYT
    BisectWizardDiffReason
    BuildBegemot
    BuildBegemotBstr
    BuildBegemotCommon
    BuildBegemotConfig
    BuildBegemotData
    BuildBegemotLogger
    BuildWizardData
    CheckBegemotResponses
    CheckBegemotSignals
    CheckBetaCoredumps
    CheckMemlockUnlimited
    CheckResourcesAge
    CheckWizhosts
    CollectBegemotResources
    CompareBegemotFastAndFullShardBuild
    CompareBegemotFreshBuildAndDistBuild
    CompareBegemotShardSize
    ComputeBegemotDiffMetrics
    CopyEventLogs
    DeployBegemotFresh
    DeployBegemotFreshDataWithBstr
    DeployBegemotSpellcheckerFresh
    ExtractBegemotProductionRequests
    FindBegemotObsoleteRules
    GetBegemotBetasQueries
    GetBegemotReleasesPerf
    GetBegemotResponses
    GetBegemotResponsesPerf
    GetBegemotResponsesMulti
    GetBegemotShardsQuality
    GetBegemotWorkerAndMergerResponses
    GetBegemotWorkerLingboostResponses
    GetFailCacheHit
    GetWorkerMaxrssDifference
    MergeBegemotFreshRevisions
    PickBuildBegemotDataContext
    PrepareBegemotFuzzyQueries
    QuotasCorrectionScript
    ReleaseBegemotAdvqResources
    ReleaseBegemotBegginsResources
    ReleaseBegemotFresh
    ReleaseBegemotMegamindResources
    ReleaseBegemotRequestInitResources
    ReleaseBegemotResources
    ReleaseBegemotResources2
    ReleaseBegemotRmPush
    RunBegemotFuzzy
    SamogonBegemotFreshPackage
    ShardAutobalancing
    TestBegemotFresh
    TestBegemotFreshDeployment
    UploadBegemotRequests
    WizardReducer
    WizardRulesDurationPerf
)
