from sandbox.projects.yabs.qa.multiple_sut_wrapper.sut.adapters.interface import MultipleSUTAdapterInterface
from sandbox.projects.yabs.qa.multiple_sut_wrapper.sut import MultipleSUT
from sandbox.projects.yabs.qa.adapter_base.sandbox import SandboxAdapterBase


class MultipleSUTSandboxAdapter(MultipleSUTAdapterInterface, SandboxAdapterBase):
    sut_name_to_adapter_class = dict()

    sut_name_to_adapter = dict()

    def __init__(self, parameters, task_instance):
        SandboxAdapterBase.__init__(self, parameters, task_instance)
        for name, adapter_class in self.sut_name_to_adapter_class.iteritems():
            self.sut_name_to_adapter[name] = adapter_class(parameters, task_instance)

    def get_port(self):
        return self.parameters.port

    def create_module(self):
        return MultipleSUT(self)
