PY2_LIBRARY()

OWNER(
    g:ydo
)

SET(PWD "sandbox/projects/ydo")

PEERDIR(
    sandbox/common/errors

    sandbox/projects/kikimr/resources
    sandbox/projects/sandbox/resources
    sandbox/projects/common/nanny
    sandbox/projects/common/file_utils
    sandbox/projects/common/yt_cleaner
    sandbox/projects/geosearch/CleanupYtFolder
    sandbox/projects/yql
    sandbox/projects/common/yql

    ${PWD}/accumulate_worker_stats
    ${PWD}/aggregate_partner_prices
    ${PWD}/aggregate_worker_stats_and_publish_to_saas
    ${PWD}/analyze_spw
    ${PWD}/arbitrage_creator
    ${PWD}/avatars_cleaner
    ${PWD}/backend
    ${PWD}/backup
    ${PWD}/balance_workers
    ${PWD}/ban_bad_external_workers
    ${PWD}/ban_fraud_workers
    ${PWD}/build
    ${PWD}/calculate_yang_bonus
    ${PWD}/call_center
    ${PWD}/change_rps_limiter_quota
    ${PWD}/check_nirvana_folders
    ${PWD}/clarifier_validation
    ${PWD}/clean_old_nodes
    ${PWD}/clear_ydb_table
    ${PWD}/collect_connections
    ${PWD}/complaints_transporter
    ${PWD}/copy_tables_between_databases
    ${PWD}/create_drive_car_wash_orders
    ${PWD}/create_transactions_for_payoffs
    ${PWD}/customer_attributes_generator
    ${PWD}/db_auto_documentation
    ${PWD}/db_enrichment
    ${PWD}/db_log_accumulator
    ${PWD}/default_multislot_task
    ${PWD}/devops
    ${PWD}/direct
    ${PWD}/disable_communication_channels
    ${PWD}/dispatch
    ${PWD}/dispatch_indexer
    ${PWD}/dispatch_maps
    ${PWD}/dj
    ${PWD}/docdoc
    ${PWD}/dry_cleaning_mailing_list
    ${PWD}/erp
    ${PWD}/erp_workers_collector
    ${PWD}/external_workers_schedule_confirmations
    ${PWD}/features
    ${PWD}/feedback_request
    ${PWD}/finish_orders_notifier
    ${PWD}/gdpr
    ${PWD}/get_launched_categories
    ${PWD}/get_payment_batches
    ${PWD}/granted_income_for_external_workers_processor
    ${PWD}/hanging_orders_handler
    ${PWD}/hitman_monitorings
    ${PWD}/incidents_observer
    ${PWD}/indexer
    ${PWD}/market
    ${PWD}/market_create_orders
    ${PWD}/messenger
    ${PWD}/moderation
    ${PWD}/monitorings
    ${PWD}/new_interesting_orders_additional_notifier
    ${PWD}/new_reviews_notifier
    ${PWD}/no_answers_stat
    ${PWD}/order_actions_notifier
    ${PWD}/order_clarifier
    ${PWD}/order_processor
    ${PWD}/order_quality_classification
    ${PWD}/order_weight_updater
    ${PWD}/orders_deficient_commission_processor
    ${PWD}/pass_payoffs_to_partners
    ${PWD}/passport_checker
    ${PWD}/prep_direct_certificates_data
    ${PWD}/prepare_saas_stats
    ${PWD}/process_suspended_order_partners
    ${PWD}/promo_logs_parser
    ${PWD}/propagate_passport_policy
    ${PWD}/proxy_phones
    ${PWD}/reminder_config_updater
    ${PWD}/reminders_expired_tasks_checker
    ${PWD}/reminders_generator
    ${PWD}/replication
    ${PWD}/reqans
    ${PWD}/resource_types
    ${PWD}/response_time_monitoring
    ${PWD}/return_bottles
    ${PWD}/rubricator_version
    ${PWD}/rubrics_merger
    ${PWD}/search_index
    ${PWD}/secret_customer_processor
    ${PWD}/self_release
    ${PWD}/sending_center
    ${PWD}/service_cards
    ${PWD}/service_matcher
    ${PWD}/service_model_sitemap
    ${PWD}/solomon_mixin
    ${PWD}/spontaneous
    ${PWD}/suggest
    ${PWD}/suspicious_workers_finder
    ${PWD}/testenv
    ${PWD}/transfer_complaints_with_verdicts
    ${PWD}/ugc
    ${PWD}/universal_notifier
    ${PWD}/uplift
    ${PWD}/upload_balance_transactions_to_yt
    ${PWD}/user_actions_notifier
    ${PWD}/wizard/one_worker
    ${PWD}/worker_actions_notifier
    ${PWD}/worker_attributes_generator
    ${PWD}/worker_clicks_reducer
    ${PWD}/worker_rating_updater
    ${PWD}/workers_orders_matching
    ${PWD}/ydo_parallel_dump_eventlog
    ${PWD}/yt_monthly_merger
    ${PWD}/yt_table_to_lb
    ${PWD}/yt_table_to_resource
    ${PWD}/yt_table_to_rtmr
)

PY_SRCS(
    __init__.py
    config_operations.py
    ferryman.py
    kikimr.py
    parameters_view.py
    process_generator.py
)

END()

RECURSE(
    accumulate_worker_stats
    aggregate_partner_prices
    aggregate_worker_stats_and_publish_to_saas
    arbitrage_creator
    backend
    backup
    balance_workers
    build
    call_center
    change_rps_limiter_quota
    clarifier_validation
    clean_old_nodes
    clear_ydb_table
    copy_tables_between_databases
    create_transactions_for_payoffs
    db_auto_documentation
    db_enrichment
    db_log_accumulator
    default_multislot_task
    devops
    disable_communication_channels
    dispatch
    dispatch_indexer
    dispatch_maps
    dj
    docdoc
    dry_cleaning_mailing_list
    erp
    features
    feedback_request
    gdpr
    get_launched_categories
    get_payment_batches
    granted_income_for_external_workers_processor
    hanging_orders_handler
    hitman_monitorings
    indexer
    market
    market_create_orders
    messenger
    moderation
    monitorings
    new_interesting_orders_additional_notifier
    new_reviews_notifier
    no_answers_stat
    order_actions_notifier
    order_clarifier
    order_quality_classification
    order_weight_updater
    orders_deficient_commission_processor
    pass_payoffs_to_partners
    prep_direct_certificates_data
    prepare_saas_stats
    promo_logs_parser
    propagate_passport_policy
    proxy_phones
    reminders_expired_tasks_checker
    reminders_generator
    replication
    reqans
    resource_types
    return_bottles
    rubricator_version
    rubrics_merger
    secret_customer_processor
    self_release
    sending_center
    service_cards
    solomon_mixin
    spontaneous
    suggest
    suspicious_workers_finder
    testenv
    ugc
    universal_notifier
    uplift
    upload_balance_transactions_to_yt
    wizard
    worker_actions_notifier
    worker_clicks_reducer
    workers_orders_matching
    ydo_parallel_dump_eventlog
    yt_monthly_merger
    yt_table_to_lb
    yt_table_to_resource
    yt_table_to_rtmr
)
