OWNER(g:sandbox-dev)

PY23_LIBRARY()

PEERDIR(
    contrib/python/aniso8601
    contrib/python/ipython
    contrib/python/psutil
    contrib/python/six

    library/python/resource
    library/python/sfx
    library/python/svn_version

    skynet/kernel

    sandbox/agentr/client
    sandbox/etc

    sandbox/common/api
    sandbox/common/auth
    sandbox/common/collections
    sandbox/common/config
    sandbox/common/context
    sandbox/common/crypto
    sandbox/common/data
    sandbox/common/encoding
    sandbox/common/enum
    sandbox/common/errors
    sandbox/common/format
    sandbox/common/fs
    sandbox/common/itertools
    sandbox/common/lazy
    sandbox/common/log
    sandbox/common/math
    sandbox/common/os
    sandbox/common/patterns
    sandbox/common/platform
    sandbox/common/projects_handler
    sandbox/common/random
    sandbox/common/rest
    sandbox/common/share
    sandbox/common/statistics
    sandbox/common/system
    sandbox/common/threading
    sandbox/common/urls
    sandbox/common/yav

    sandbox/sdk2/helpers/coredump_filter
)

IF (PYTHON2)
    PEERDIR(
        contrib/python/pathlib2
        contrib/deprecated/python/subprocess32
    )
ENDIF()

PY_SRCS(
    __init__.py
    copy.py
    environments.py
    legacy.py
    os.py
    parameters.py
    path.py
    paths.py
    phazotron.py
    resource.py
    service_resources.py
    ssh.py
    statistics.py
    task.py
    yav.py

    helpers/__init__.py
    helpers/gdb.py
    helpers/misc.py
    helpers/process.py
    helpers/resource.py

    internal/__init__.py
    internal/common.py
    internal/parameters.py
    internal/resource.py
    internal/task.py

    vcs/__init__.py
    vcs/git.py
    vcs/hg.py
    vcs/svn.py
    vcs/tunnel.py
    vcs/zipatch.py
)

END()

RECURSE(
    helpers/coredump_filter
)

RECURSE_FOR_TESTS(
    tests
)
