var scheduler = {

        status : 200,
        body   : [
            {
                "status": "UNKNOWN",
                "task": {
                    "priority": {"class": "SERVICE", "subclass": "NORMAL"},
                    "notifications": [],
                    "important": false,
                    "description": "",
                    "owner": "dhomich",
                    "kill_timeout": 10800,
                    "hidden": false,
                    "type": "PRIEMKA_BASESEARCH_BINARY",
                    "custom_fields": [{
                        "modifiers": null,
                        "description": "",
                        "title": "Test on Linux",
                        "required": false,
                        "value": true,
                        "context": null,
                        "type": "boolean",
                        "name": "test_linux"
                    }, {
                        "modifiers": null,
                        "description": "",
                        "title": "Test on FreeBSD",
                        "required": false,
                        "value": true,
                        "context": null,
                        "type": "boolean",
                        "name": "test_freebsd"
                    }, {
                        "modifiers": null,
                        "description": "",
                        "title": "Test configuration with middlesearch and two new basesearches",
                        "required": false,
                        "value": false,
                        "context": null,
                        "type": "boolean",
                        "name": "test_with_middlesearch"
                    }, {
                        "modifiers": null,
                        "description": "",
                        "title": "Build task (new)",
                        "required": true,
                        "value": 0,
                        "context": {"status": "FINISH", "limit": 20, "type": "BUILD_BASESEARCH"},
                        "type": "void",
                        "name": "build_task_id"
                    }, {
                        "sub_fields": {"existing": ["old_basesearch_resource_id"]},
                        "modifiers": null,
                        "description": "",
                        "title": "Old basesearch source",
                        "required": true,
                        "value": "from_production",
                        "choices": [["from production", "from_production"], ["existing", "existing"]],
                        "context": {
                            "sub_fields": {"existing": ["old_basesearch_resource_id"]},
                            "values": [["from production", "from_production"], ["existing", "existing"]]
                        },
                        "type": "string",
                        "name": "old_basesearch_source"
                    }, {
                        "modifiers": null,
                        "description": "",
                        "title": "Old basesearch",
                        "required": true,
                        "value": 0,
                        "context": {"types": ["BASESEARCH_EXECUTABLE"]},
                        "type": "resource",
                        "name": "old_basesearch_resource_id"
                    }, {
                        "sub_fields": {"existing": ["old_realsearch_resource_id"]},
                        "modifiers": null,
                        "description": "",
                        "title": "Old realsearch source",
                        "required": true,
                        "value": "from_production",
                        "choices": [["from production", "from_production"], ["existing", "existing"]],
                        "context": {
                            "sub_fields": {"existing": ["old_realsearch_resource_id"]},
                            "values": [["from production", "from_production"], ["existing", "existing"]]
                        },
                        "type": "string",
                        "name": "old_realsearch_source"
                    }, {
                        "modifiers": null,
                        "description": "",
                        "title": "Old realsearch",
                        "required": true,
                        "value": 0,
                        "context": {"types": ["REALSEARCH_EXECUTABLE"]},
                        "type": "resource",
                        "name": "old_realsearch_resource_id"
                    }, {
                        "modifiers": null,
                        "description": "",
                        "title": "Realsearch config",
                        "required": false,
                        "value": null,
                        "context": {"types": ["REALSEARCH_CONFIG"]},
                        "type": "resource",
                        "name": "realsearch_config_resource_id"
                    }, {
                        "modifiers": null,
                        "description": "",
                        "title": "Realsearch data",
                        "required": false,
                        "value": null,
                        "context": {"types": ["REALSEARCH_DATA"]},
                        "type": "resource",
                        "name": "realsearch_data_resource_id"
                    }, {
                        "modifiers": null,
                        "description": "",
                        "title": "Realsearch dump",
                        "required": false,
                        "value": null,
                        "context": {"types": ["REALSEARCH_DUMP"]},
                        "type": "resource",
                        "name": "realsearch_dump_resource_id"
                    }, {
                        "modifiers": null,
                        "description": "",
                        "title": "Realsearch plan",
                        "required": false,
                        "value": null,
                        "context": {"types": ["REALSEARCH_PLAN"]},
                        "type": "resource",
                        "name": "realsearch_plan_resource_id"
                    }, {
                        "modifiers": null,
                        "description": "",
                        "title": "if true, binary will be rolled out to FTOTK (this flag is looked up by ftotk external scripts)",
                        "required": false,
                        "value": false,
                        "context": null,
                        "type": "boolean",
                        "name": "rollout_binaries_to_ftotk"
                    }, {
                        "modifiers": null,
                        "description": "",
                        "title": "SKIP FUSION TESTS",
                        "required": false,
                        "value": false,
                        "context": null,
                        "type": "boolean",
                        "name": "skip_fusion_tests"
                    }],
                    "fail_on_any_error": false
                },
                "rights": "write",
                "url": "https://sandbox.yandex-team.ru/sandbox//api/v1.0/scheduler/917",
                "author": "dhomich",
                "schedule": {"fail_on_error": false, "repetition": null, "retry": {"ignore": true}},
                "time": {
                    "next_run": "2015-05-08T10:14:17.452000",
                    "last_run": null,
                    "created": "2015-05-08T10:14:17.453000"
                },
                "owner": "dhomich",
                "id": 917
            }
        ],

        processor : function(urlParts, reqBody, mockedData, status){

            return {
                status : status,
                body   : mockedData[0]
            };
        }
    };

module.exports = scheduler;
