var scheduler = {

        status : 200,
        body   : [
            {
                "status": "UNKNOWN",
                "task": {
                    "priority": {"class": "SERVICE", "subclass": "NORMAL"},
                    "notifications": [],
                    "important": false,
                    "description": "",
                    "owner": "dhomich",
                    "kill_timeout": 3600,
                    "hidden": false,
                    "type": "TEST_TASK",
                    "custom_fields": [{
                        "modifiers": null,
                        "name": "live_time",
                        "context": null,
                        "title": "Time to live",
                        "required": true,
                        "type": "integer",
                        "value": 10
                    }, {
                        "modifiers": null,
                        "name": "break_time",
                        "context": null,
                        "title": "Time to break",
                        "required": false,
                        "type": "integer",
                        "value": 0
                    }, {
                        "modifiers": null,
                        "name": "dependent_resource_id",
                        "context": null,
                        "title": "Dependent resource",
                        "required": false,
                        "type": "resource",
                        "value": 57976068
                    }, {
                        "modifiers": null,
                        "name": "modify_resource",
                        "context": null,
                        "title": "Modify resource",
                        "required": false,
                        "type": "boolean",
                        "value": false
                    }, {
                        "modifiers": null,
                        "name": "wait_time",
                        "context": null,
                        "title": "Wait for timeout",
                        "required": true,
                        "type": "integer",
                        "value": 0
                    }, {
                        "sub_fields": {"true": ["number_of_subtasks"]},
                        "modifiers": null,
                        "name": "create_sub_task",
                        "context": null,
                        "title": "Create subtask",
                        "required": false,
                        "type": "boolean",
                        "value": false
                    }, {
                        "modifiers": null,
                        "name": "number_of_subtasks",
                        "context": null,
                        "title": "Number of subtasks",
                        "required": false,
                        "type": "integer",
                        "value": 1
                    }, {
                        "sub_fields": {"true": ["vault_item_name", "vault_item_owner"]},
                        "modifiers": null,
                        "name": "commit_to_test_data",
                        "context": null,
                        "title": "Make commit to sandbox path in testdata dir",
                        "required": false,
                        "type": "boolean",
                        "value": false
                    }, {
                        "modifiers": null,
                        "name": "vault_item_name",
                        "context": null,
                        "title": "Vault item name",
                        "required": false,
                        "type": "string",
                        "value": ""
                    }, {
                        "modifiers": null,
                        "name": "vault_item_owner",
                        "context": null,
                        "title": "Vault item owner (task author by default)",
                        "required": false,
                        "type": "string",
                        "value": ""
                    }, {
                        "modifiers": null,
                        "name": "create_resources",
                        "context": null,
                        "title": "Create resources",
                        "required": false,
                        "type": "boolean",
                        "value": true
                    }, {
                        "modifiers": null,
                        "name": "check_testdata",
                        "context": null,
                        "title": "Check Testdata",
                        "required": false,
                        "type": "boolean",
                        "value": false
                    }, {
                        "modifiers": null,
                        "name": "test_get_arcadia_url",
                        "context": null,
                        "title": "Path to Arcadia svn",
                        "required": false,
                        "type": "string",
                        "value": ""
                    }, {
                        "modifiers": null,
                        "name": "check_vault",
                        "context": null,
                        "title": "Check vault data",
                        "required": false,
                        "type": "boolean",
                        "value": false
                    }, {
                        "modifiers": null,
                        "name": "raise_exception_on_start",
                        "context": null,
                        "title": "Raise excepton on start",
                        "required": false,
                        "type": "boolean",
                        "value": false
                    }, {
                        "modifiers": null,
                        "name": "go_to_state",
                        "context": null,
                        "title": "Go to state",
                        "required": false,
                        "type": "select",
                        "value": "finished"
                    }, {
                        "modifiers": null,
                        "name": "ping_host_via_skynet",
                        "context": null,
                        "title": "Pass hostnames separated with comma in old style syntax (e.g. sandbox0{1..4}h)",
                        "required": false,
                        "type": "string",
                        "value": ""
                    }, {
                        "modifiers": null,
                        "name": "create_independent_task",
                        "context": null,
                        "title": "Create independent task",
                        "required": false,
                        "type": "boolean",
                        "value": false
                    }],
                    "fail_on_any_error": false
                },
                "rights": "write",
                "url": "https://sandbox.yandex-team.ru/sandbox//api/v1.0/scheduler/911",
                "author": "dhomich",
                "schedule": {"fail_on_error": false, "repetition": null, "retry": {"ignore": true}},
                "time": {"next": "2015-04-30T18:42:31.684247", "created": "2015-04-30T18:42:31.677000"},
                "owner": "dhomich",
                "id": 911
            }
        ],

        processor : function(urlParts, reqBody, mockedData, status){

            return {
                status : status,
                body   : mockedData[0]
            };
        }
    };

module.exports = scheduler;
