import React, { PureComponent } from 'react';
import styled from 'styled-components';

import { YSpin } from 'y-components';

const Wrapper = styled.div`
    position: absolute;
    background: rgba(255,255,255,.7);
    top: 0;
    bottom: 0;
    width:100%;

    > .y-spin {
        left: 50%;
        margin-top: 150px;
        margin-left: -19px;
    }
`;

const Label = styled.div`
    font-size: 22px;
    position: absolute;
    top: 120px;
    left: 50%;
    width: 100px;
    margin-left: -50px;
    -webkit-transform: translateZ(0);
    transform: translateZ(0);
    text-align: center;
    color: #777;
`;

export default class Splash extends PureComponent {
    render() {
        return (
            <Wrapper>
                <Label>Sandbox</Label>
                <YSpin progress size="l"/>
            </Wrapper>
        );
    }
}
